import { KoconutPrimitive, KoconutArray, KoconutSet, KoconutBoolean, KoconutLoopSignal, KoconutComparable } from "../../module.internal";
export declare class KoconutIterable<DataType, CombinedDataType, WrapperType extends Iterable<DataType>, CombinedWrapperType extends Iterable<CombinedDataType>> extends KoconutPrimitive<WrapperType> {
    protected combinedDataWrapper: CombinedWrapperType | null;
    protected mSize: number;
    count(predicate?: ((element: CombinedDataType) => boolean | Promise<boolean>) | null, thisArg?: any): KoconutPrimitive<number>;
    maxBy(selector: (element: CombinedDataType) => number | string | KoconutComparable | Promise<number | string | KoconutComparable>, thisArg?: any): KoconutPrimitive<CombinedDataType>;
    maxByOrNull(selector: (element: CombinedDataType) => number | string | KoconutComparable | Promise<number | string | KoconutComparable>, thisArg?: any): KoconutPrimitive<CombinedDataType | null>;
    maxOf(selector: (element: CombinedDataType) => number | Promise<number>, thisArg: any): KoconutPrimitive<number>;
    maxOf(selector: (element: CombinedDataType) => number | Promise<number>): KoconutPrimitive<number>;
    maxOf(selector: (element: CombinedDataType) => string | Promise<string>, thisArg: any): KoconutPrimitive<string>;
    maxOf(selector: (element: CombinedDataType) => string | Promise<string>): KoconutPrimitive<string>;
    maxOf<ComparableType extends KoconutComparable>(selector: (element: CombinedDataType) => ComparableType | Promise<ComparableType>, thisArg: any): KoconutPrimitive<ComparableType>;
    maxOf<ComparableType extends KoconutComparable>(selector: (element: CombinedDataType) => ComparableType | Promise<ComparableType>): KoconutPrimitive<ComparableType>;
    maxOfOrNull(selector: (element: CombinedDataType) => number | Promise<number>): KoconutPrimitive<number | null>;
    maxOfOrNull(selector: (element: CombinedDataType) => number | Promise<number>, thisArg: any): KoconutPrimitive<number | null>;
    maxOfOrNull(selector: (element: CombinedDataType) => string | Promise<string>): KoconutPrimitive<string | null>;
    maxOfOrNull(selector: (element: CombinedDataType) => string | Promise<string>, thisArg: any): KoconutPrimitive<string | null>;
    maxOfOrNull<ComparableType extends KoconutComparable>(selector: (element: CombinedDataType) => ComparableType | Promise<ComparableType>): KoconutPrimitive<ComparableType | null>;
    maxOfOrNull<ComparableType extends KoconutComparable>(selector: (element: CombinedDataType) => ComparableType | Promise<ComparableType>, thisArg: any): KoconutPrimitive<ComparableType | null>;
    maxOfWith<ResultDataType>(selector: (element: CombinedDataType) => ResultDataType | Promise<ResultDataType>, comparator: (front: ResultDataType, rear: ResultDataType) => number | Promise<number>, selectorThisArg?: any, comparatorThisArg?: any): KoconutPrimitive<ResultDataType>;
    maxOfWithOrNull<ResultDataType>(selector: (element: CombinedDataType) => ResultDataType | Promise<ResultDataType>, comparator: (front: ResultDataType, rear: ResultDataType) => number | Promise<number>, selectorThisArg?: any, comparatorThisArg?: any): KoconutPrimitive<ResultDataType | null>;
    maxWith(comparator: (front: CombinedDataType, rear: CombinedDataType) => number | Promise<number>, thisArg?: any): KoconutPrimitive<CombinedDataType>;
    maxWithOrNull(comparator: (front: CombinedDataType, rear: CombinedDataType) => number | Promise<number>, thisArg?: any): KoconutPrimitive<CombinedDataType | null>;
    minBy(selector: (element: CombinedDataType) => number | string | KoconutComparable | Promise<number | string | KoconutComparable>, thisArg?: any): KoconutPrimitive<CombinedDataType>;
    minByOrNull(selector: (element: CombinedDataType) => number | string | KoconutComparable | Promise<number | string | KoconutComparable>, thisArg?: any): KoconutPrimitive<CombinedDataType | null>;
    minOf(selector: (element: CombinedDataType) => number | Promise<number>, thisArg: any): KoconutPrimitive<number>;
    minOf(selector: (element: CombinedDataType) => number | Promise<number>): KoconutPrimitive<number>;
    minOf(selector: (element: CombinedDataType) => string | Promise<string>, thisArg: any): KoconutPrimitive<string>;
    minOf(selector: (element: CombinedDataType) => string | Promise<string>): KoconutPrimitive<string>;
    minOf<ComparableType extends KoconutComparable>(selector: (element: CombinedDataType) => ComparableType | Promise<ComparableType>, thisArg: any): KoconutPrimitive<ComparableType>;
    minOf<ComparableType extends KoconutComparable>(selector: (element: CombinedDataType) => ComparableType | Promise<ComparableType>): KoconutPrimitive<ComparableType>;
    minOfOrNull(selector: (element: CombinedDataType) => number | Promise<number>, thisArg: any): KoconutPrimitive<number | null>;
    minOfOrNull(selector: (element: CombinedDataType) => number | Promise<number>): KoconutPrimitive<number | null>;
    minOfOrNull(selector: (element: CombinedDataType) => string | Promise<string>, thisArg: any): KoconutPrimitive<string | null>;
    minOfOrNull(selector: (element: CombinedDataType) => string | Promise<string>): KoconutPrimitive<string | null>;
    minOfOrNull<ComparableType extends KoconutComparable>(selector: (element: CombinedDataType) => ComparableType | Promise<ComparableType>, thisArg: any): KoconutPrimitive<ComparableType | null>;
    minOfOrNull<ComparableType extends KoconutComparable>(selector: (element: CombinedDataType) => ComparableType | Promise<ComparableType>): KoconutPrimitive<ComparableType>;
    minOfWith<ResultDataType>(selector: (element: CombinedDataType) => ResultDataType | Promise<ResultDataType>, comparator: (front: ResultDataType, rear: ResultDataType) => number | Promise<number>, selectorThisArg?: any, comparatorThisArg?: any): KoconutPrimitive<ResultDataType>;
    minOfWithOrNull<ResultDataType>(selector: (element: CombinedDataType) => ResultDataType | Promise<ResultDataType>, comparator: (front: ResultDataType, rear: ResultDataType) => number | Promise<number>, selectorThisArg?: any, comparatorThisArg?: any): KoconutPrimitive<ResultDataType | null>;
    minWith(comparator: (front: CombinedDataType, rear: CombinedDataType) => number | Promise<number>, thisArg?: any): KoconutPrimitive<CombinedDataType>;
    minWithOrNull(comparator: (front: CombinedDataType, rear: CombinedDataType) => number | Promise<number>, thisArg?: any): KoconutPrimitive<CombinedDataType | null>;
    asArray(): KoconutArray<CombinedDataType>;
    asSet(): KoconutSet<CombinedDataType>;
    all(predicate: (element: CombinedDataType) => boolean | Promise<boolean>, thisArg?: any): KoconutBoolean;
    any(predicate: (element: CombinedDataType) => boolean | Promise<boolean>, thisArg?: any): KoconutBoolean;
    isEmpty(): KoconutBoolean;
    isNotEmpty(): KoconutBoolean;
    isNullOrEmpty(): KoconutBoolean;
    none(predicate?: ((element: CombinedDataType) => boolean | Promise<boolean>) | null, thisArg?: any): KoconutBoolean;
    forEach(action: (element: CombinedDataType) => boolean | KoconutLoopSignal | void | Promise<boolean | KoconutLoopSignal | void>, thisArg?: any): KoconutPrimitive<void>;
    onEach(action: (element: CombinedDataType) => boolean | KoconutLoopSignal | void | Promise<boolean | KoconutLoopSignal | void>, thisArg?: any): KoconutIterable<DataType, CombinedDataType, WrapperType, CombinedWrapperType>;
    filter(predicate: (element: CombinedDataType) => boolean | Promise<boolean>, thisArg?: any): KoconutIterable<DataType, CombinedDataType, WrapperType, CombinedWrapperType>;
    filterNot(predicate: (element: CombinedDataType) => boolean | Promise<boolean>, thisArg?: any): KoconutIterable<DataType, CombinedDataType, WrapperType, CombinedWrapperType>;
    flatMap<ResultDataType>(transform: (element: CombinedDataType) => Iterable<ResultDataType> | Promise<Iterable<ResultDataType>>, thisArg?: any): KoconutArray<ResultDataType>;
    flatMapTo<ResultDataType>(destination: Array<ResultDataType> | Set<ResultDataType>, transform: (element: CombinedDataType) => Iterable<ResultDataType> | Promise<Iterable<ResultDataType>>, thisArg?: any): KoconutIterable<DataType, CombinedDataType, WrapperType, CombinedWrapperType>;
    map<ResultDataType>(transform: (element: CombinedDataType) => ResultDataType | Promise<ResultDataType>, thisArg?: any): KoconutArray<ResultDataType>;
    mapTo<ResultDataType>(destination: Array<ResultDataType> | Set<ResultDataType>, transform: (element: CombinedDataType) => ResultDataType | Promise<ResultDataType>, thisArg?: any): KoconutIterable<DataType, CombinedDataType, WrapperType, CombinedWrapperType>;
    mapNotNull<ResultDataType>(transform: (element: CombinedDataType) => ResultDataType | void | null | undefined | Promise<ResultDataType | void | null | undefined>, thisArg?: any): KoconutArray<ResultDataType>;
    mapNotNullTo<ResultDataType>(destination: Array<ResultDataType> | Set<ResultDataType>, transform: (element: CombinedDataType) => ResultDataType | void | null | undefined | Promise<ResultDataType | void | null | undefined>, thisArg?: any): KoconutIterable<DataType, CombinedDataType, WrapperType, CombinedWrapperType>;
}
