"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.KoconutIterable = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _module = require("../../module.internal");

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var KoconutIterable = /*#__PURE__*/function (_KoconutPrimitive) {
  (0, _inherits2["default"])(KoconutIterable, _KoconutPrimitive);

  var _super = _createSuper(KoconutIterable);

  function KoconutIterable() {
    var _this;

    (0, _classCallCheck2["default"])(this, KoconutIterable);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "combinedDataWrapper", null);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "mSize", 0);
    return _this;
  }

  (0, _createClass2["default"])(KoconutIterable, [{
    key: "count",
    // Calculator

    /**
     * Returns the number of the elements matching the given ```predicate```. If the ```predicate``` is ommitted it'll returns the whole number of elements. 
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Calculator
     * 
     * @example
     * ``` typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const numberOfAllArrayElements = await koconutArray
     *                                       .count()
     *                                       .yield()
     * console.log(numberOfAllArrayElements)
     * // ↑ 5
     *
     * const numberOfArrayElementsHigherThan2 = await koconutArray
     *                                           .count(eachNumber => eachNumber > 2)
     *                                           .yield()
     * console.log(numberOfArrayElementsHigherThan2)
     * // ↑ 3 -- i.e. [3, 4, 5]
     * 
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const numberOfAllSetElements = await koconutSet
     *                                       .count()
     *                                       .yield()
     * console.log(numberOfAllSetElements)
     * // ↑ 5
     *
     * const numberOfOddSetElements = await koconutSet
     *                                       .count(eachNumber => eachNumber % 2 == 1)
     *                                       .yield()
     * console.log(numberOfOddSetElements)
     * // ↑ 3 -- i.e. [1, 3, 5]
     * 
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of(1,2,3)
     *                   .associateWith(eachNumber => eachNumber * 2)
     *                   // ↑ Map { 1 => 2, 
     *                   //         2 => 4, 
     *                   //         3 => 6 }
     *
     * const numberOfAllMapEntries = await koconutMap
     *                                   .count()
     *                                   .yield()
     * console.log(numberOfAllMapEntries)
     * // ↑ 3
     *
     * const numberOfMapEntriesValueHigherThan5 = await koconutMap
     *                                               .count(eachEntry => eachEntry.value > 5)
     *                                               .yield()
     * console.log(numberOfMapEntriesValueHigherThan5)
     * // ↑ 1 -- i.e. Entry { 3, 6 }
     * 
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(1,2,3,4,5)
     *
     * const numberOfArrayElementsLessThan3 = await koconutArray2
     *                                       .count(async eachNumber => eachNumber < 3)
     *                                       .yield()
     * console.log(numberOfArrayElementsLessThan3)
     * // ↑ 2 -- i.e. [1, 2]
     *
     * const numberOfEvenArrayElements = await koconutArray2
     *                                   .count(eachNumber => new Promise(resolve => {
     *                                       resolve(eachNumber % 2 == 0)
     *                                   }))
     *                                   .yield()
     * console.log(numberOfEvenArrayElements)
     * // ↑ 2 -- i.e. [2, 4]
     * ```
     */
    value: function count() {
      var _this2 = this;

      var predicate = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      if (predicate) predicate.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var count, _iterator, _step, eachCombinedDatum;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(_this2.combinedDataWrapper == null)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return", 0);

              case 2:
                count = 0;
                _iterator = _createForOfIteratorHelper(_this2.combinedDataWrapper);
                _context.prev = 4;

                _iterator.s();

              case 6:
                if ((_step = _iterator.n()).done) {
                  _context.next = 18;
                  break;
                }

                eachCombinedDatum = _step.value;

                if (predicate) {
                  _context.next = 12;
                  break;
                }

                count++;
                _context.next = 16;
                break;

              case 12:
                _context.next = 14;
                return predicate(eachCombinedDatum);

              case 14:
                if (!_context.sent) {
                  _context.next = 16;
                  break;
                }

                count++;

              case 16:
                _context.next = 6;
                break;

              case 18:
                _context.next = 23;
                break;

              case 20:
                _context.prev = 20;
                _context.t0 = _context["catch"](4);

                _iterator.e(_context.t0);

              case 23:
                _context.prev = 23;

                _iterator.f();

                return _context.finish(23);

              case 26:
                return _context.abrupt("return", count);

              case 27:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[4, 20, 23, 26]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the first element yielding the largest value of the given function or 
     * throws {@link KoconutNoSuchElementException} if there are no elements.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @throws {@link KoconutNoSuchElementException}
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * @deprecated Use {@link maxByOrNull} instead.
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const largestNumberOfArray = await koconutArray
     *                               .maxBy(eachNumber => eachNumber)
     *                               .yield()
     * console.log(largestNumberOfArray)
     * // ↑ 5
     *
     * try {
     *   await koconutArray
     *           .filter(eachNumber => eachNumber > 10)
     *           .maxBy(eachNumber => eachNumber)
     *           .yield()
     * } catch(error) {
     *   console.log(error.name)
     *   // ↑ Koconut No Such Element Exception
     *   // i.e. -- Array is filtered.
     *   // No element in 1 to 5 is greater than 10.
     * }
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc")
     *
     * const lognestStringOfSet = await koconutSet
     *                               .maxBy(eachString => eachString.length)
     *                               .yield()
     * console.log(lognestStringOfSet)
     * // ↑ abc
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of(1, 12, 123)
     *                   .associateWith(eachNumber => eachNumber.toString())
     *
     * const longestDigitsEntryOfMap = await koconutMap
     *                                       .maxBy(eachEntry => eachEntry.value.length)
     *                                       .yield()
     * console.log(longestDigitsEntryOfMap)
     * // ↑ Entry { keyElement: 123, valueElement: '123' }
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(19,27,32)
     *
     * const largestNumberOfArray2 = await koconutArray2
     *                                   .maxBy(async eachNumber => eachNumber)
     *                                   .yield()
     * console.log(largestNumberOfArray2)
     * // ↑ 32
     *
     * const largest1sDigitNumberOfArray2 = await koconutArray2
     *                                       .maxBy(eachNumber => new Promise(resolve => {
     *                                           resolve(eachNumber % 10)
     *                                       }))
     *                                       .yield()
     * console.log(largest1sDigitNumberOfArray2)
     * // ↑ 19
     * ```
     */

  }, {
    key: "maxBy",
    value: function maxBy(selector) {
      var _this3 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _module.KoconutDeprecation.showDeprecationWarning("1.2.0", this.maxByOrNull);

      selector = selector.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        var dataToReturn, lastComparableDatum, _iterator2, _step2, eachCombinedDatum, eachComparableDatum, shouldBeChanged, eachCompareResult, numberResult;

        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(_this3.combinedDataWrapper == null)) {
                  _context2.next = 2;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is null");

              case 2:
                dataToReturn = null;
                lastComparableDatum = null;
                _iterator2 = _createForOfIteratorHelper(_this3.combinedDataWrapper);
                _context2.prev = 5;

                _iterator2.s();

              case 7:
                if ((_step2 = _iterator2.n()).done) {
                  _context2.next = 31;
                  break;
                }

                eachCombinedDatum = _step2.value;
                _context2.next = 11;
                return selector(eachCombinedDatum);

              case 11:
                eachComparableDatum = _context2.sent;
                shouldBeChanged = lastComparableDatum == null;

                if (shouldBeChanged) {
                  _context2.next = 28;
                  break;
                }

                if (!_module.KoconutTypeChecker.checkIsComparable(eachComparableDatum)) {
                  _context2.next = 27;
                  break;
                }

                eachCompareResult = eachComparableDatum.compareTo(lastComparableDatum);
                numberResult = 0;

                if (!(eachCompareResult instanceof _module.KoconutPrimitive)) {
                  _context2.next = 23;
                  break;
                }

                _context2.next = 20;
                return eachCompareResult["yield"]();

              case 20:
                numberResult = _context2.sent;
                _context2.next = 24;
                break;

              case 23:
                numberResult = eachCompareResult;

              case 24:
                if (numberResult > 0) shouldBeChanged = true;
                _context2.next = 28;
                break;

              case 27:
                shouldBeChanged = lastComparableDatum < eachComparableDatum;

              case 28:
                if (shouldBeChanged) {
                  dataToReturn = eachCombinedDatum;
                  lastComparableDatum = eachComparableDatum;
                }

              case 29:
                _context2.next = 7;
                break;

              case 31:
                _context2.next = 36;
                break;

              case 33:
                _context2.prev = 33;
                _context2.t0 = _context2["catch"](5);

                _iterator2.e(_context2.t0);

              case 36:
                _context2.prev = 36;

                _iterator2.f();

                return _context2.finish(36);

              case 39:
                if (!(dataToReturn == null)) {
                  _context2.next = 41;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is empty");

              case 41:
                return _context2.abrupt("return", dataToReturn);

              case 42:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, null, [[5, 33, 36, 39]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the first element yielding the largest value of the given function or null if there are no elements.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const largestNumberOfArray = await koconutArray
     *                               .maxByOrNull(eachNumber => eachNumber)
     *                               .yield()
     * console.log(largestNumberOfArray)
     * // ↑ 5
     *
     * 
     * const largestNumberOfEmptyArray = await koconutArray
     *                                 .filter(eachNumber => eachNumber > 10)
     *                                 .maxByOrNull(eachNumber => eachNumber)
     *                                 .yield()
     * console.log(largestNumberOfEmptyArray)
     * // ↑ null
     * 
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc")
     *
     * const lognestStringOfSet = await koconutSet
     *                               .maxByOrNull(eachString => eachString.length)
     *                               .yield()
     * console.log(lognestStringOfSet)
     * // ↑ abc
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of(1, 12, 123)
     *                   .associateWith(eachNumber => eachNumber.toString())
     *
     * const longestDigitsEntryOfMap = await koconutMap
     *                                       .maxByOrNull(eachEntry => eachEntry.value.length)
     *                                       .yield()
     * console.log(longestDigitsEntryOfMap)
     * // ↑ Entry { keyElement: 123, valueElement: '123' }
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(19,27,32)
     *
     * const largestNumberOfArray2 = await koconutArray2
     *                                   .maxByOrNull(async eachNumber => eachNumber)
     *                                   .yield()
     * console.log(largestNumberOfArray2)
     * // ↑ 32
     *
     * const largest1sDigitNumberOfArray2 = await koconutArray2
     *                                       .maxByOrNull(eachNumber => new Promise(resolve => {
     *                                           resolve(eachNumber % 10)
     *                                       }))
     *                                       .yield()
     * console.log(largest1sDigitNumberOfArray2)
     * // ↑ 19
     * ```
     */

  }, {
    key: "maxByOrNull",
    value: function maxByOrNull(selector) {
      var _this4 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      selector = selector.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
        var dataToReturn, lastComparableDatum, _iterator3, _step3, eachCombinedDatum, eachComparableDatum, shouldBeChanged, eachCompareResult, numberResult;

        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!(_this4.combinedDataWrapper == null)) {
                  _context3.next = 2;
                  break;
                }

                return _context3.abrupt("return", null);

              case 2:
                dataToReturn = null;
                lastComparableDatum = null;
                _iterator3 = _createForOfIteratorHelper(_this4.combinedDataWrapper);
                _context3.prev = 5;

                _iterator3.s();

              case 7:
                if ((_step3 = _iterator3.n()).done) {
                  _context3.next = 31;
                  break;
                }

                eachCombinedDatum = _step3.value;
                _context3.next = 11;
                return selector(eachCombinedDatum);

              case 11:
                eachComparableDatum = _context3.sent;
                shouldBeChanged = lastComparableDatum == null;

                if (shouldBeChanged) {
                  _context3.next = 28;
                  break;
                }

                if (!_module.KoconutTypeChecker.checkIsComparable(eachComparableDatum)) {
                  _context3.next = 27;
                  break;
                }

                eachCompareResult = eachComparableDatum.compareTo(lastComparableDatum);
                numberResult = 0;

                if (!(eachCompareResult instanceof _module.KoconutPrimitive)) {
                  _context3.next = 23;
                  break;
                }

                _context3.next = 20;
                return eachCompareResult["yield"]();

              case 20:
                numberResult = _context3.sent;
                _context3.next = 24;
                break;

              case 23:
                numberResult = eachCompareResult;

              case 24:
                if (numberResult > 0) shouldBeChanged = true;
                _context3.next = 28;
                break;

              case 27:
                shouldBeChanged = lastComparableDatum < eachComparableDatum;

              case 28:
                if (shouldBeChanged) {
                  dataToReturn = eachCombinedDatum;
                  lastComparableDatum = eachComparableDatum;
                }

              case 29:
                _context3.next = 7;
                break;

              case 31:
                _context3.next = 36;
                break;

              case 33:
                _context3.prev = 33;
                _context3.t0 = _context3["catch"](5);

                _iterator3.e(_context3.t0);

              case 36:
                _context3.prev = 36;

                _iterator3.f();

                return _context3.finish(36);

              case 39:
                return _context3.abrupt("return", dataToReturn);

              case 40:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, null, [[5, 33, 36, 39]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the largest value among all values produced by ```selector``` function applied to each element in the collection or 
     * throws {@link KoconutNoSuchElementException} if there are no elements.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @throws {@link KoconutNoSuchElementException}
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,7,9)
     *
     * const largestRemainderNumberDividedBy5OfArray = await koconutArray
     *                                               .maxOf(eachNumber => eachNumber % 5)
     *                                               .yield()
     * console.log(largestRemainderNumberDividedBy5OfArray)
     * // ↑ 4
     *
     * try {
     *   await koconutArray
     *           .filter(eachNumber => eachNumber > 10)
     *           .maxOf(eachNumber => eachNumber % 5)
     *           .yield()
     * } catch(error) {
     *   console.log(error.name)
     *   // ↑ Koconut No Such Element Exception
     *   // i.e. -- Array is filtered.
     *   // No element in 1 to 5 is greater than 10.
     * }
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc")
     *
     * const longestStringLengthOfSet = await koconutSet
     *                               .maxOf(eachString => eachString.length)
     *                               .yield()
     * console.log(longestStringLengthOfSet)
     * // ↑ 3
     *
     * class ComparableString implements KoconutComparable{
     *   str : string
     *   constructor(str : string) {
     *       this.str = str
     *   }
     *   // Override
     *   compareTo(other : ComparableString) : number {
     *       return this.str.length - other.str.length
     *   }
     * }
     * const maxComparableString = await koconutSet
     *                           .maxOf(eachString => new ComparableString(eachString))
     *                           .yield()
     * console.log(maxComparableString)
     * // ↑ ComparableString { str: 'abc' }
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of("a", "ab", "abc")
     *                   .associate(eachString => [eachString.length, eachString])
     *
     * const longestStringLengthOfMap = await koconutMap
     *                                   .maxOf(eachEntry => eachEntry.key)
     *                                   .yield()
     * console.log(longestStringLengthOfMap)
     * // ↑ 3
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(12,51,32,45,50)
     *
     * const largestNumberOfArray2 = await koconutArray2
     *                           .maxOf(async eachNumber => eachNumber)
     *                           .yield()
     * console.log(largestNumberOfArray2)
     * // ↑ 51
     *
     * const largest1sDigitOfArray2 = await koconutArray2
     *                           .maxOf(eachNumber => new Promise(resolve => {
     *                               resolve(eachNumber % 10)
     *                           }))
     *                           .yield()
     * console.log(largest1sDigitOfArray2)
     * // ↑ 5
     * ```
     */

  }, {
    key: "maxOf",
    value: function maxOf(selector) {
      var _this5 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      selector = selector.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
        var lastComparableDatumToReturn, _iterator4, _step4, eachCombinedDatum, eachComparableDatum, shouldBeChanged, eachCompareResult, numberResult;

        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (!(_this5.combinedDataWrapper == null)) {
                  _context4.next = 2;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is null");

              case 2:
                lastComparableDatumToReturn = null;
                _iterator4 = _createForOfIteratorHelper(_this5.combinedDataWrapper);
                _context4.prev = 4;

                _iterator4.s();

              case 6:
                if ((_step4 = _iterator4.n()).done) {
                  _context4.next = 30;
                  break;
                }

                eachCombinedDatum = _step4.value;
                _context4.next = 10;
                return selector(eachCombinedDatum);

              case 10:
                eachComparableDatum = _context4.sent;
                shouldBeChanged = lastComparableDatumToReturn == null;

                if (shouldBeChanged) {
                  _context4.next = 27;
                  break;
                }

                if (!_module.KoconutTypeChecker.checkIsComparable(eachComparableDatum)) {
                  _context4.next = 26;
                  break;
                }

                eachCompareResult = eachComparableDatum.compareTo(lastComparableDatumToReturn);
                numberResult = 0;

                if (!(eachCompareResult instanceof _module.KoconutPrimitive)) {
                  _context4.next = 22;
                  break;
                }

                _context4.next = 19;
                return eachCompareResult["yield"]();

              case 19:
                numberResult = _context4.sent;
                _context4.next = 23;
                break;

              case 22:
                numberResult = eachCompareResult;

              case 23:
                if (numberResult > 0) shouldBeChanged = true;
                _context4.next = 27;
                break;

              case 26:
                shouldBeChanged = lastComparableDatumToReturn < eachComparableDatum;

              case 27:
                if (shouldBeChanged) lastComparableDatumToReturn = eachComparableDatum;

              case 28:
                _context4.next = 6;
                break;

              case 30:
                _context4.next = 35;
                break;

              case 32:
                _context4.prev = 32;
                _context4.t0 = _context4["catch"](4);

                _iterator4.e(_context4.t0);

              case 35:
                _context4.prev = 35;

                _iterator4.f();

                return _context4.finish(35);

              case 38:
                if (!(lastComparableDatumToReturn == null)) {
                  _context4.next = 40;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is empty");

              case 40:
                return _context4.abrupt("return", lastComparableDatumToReturn);

              case 41:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, null, [[4, 32, 35, 38]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the largest value among all values produced by ```selector``` function applied to each element in the collection or 
     * null if there are no elements.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,7,9)
     *
     * const largestRemainderNumberDividedBy5OfArray = await koconutArray
     *                                               .maxOfOrNull(eachNumber => eachNumber % 5)
     *                                               .yield()
     * console.log(largestRemainderNumberDividedBy5OfArray)
     * // ↑ 4
     * 
     * const largestRemainderNumberDividedBy5OfEmptyArray = await koconutArray
     *                                       .filter(eachNumber => eachNumber > 10)
     *                                       .maxOfOrNull(eachNumber => eachNumber % 5)
     *                                       .yield()
     * console.log(largestRemainderNumberDividedBy5OfEmptyArray)
     * // ↑ null
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc")
     *
     * const longestStringLengthOfSet = await koconutSet
     *                               .maxOfOrNull(eachString => eachString.length)
     *                               .yield()
     * console.log(longestStringLengthOfSet)
     * // ↑ 3
     *
     * class ComparableString implements KoconutComparable{
     *   str : string
     *   constructor(str : string) {
     *       this.str = str
     *   }
     *   // Override
     *   compareTo(other : ComparableString) : number {
     *       return this.str.length - other.str.length
     *   }
     * }
     * const maxComparableString = await koconutSet
     *                           .maxOfOrNull(eachString => new ComparableString(eachString))
     *                           .yield()
     * console.log(maxComparableString)
     * // ↑ ComparableString { str: 'abc' }
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of("a", "ab", "abc")
     *                   .associate(eachString => [eachString.length, eachString])
     *
     * const longestStringLengthOfMap = await koconutMap
     *                                   .maxOfOrNull(eachEntry => eachEntry.key)
     *                                   .yield()
     * console.log(longestStringLengthOfMap)
     * // ↑ 3
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(12,51,32,45,50)
     *
     * const largestNumberOfArray2 = await koconutArray2
     *                           .maxOfOrNull(async eachNumber => eachNumber)
     *                           .yield()
     * console.log(largestNumberOfArray2)
     * // ↑ 51
     *
     * const largest1sDigitOfArray2 = await koconutArray2
     *                           .maxOfOrNull(eachNumber => new Promise(resolve => {
     *                               resolve(eachNumber % 10)
     *                           }))
     *                           .yield()
     * console.log(largest1sDigitOfArray2)
     * // ↑ 5
     * ```
     */

  }, {
    key: "maxOfOrNull",
    value: function maxOfOrNull(selector) {
      var _this6 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      selector = selector.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
        var lastComparableDatumToReturn, _iterator5, _step5, eachCombinedDatum, eachComparableDatum, shouldBeChanged, eachCompareResult, numberResult;

        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (!(_this6.combinedDataWrapper == null)) {
                  _context5.next = 2;
                  break;
                }

                return _context5.abrupt("return", null);

              case 2:
                lastComparableDatumToReturn = null;
                _iterator5 = _createForOfIteratorHelper(_this6.combinedDataWrapper);
                _context5.prev = 4;

                _iterator5.s();

              case 6:
                if ((_step5 = _iterator5.n()).done) {
                  _context5.next = 30;
                  break;
                }

                eachCombinedDatum = _step5.value;
                _context5.next = 10;
                return selector(eachCombinedDatum);

              case 10:
                eachComparableDatum = _context5.sent;
                shouldBeChanged = lastComparableDatumToReturn == null;

                if (shouldBeChanged) {
                  _context5.next = 27;
                  break;
                }

                if (!_module.KoconutTypeChecker.checkIsComparable(eachComparableDatum)) {
                  _context5.next = 26;
                  break;
                }

                eachCompareResult = eachComparableDatum.compareTo(lastComparableDatumToReturn);
                numberResult = 0;

                if (!(eachCompareResult instanceof _module.KoconutPrimitive)) {
                  _context5.next = 22;
                  break;
                }

                _context5.next = 19;
                return eachCompareResult["yield"]();

              case 19:
                numberResult = _context5.sent;
                _context5.next = 23;
                break;

              case 22:
                numberResult = eachCompareResult;

              case 23:
                if (numberResult > 0) shouldBeChanged = true;
                _context5.next = 27;
                break;

              case 26:
                shouldBeChanged = lastComparableDatumToReturn < eachComparableDatum;

              case 27:
                if (shouldBeChanged) lastComparableDatumToReturn = eachComparableDatum;

              case 28:
                _context5.next = 6;
                break;

              case 30:
                _context5.next = 35;
                break;

              case 32:
                _context5.prev = 32;
                _context5.t0 = _context5["catch"](4);

                _iterator5.e(_context5.t0);

              case 35:
                _context5.prev = 35;

                _iterator5.f();

                return _context5.finish(35);

              case 38:
                return _context5.abrupt("return", lastComparableDatumToReturn);

              case 39:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, null, [[4, 32, 35, 38]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the largest value according to the provided ```comparator``` among all values
     * produced by ```selector``` function applied to each element in the collection all throws {@link KoconutNoSuchElementException}
     * if elements are empty.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param comparator A callback function that accepts two arguements. The method calls the ```comparator``` to compare two selected values.
     * In case the result is larger than 0, front is bigger than rear, and if it's less than 0 judge vice versa.
     * @param selectorThisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * @param comparatorThisArg An object to which the ```this``` keyword can refer in the ```comparator```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @throws {@link KoconutNoSuchElementException}
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of("1", "2", "3", "4", "5")
     *
     * const largestNumberedStringOfArray = await koconutArray
     *                                   .maxOfWith(
     *                                       parseInt,
     *                                       (front, rear) => front - rear
     *                                   )
     *                                   .yield()
     * console.log(largestNumberedStringOfArray)
     * // ↑ 5
     *
     * try {
     *   await koconutArray
     *           .filter(eachString => eachString.length > 2)
     *           .maxOfWith(
     *               parseInt,
     *               (front, rear) => front - rear
     *           )
     *           .yield()
     * } catch(error) {
     *   console.log(error.name)
     *   // ↑ Koconut No Such Element Exception
     *   // i.e. -- Array is filtered.
     *   // No string in "1" to "5" is logner than 2. 
     * }
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc")
     *
     * const lognestStringLengthOfSet = await koconutSet
     *                               .maxOfWith(
     *                                   eachString => eachString.length,
     *                                   (front, rear) => front - rear
     *                               )
     *                               .yield()
     * console.log(lognestStringLengthOfSet)
     * // ↑ 3
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of("a", "ab", "abc")
     *                   .associate(eachString => [eachString.length, eachString])
     *
     * const longestStringLengthOfMap = await koconutMap
     *                                   .maxOfWith(
     *                                       eachEntry => eachEntry.key,
     *                                       (front, rear) => front - rear
     *                                   )
     *                                   .yield()
     * console.log(longestStringLengthOfMap)
     * // ↑ 3
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(12,51,32,45,50)
     *
     * const largestNumberOfArray2 = await koconutArray2
     *                               .maxOfWith(
     *                                   async eachNumber => eachNumber,
     *                                   async (front, rear) => front - rear
     *                               )
     *                               .yield()
     * console.log(largestNumberOfArray2)
     * // ↑ 51
     *
     * const largest1sDigitOfArray2 = await koconutArray2
     *                               .maxOfWith(
     *                                   (eachNumber) => new Promise<number>(resolve => {
     *                                       resolve(eachNumber % 10)
     *                                   }),
     *                                   (front, rear) => new Promise(resolve => {
     *                                       resolve(front - rear)
     *                                   })
     *                               )
     *                               .yield()
     * console.log(largest1sDigitOfArray2)
     * // ↑ 5
     * ```
     */

  }, {
    key: "maxOfWith",
    value: function maxOfWith(selector, comparator) {
      var _this7 = this;

      var selectorThisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var comparatorThisArg = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      selector = selector.bind(selectorThisArg);
      comparator = comparator.bind(comparatorThisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
        var lastComparableDatumToReturn, _iterator6, _step6, eachCombinedDatum, eachComparableDatum;

        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                if (!(_this7.combinedDataWrapper == null)) {
                  _context6.next = 2;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is null");

              case 2:
                lastComparableDatumToReturn = null;
                _iterator6 = _createForOfIteratorHelper(_this7.combinedDataWrapper);
                _context6.prev = 4;

                _iterator6.s();

              case 6:
                if ((_step6 = _iterator6.n()).done) {
                  _context6.next = 21;
                  break;
                }

                eachCombinedDatum = _step6.value;
                _context6.next = 10;
                return selector(eachCombinedDatum);

              case 10:
                eachComparableDatum = _context6.sent;
                _context6.t0 = lastComparableDatumToReturn == null;

                if (_context6.t0) {
                  _context6.next = 17;
                  break;
                }

                _context6.next = 15;
                return comparator(lastComparableDatumToReturn, eachComparableDatum);

              case 15:
                _context6.t1 = _context6.sent;
                _context6.t0 = _context6.t1 < 0;

              case 17:
                if (!_context6.t0) {
                  _context6.next = 19;
                  break;
                }

                lastComparableDatumToReturn = eachComparableDatum;

              case 19:
                _context6.next = 6;
                break;

              case 21:
                _context6.next = 26;
                break;

              case 23:
                _context6.prev = 23;
                _context6.t2 = _context6["catch"](4);

                _iterator6.e(_context6.t2);

              case 26:
                _context6.prev = 26;

                _iterator6.f();

                return _context6.finish(26);

              case 29:
                if (!(lastComparableDatumToReturn == null)) {
                  _context6.next = 31;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is empty");

              case 31:
                return _context6.abrupt("return", lastComparableDatumToReturn);

              case 32:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, null, [[4, 23, 26, 29]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the largest value according to the provided ```comparator``` among all values
     * produced by ```selector``` function applied to each element in the collection or ```null```
     * if elements are empty.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param comparator A callback function that accepts two arguements. The method calls the ```comparator``` to compare two selected values.
     * In case the result is larger than 0, front is bigger than rear, and if it's less than 0 judge vice versa.
     * @param selectorThisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * @param comparatorThisArg An object to which the ```this``` keyword can refer in the ```comparator```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of("1", "2", "3", "4", "5")
     *
     * const largestNumberedStringOfArray = await koconutArray
     *                                   .maxOfWithOrNull(
     *                                       parseInt,
     *                                       (front, rear) => front - rear
     *                                   )
     *                                   .yield()
     * console.log(largestNumberedStringOfArray)
     * // ↑ 5
     *
     * const largestNumberedStringOfEmptyArray = await koconutArray
     *                           .filter(eachString => eachString.length > 2)
     *                           .maxOfWithOrNull(
     *                               parseInt,
     *                               (front, rear) => front - rear
     *                           )
     *                           .yield()
     * console.log(largestNumberedStringOfEmptyArray)
     * // ↑ null
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc")
     *
     * const lognestStringLengthOfSet = await koconutSet
     *                               .maxOfWithOrNull(
     *                                   eachString => eachString.length,
     *                                   (front, rear) => front - rear
     *                               )
     *                               .yield()
     * console.log(lognestStringLengthOfSet)
     * // ↑ 3
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of("a", "ab", "abc")
     *                   .associate(eachString => [eachString.length, eachString])
     *
     * const longestStringLengthOfMap = await koconutMap
     *                                   .maxOfWithOrNull(
     *                                       eachEntry => eachEntry.key,
     *                                       (front, rear) => front - rear
     *                                   )
     *                                   .yield()
     * console.log(longestStringLengthOfMap)
     * // ↑ 3
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(12,51,32,45,50)
     *
     * const largestNumberOfArray2 = await koconutArray2
     *                               .maxOfWithOrNull(
     *                                   async eachNumber => eachNumber,
     *                                   async (front, rear) => front - rear
     *                               )
     *                               .yield()
     * console.log(largestNumberOfArray2)
     * // ↑ 51
     *
     * const largest1sDigitOfArray2 = await koconutArray2
     *                               .maxOfWithOrNull(
     *                                   (eachNumber) => new Promise<number>(resolve => {
     *                                       resolve(eachNumber % 10)
     *                                   }),
     *                                   (front, rear) => new Promise(resolve => {
     *                                       resolve(front - rear)
     *                                   })
     *                               )
     *                               .yield()
     * console.log(largest1sDigitOfArray2)
     * // ↑ 5
     * ```
     */

  }, {
    key: "maxOfWithOrNull",
    value: function maxOfWithOrNull(selector, comparator) {
      var _this8 = this;

      var selectorThisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var comparatorThisArg = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      selector = selector.bind(selectorThisArg);
      comparator = comparator.bind(comparatorThisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7() {
        var lastComparableDatumToReturn, _iterator7, _step7, eachCombinedDatum, eachComparableDatum;

        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                if (!(_this8.combinedDataWrapper == null)) {
                  _context7.next = 2;
                  break;
                }

                return _context7.abrupt("return", null);

              case 2:
                lastComparableDatumToReturn = null;
                _iterator7 = _createForOfIteratorHelper(_this8.combinedDataWrapper);
                _context7.prev = 4;

                _iterator7.s();

              case 6:
                if ((_step7 = _iterator7.n()).done) {
                  _context7.next = 21;
                  break;
                }

                eachCombinedDatum = _step7.value;
                _context7.next = 10;
                return selector(eachCombinedDatum);

              case 10:
                eachComparableDatum = _context7.sent;
                _context7.t0 = lastComparableDatumToReturn == null;

                if (_context7.t0) {
                  _context7.next = 17;
                  break;
                }

                _context7.next = 15;
                return comparator(lastComparableDatumToReturn, eachComparableDatum);

              case 15:
                _context7.t1 = _context7.sent;
                _context7.t0 = _context7.t1 < 0;

              case 17:
                if (!_context7.t0) {
                  _context7.next = 19;
                  break;
                }

                lastComparableDatumToReturn = eachComparableDatum;

              case 19:
                _context7.next = 6;
                break;

              case 21:
                _context7.next = 26;
                break;

              case 23:
                _context7.prev = 23;
                _context7.t2 = _context7["catch"](4);

                _iterator7.e(_context7.t2);

              case 26:
                _context7.prev = 26;

                _iterator7.f();

                return _context7.finish(26);

              case 29:
                return _context7.abrupt("return", lastComparableDatumToReturn);

              case 30:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, null, [[4, 23, 26, 29]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the first element having the largest value according to the provided ```comparator``` or throws {@link KoconutNoSuchElementException}
     * if elements are empty.
     * @param comparator A callback function that accepts two arguements. The method calls the ```comparator``` to compare two selected values.
     * In case the result is larger than 0, front is bigger than rear, and if it's less than 0 judge vice versa.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```comparator```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @throws {@link KoconutNoSuchElementException}
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const largestNumberOfArray = await koconutArray
     *                                   .maxWith((front, rear) => front - rear)
     *                                   .yield()
     * console.log(largestNumberOfArray)
     * // ↑ 5
     *
     * try {
     *   await koconutArray
     *           .filter(eachNumber => eachNumber > 10)
     *           .maxWith((front, rear) => front - rear)
     *           .yield()
     * } catch(error) {
     *   console.log(error.name)
     *   // ↑ Koconut No Such Element Exception
     *   // i.e. -- Array is filtered.
     *   // No element in 1 to 5 is greater than 10.
     * }
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc", "abcd")
     *
     * const longestStringLengthOfSet = await koconutSet
     *                                       .maxWith((front, rear) => front.length - rear.length)
     *                                       .yield()
     * console.log(longestStringLengthOfSet)
     * // ↑ abcd
     *
     * // Case 3
     * const koconutMap = KoconutArray.of("a", "ab", "abc")
     *                   .associate(eachString => [eachString.length, eachString])
     *
     * const longestStringLengthEntryOfMap = await koconutMap
     *                                   .maxWith((front, rear) => front.key - rear.key)
     *                                   .yield()
     * console.log(longestStringLengthEntryOfMap)
     * // ↑ Entry { keyElement: 3, valueElement: 'abc' }
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(12,51,32,45,50)
     *
     * const largestNumberOfArray2 = await koconutArray2
     *                     .maxWith(async (front, rear) => front - rear)
     *                     .yield()
     * console.log(largestNumberOfArray2)
     * // ↑ 51
     *
     * const largest1sDigitNumberOfArray2 = await koconutArray2
     *                       .maxWith((front, rear) => new Promise(resolve => {
     *                           resolve(front % 10 - rear % 10)
     *                       }))
     *                       .yield()
     * console.log(largest1sDigitNumberOfArray2)
     * // ↑ 45
     */

  }, {
    key: "maxWith",
    value: function maxWith(comparator) {
      var _this9 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      comparator = comparator.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8() {
        var dataToReturn, _iterator8, _step8, eachCombinedDatum;

        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                if (!(_this9.combinedDataWrapper == null)) {
                  _context8.next = 2;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is null");

              case 2:
                dataToReturn = null;
                _iterator8 = _createForOfIteratorHelper(_this9.combinedDataWrapper);
                _context8.prev = 4;

                _iterator8.s();

              case 6:
                if ((_step8 = _iterator8.n()).done) {
                  _context8.next = 18;
                  break;
                }

                eachCombinedDatum = _step8.value;
                _context8.t0 = dataToReturn == null;

                if (_context8.t0) {
                  _context8.next = 14;
                  break;
                }

                _context8.next = 12;
                return comparator(dataToReturn, eachCombinedDatum);

              case 12:
                _context8.t1 = _context8.sent;
                _context8.t0 = _context8.t1 < 0;

              case 14:
                if (!_context8.t0) {
                  _context8.next = 16;
                  break;
                }

                dataToReturn = eachCombinedDatum;

              case 16:
                _context8.next = 6;
                break;

              case 18:
                _context8.next = 23;
                break;

              case 20:
                _context8.prev = 20;
                _context8.t2 = _context8["catch"](4);

                _iterator8.e(_context8.t2);

              case 23:
                _context8.prev = 23;

                _iterator8.f();

                return _context8.finish(23);

              case 26:
                if (!(dataToReturn == null)) {
                  _context8.next = 28;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is empty");

              case 28:
                return _context8.abrupt("return", dataToReturn);

              case 29:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, null, [[4, 20, 23, 26]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the first element having the largest value according to the provided ```comparator``` or null
     * if elements are empty.
     * @param comparator A callback function that accepts two arguements. The method calls the ```comparator``` to compare two selected values.
     * In case the result is larger than 0, front is bigger than rear, and if it's less than 0 judge vice versa.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```comparator```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const largestNumberOfArray = await koconutArray
     *                                   .maxWithOrNull((front, rear) => front - rear)
     *                                   .yield()
     * console.log(largestNumberOfArray)
     * // ↑ 5
     * 
     * const largestNumberOfEmptyArray = await koconutArray
     *                                  .filter(eachNumber => eachNumber > 10)
     *                                  .maxWithOrNull((front, rear) => front - rear)
     *                                  .yield()
     * console.log(largestNumberOfEmptyArray)
     * // ↑ null
     * 
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc", "abcd")
     *
     * const longestStringLengthOfSet = await koconutSet
     *                                       .maxWithOrNull((front, rear) => front.length - rear.length)
     *                                       .yield()
     * console.log(longestStringLengthOfSet)
     * // ↑ abcd
     *
     * // Case 3
     * const koconutMap = KoconutArray.of("a", "ab", "abc")
     *                   .associate(eachString => [eachString.length, eachString])
     *
     * const longestStringLengthEntryOfMap = await koconutMap
     *                                   .maxWithOrNull((front, rear) => front.key - rear.key)
     *                                   .yield()
     * console.log(longestStringLengthEntryOfMap)
     * // ↑ Entry { keyElement: 3, valueElement: 'abc' }
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(12,51,32,45,50)
     *
     * const largestNumberOfArray2 = await koconutArray2
     *                     .maxWithOrNull(async (front, rear) => front - rear)
     *                     .yield()
     * console.log(largestNumberOfArray2)
     * // ↑ 51
     *
     * const largest1sDigitNumberOfArray2 = await koconutArray2
     *                       .maxWithOrNull((front, rear) => new Promise(resolve => {
     *                           resolve(front % 10 - rear % 10)
     *                       }))
     *                       .yield()
     * console.log(largest1sDigitNumberOfArray2)
     * // ↑ 45
     */

  }, {
    key: "maxWithOrNull",
    value: function maxWithOrNull(comparator) {
      var _this10 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      comparator = comparator.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9() {
        var dataToReturn, _iterator9, _step9, eachCombinedDatum;

        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                if (!(_this10.combinedDataWrapper == null)) {
                  _context9.next = 2;
                  break;
                }

                return _context9.abrupt("return", null);

              case 2:
                dataToReturn = null;
                _iterator9 = _createForOfIteratorHelper(_this10.combinedDataWrapper);
                _context9.prev = 4;

                _iterator9.s();

              case 6:
                if ((_step9 = _iterator9.n()).done) {
                  _context9.next = 18;
                  break;
                }

                eachCombinedDatum = _step9.value;
                _context9.t0 = dataToReturn == null;

                if (_context9.t0) {
                  _context9.next = 14;
                  break;
                }

                _context9.next = 12;
                return comparator(dataToReturn, eachCombinedDatum);

              case 12:
                _context9.t1 = _context9.sent;
                _context9.t0 = _context9.t1 < 0;

              case 14:
                if (!_context9.t0) {
                  _context9.next = 16;
                  break;
                }

                dataToReturn = eachCombinedDatum;

              case 16:
                _context9.next = 6;
                break;

              case 18:
                _context9.next = 23;
                break;

              case 20:
                _context9.prev = 20;
                _context9.t2 = _context9["catch"](4);

                _iterator9.e(_context9.t2);

              case 23:
                _context9.prev = 23;

                _iterator9.f();

                return _context9.finish(23);

              case 26:
                return _context9.abrupt("return", dataToReturn);

              case 27:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, null, [[4, 20, 23, 26]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the first element yielding the samllest value of the given function or 
     * throws {@link KoconutNoSuchElementException} if there are no elements.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @throws {@link KoconutNoSuchElementException}
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * @deprecated Use {@link minByOrNull} instead.
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const smallestNumberOfArray = await koconutArray
     *                           .minBy(eachNumber => eachNumber)
     *                           .yield()
     * console.log(smallestNumberOfArray)
     * // ↑ 1
     *
     * try {
     * await koconutArray
     *       .filter(eachNumber => eachNumber > 10)
     *       .minBy(eachNumber => eachNumber)
     *       .yield()
     * } catch(error) {
     *   console.log(error.name)
     *   // ↑ Koconut No Such Element Exception
     *   // i.e. -- Array is filtered.
     *   // No element in 1 to 5 is greater than 10.
     * }
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc")
     *
     * const shortestStringOfSet = await koconutSet
     *                           .minBy(eachString => eachString.length)
     *                           .yield()
     * console.log(shortestStringOfSet)
     * // ↑ a
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of(1, 12, 123)
     *               .associateWith(eachNumber => eachNumber.toString())
     *
     * const shortestDigitsEntryOfMap = await koconutMap
     *                                   .minBy(eachEntry => eachEntry.value.length)
     *                                   .yield()
     * console.log(shortestDigitsEntryOfMap)
     * // ↑ Entry { keyElement: 1, valueElement: '1' }
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(19,27,32)
     *
     * const smallestNumberOfArray2 = await koconutArray2
     *                               .minBy(async eachNumber => eachNumber)
     *                               .yield()
     * console.log(smallestNumberOfArray2)
     * // ↑ 19
     *
     * const smallest1sDigitNumberOfArray2 = await koconutArray2
     *                                   .minBy(eachNumber => new Promise(resolve => {
     *                                       resolve(eachNumber % 10)
     *                                   }))
     *                                   .yield()
     * console.log(smallest1sDigitNumberOfArray2)
     * // ↑ 32
     * ```
     */

  }, {
    key: "minBy",
    value: function minBy(selector) {
      var _this11 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      _module.KoconutDeprecation.showDeprecationWarning("1.2.0", this.minByOrNull);

      selector = selector.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10() {
        var dataToReturn, lastComparableDatum, _iterator10, _step10, eachCombinedDatum, eachComparableDatum, shouldBeChanged, eachCompareResult, numberResult;

        return _regenerator["default"].wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                if (!(_this11.combinedDataWrapper == null)) {
                  _context10.next = 2;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is null");

              case 2:
                dataToReturn = null;
                lastComparableDatum = null;
                _iterator10 = _createForOfIteratorHelper(_this11.combinedDataWrapper);
                _context10.prev = 5;

                _iterator10.s();

              case 7:
                if ((_step10 = _iterator10.n()).done) {
                  _context10.next = 31;
                  break;
                }

                eachCombinedDatum = _step10.value;
                _context10.next = 11;
                return selector(eachCombinedDatum);

              case 11:
                eachComparableDatum = _context10.sent;
                shouldBeChanged = lastComparableDatum == null;

                if (shouldBeChanged) {
                  _context10.next = 28;
                  break;
                }

                if (!_module.KoconutTypeChecker.checkIsComparable(eachComparableDatum)) {
                  _context10.next = 27;
                  break;
                }

                eachCompareResult = eachComparableDatum.compareTo(lastComparableDatum);
                numberResult = 0;

                if (!(eachCompareResult instanceof _module.KoconutPrimitive)) {
                  _context10.next = 23;
                  break;
                }

                _context10.next = 20;
                return eachCompareResult["yield"]();

              case 20:
                numberResult = _context10.sent;
                _context10.next = 24;
                break;

              case 23:
                numberResult = eachCompareResult;

              case 24:
                if (numberResult < 0) shouldBeChanged = true;
                _context10.next = 28;
                break;

              case 27:
                shouldBeChanged = lastComparableDatum > eachComparableDatum;

              case 28:
                if (shouldBeChanged) {
                  dataToReturn = eachCombinedDatum;
                  lastComparableDatum = eachComparableDatum;
                }

              case 29:
                _context10.next = 7;
                break;

              case 31:
                _context10.next = 36;
                break;

              case 33:
                _context10.prev = 33;
                _context10.t0 = _context10["catch"](5);

                _iterator10.e(_context10.t0);

              case 36:
                _context10.prev = 36;

                _iterator10.f();

                return _context10.finish(36);

              case 39:
                if (!(dataToReturn == null)) {
                  _context10.next = 41;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is empty");

              case 41:
                return _context10.abrupt("return", dataToReturn);

              case 42:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, null, [[5, 33, 36, 39]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the first element yielding the samllest value of the given function or ```null``` if there are no elements.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const smallestNumberOfArray = await koconutArray
     *                           .minByOrNull(eachNumber => eachNumber)
     *                           .yield()
     * console.log(smallestNumberOfArray)
     * // ↑ 1
     *
     * const smallestNumberOfEmptyArray = await koconutArray
     *                       .filter(eachNumber => eachNumber > 10)
     *                       .minByOrNull(eachNumber => eachNumber)
     *                       .yield()
     * console.log(smallestNumberOfEmptyArray)
     * // ↑ null
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc")
     *
     * const shortestStringOfSet = await koconutSet
     *                           .minByOrNull(eachString => eachString.length)
     *                           .yield()
     * console.log(shortestStringOfSet)
     * // ↑ a
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of(1, 12, 123)
     *               .associateWith(eachNumber => eachNumber.toString())
     *
     * const shortestDigitsEntryOfMap = await koconutMap
     *                                   .minByOrNull(eachEntry => eachEntry.value.length)
     *                                   .yield()
     * console.log(shortestDigitsEntryOfMap)
     * // ↑ Entry { keyElement: 1, valueElement: '1' }
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(19,27,32)
     *
     * const samllestNumberOfArray2 = await koconutArray2
     *                               .minByOrNull(async eachNumber => eachNumber)
     *                               .yield()
     * console.log(samllestNumberOfArray2)
     * // ↑ 19
     *
     * const smallest1sDigitNumberOfArray2 = await koconutArray2
     *                                   .minByOrNull(eachNumber => new Promise(resolve => {
     *                                       resolve(eachNumber % 10)
     *                                   }))
     *                                   .yield()
     * console.log(smallest1sDigitNumberOfArray2)
     * // ↑ 32
     * ```
     */

  }, {
    key: "minByOrNull",
    value: function minByOrNull(selector) {
      var _this12 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      selector = selector.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11() {
        var dataToReturn, lastComparableDatum, _iterator11, _step11, eachCombinedDatum, eachComparableDatum, shouldBeChanged, eachCompareResult, numberResult;

        return _regenerator["default"].wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                if (!(_this12.combinedDataWrapper == null)) {
                  _context11.next = 2;
                  break;
                }

                return _context11.abrupt("return", null);

              case 2:
                dataToReturn = null;
                lastComparableDatum = null;
                _iterator11 = _createForOfIteratorHelper(_this12.combinedDataWrapper);
                _context11.prev = 5;

                _iterator11.s();

              case 7:
                if ((_step11 = _iterator11.n()).done) {
                  _context11.next = 31;
                  break;
                }

                eachCombinedDatum = _step11.value;
                _context11.next = 11;
                return selector(eachCombinedDatum);

              case 11:
                eachComparableDatum = _context11.sent;
                shouldBeChanged = lastComparableDatum == null;

                if (shouldBeChanged) {
                  _context11.next = 28;
                  break;
                }

                if (!_module.KoconutTypeChecker.checkIsComparable(eachComparableDatum)) {
                  _context11.next = 27;
                  break;
                }

                eachCompareResult = eachComparableDatum.compareTo(lastComparableDatum);
                numberResult = 0;

                if (!(eachCompareResult instanceof _module.KoconutPrimitive)) {
                  _context11.next = 23;
                  break;
                }

                _context11.next = 20;
                return eachCompareResult["yield"]();

              case 20:
                numberResult = _context11.sent;
                _context11.next = 24;
                break;

              case 23:
                numberResult = eachCompareResult;

              case 24:
                if (numberResult < 0) shouldBeChanged = true;
                _context11.next = 28;
                break;

              case 27:
                shouldBeChanged = lastComparableDatum > eachComparableDatum;

              case 28:
                if (shouldBeChanged) {
                  dataToReturn = eachCombinedDatum;
                  lastComparableDatum = eachComparableDatum;
                }

              case 29:
                _context11.next = 7;
                break;

              case 31:
                _context11.next = 36;
                break;

              case 33:
                _context11.prev = 33;
                _context11.t0 = _context11["catch"](5);

                _iterator11.e(_context11.t0);

              case 36:
                _context11.prev = 36;

                _iterator11.f();

                return _context11.finish(36);

              case 39:
                return _context11.abrupt("return", dataToReturn);

              case 40:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, null, [[5, 33, 36, 39]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the smallest value among all values produced by ```selector``` function applied to each element in the collection or 
     * throws {@link KoconutNoSuchElementException} if there are no elements.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @throws {@link KoconutNoSuchElementException}
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,7,9)
     *
     * const smallestRemainderNumberDividedBy5OfArray = await koconutArray
     *                                           .minOf(eachNumber => eachNumber % 5)
     *                                           .yield()
     * console.log(smallestRemainderNumberDividedBy5OfArray)
     * // ↑ 1
     *
     * try {
     *   await koconutArray
     *           .filter(eachNumber => eachNumber > 10)
     *           .minOf(eachNumber => eachNumber % 5)
     *           .yield()
     * } catch(error) {
     *   console.log(error.name)
     *   // ↑ Koconut No Such Element Exception
     *   // i.e. -- Array is filtered.
     *   // No element in 1 to 5 is greater than 10.
     * }
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc")
     *
     * const shortestStringLengthOfSet = await koconutSet
     *                           .minOf(eachString => eachString.length)
     *                           .yield()
     * console.log(shortestStringLengthOfSet)
     * // ↑ 1
     *
     * class ComparableString implements KoconutComparable{
     *   str : string
     *   constructor(str : string) {
     *       this.str = str
     *   }
     *   // Override
     *   compareTo(other : ComparableString) : number {
     *       return this.str.length - other.str.length
     *   }
     * }
     * const minComparableString = await koconutSet
     *                       .minOf(eachString => new ComparableString(eachString))
     *                       .yield()
     * console.log(minComparableString)
     * // ↑ ComparableString { str: 'a' }
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of("a", "ab", "abc")
     *               .associate(eachString => [eachString.length, eachString])
     *
     * const shortestStringLengthOfMap = await koconutMap
     *                               .minOf(eachEntry => eachEntry.key)
     *                               .yield()
     * console.log(shortestStringLengthOfMap)
     * // ↑ 1
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(12,51,32,45,50)
     *
     * const smallestNumberOfArray2 = await koconutArray2
     *                       .minOf(async eachNumber => eachNumber)
     *                       .yield()
     * console.log(smallestNumberOfArray2)
     * // ↑ 12
     *
     * const smallest1sDigitOfArray2 = await koconutArray2
     *                       .minOf(eachNumber => new Promise(resolve => {
     *                           resolve(eachNumber % 10)
     *                       }))
     *                       .yield()
     * console.log(smallest1sDigitOfArray2)
     * // ↑ 0
     * ```
     */

  }, {
    key: "minOf",
    value: function minOf(selector) {
      var _this13 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      selector = selector.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12() {
        var lastComparableDatumToReturn, _iterator12, _step12, eachCombinedDatum, eachComparableDatum, shouldBeChanged, eachCompareResult, numberResult;

        return _regenerator["default"].wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                if (!(_this13.combinedDataWrapper == null)) {
                  _context12.next = 2;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is null");

              case 2:
                lastComparableDatumToReturn = null;
                _iterator12 = _createForOfIteratorHelper(_this13.combinedDataWrapper);
                _context12.prev = 4;

                _iterator12.s();

              case 6:
                if ((_step12 = _iterator12.n()).done) {
                  _context12.next = 30;
                  break;
                }

                eachCombinedDatum = _step12.value;
                _context12.next = 10;
                return selector(eachCombinedDatum);

              case 10:
                eachComparableDatum = _context12.sent;
                shouldBeChanged = lastComparableDatumToReturn == null;

                if (shouldBeChanged) {
                  _context12.next = 27;
                  break;
                }

                if (!_module.KoconutTypeChecker.checkIsComparable(eachComparableDatum)) {
                  _context12.next = 26;
                  break;
                }

                eachCompareResult = eachComparableDatum.compareTo(lastComparableDatumToReturn);
                numberResult = 0;

                if (!(eachCompareResult instanceof _module.KoconutPrimitive)) {
                  _context12.next = 22;
                  break;
                }

                _context12.next = 19;
                return eachCompareResult["yield"]();

              case 19:
                numberResult = _context12.sent;
                _context12.next = 23;
                break;

              case 22:
                numberResult = eachCompareResult;

              case 23:
                if (numberResult < 0) shouldBeChanged = true;
                _context12.next = 27;
                break;

              case 26:
                shouldBeChanged = lastComparableDatumToReturn > eachComparableDatum;

              case 27:
                if (shouldBeChanged) lastComparableDatumToReturn = eachComparableDatum;

              case 28:
                _context12.next = 6;
                break;

              case 30:
                _context12.next = 35;
                break;

              case 32:
                _context12.prev = 32;
                _context12.t0 = _context12["catch"](4);

                _iterator12.e(_context12.t0);

              case 35:
                _context12.prev = 35;

                _iterator12.f();

                return _context12.finish(35);

              case 38:
                if (!(lastComparableDatumToReturn == null)) {
                  _context12.next = 40;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is empty");

              case 40:
                return _context12.abrupt("return", lastComparableDatumToReturn);

              case 41:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, null, [[4, 32, 35, 38]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the smallest value among all values produced by ```selector``` function applied to each element in the collection or 
     * ```null``` if there are no elements.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,7,9)
     *
     * const smallestRemainderNumberDividedBy5OfArray = await koconutArray
     *                                           .minOfOrNull(eachNumber => eachNumber % 5)
     *                                           .yield()
     * console.log(smallestRemainderNumberDividedBy5OfArray)
     * // ↑ 1
     *
     * const smallestRemainderNumberDividedBy5OfEmptyArray = await koconutArray
     *                                       .filter(eachNumber => eachNumber > 10)
     *                                       .minOfOrNull(eachNumber => eachNumber % 5)
     *                                       .yield()
     * console.log(smallestRemainderNumberDividedBy5OfEmptyArray)
     * // ↑ null
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc")
     *
     * const shortestStringLengthOfSet = await koconutSet
     *                           .minOfOrNull(eachString => eachString.length)
     *                           .yield()
     * console.log(shortestStringLengthOfSet)
     * // ↑ 1
     *
     * class ComparableString implements KoconutComparable{
     *   str : string
     *   constructor(str : string) {
     *       this.str = str
     *   }
     *   // Override
     *   compareTo(other : ComparableString) : number {
     *       return this.str.length - other.str.length
     *   }
     * }
     * const minComparableString = await koconutSet
     *                       .minOfOrNull(eachString => new ComparableString(eachString))
     *                       .yield()
     * console.log(minComparableString)
     * // ↑ ComparableString { str: 'a' }
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of("a", "ab", "abc")
     *               .associate(eachString => [eachString.length, eachString])
     *
     * const shortestStringLengthOfMap = await koconutMap
     *                               .minOfOrNull(eachEntry => eachEntry.key)
     *                               .yield()
     * console.log(shortestStringLengthOfMap)
     * // ↑ 1
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(12,51,32,45,50)
     *
     * const smallestNumberOfArray2 = await koconutArray2
     *                       .minOfOrNull(async eachNumber => eachNumber)
     *                       .yield()
     * console.log(smallestNumberOfArray2)
     * // ↑ 12
     *
     * const smallest1sDigitOfArray2 = await koconutArray2
     *                       .minOfOrNull(eachNumber => new Promise(resolve => {
     *                           resolve(eachNumber % 10)
     *                       }))
     *                       .yield()
     * console.log(smallest1sDigitOfArray2)
     * // ↑ 0
     * ```
     */

  }, {
    key: "minOfOrNull",
    value: function minOfOrNull(selector) {
      var _this14 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      selector = selector.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13() {
        var lastComparableDatumToReturn, _iterator13, _step13, eachCombinedDatum, eachComparableDatum, shouldBeChanged, eachCompareResult, numberResult;

        return _regenerator["default"].wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                if (!(_this14.combinedDataWrapper == null)) {
                  _context13.next = 2;
                  break;
                }

                return _context13.abrupt("return", null);

              case 2:
                lastComparableDatumToReturn = null;
                _iterator13 = _createForOfIteratorHelper(_this14.combinedDataWrapper);
                _context13.prev = 4;

                _iterator13.s();

              case 6:
                if ((_step13 = _iterator13.n()).done) {
                  _context13.next = 30;
                  break;
                }

                eachCombinedDatum = _step13.value;
                _context13.next = 10;
                return selector(eachCombinedDatum);

              case 10:
                eachComparableDatum = _context13.sent;
                shouldBeChanged = lastComparableDatumToReturn == null;

                if (shouldBeChanged) {
                  _context13.next = 27;
                  break;
                }

                if (!_module.KoconutTypeChecker.checkIsComparable(eachComparableDatum)) {
                  _context13.next = 26;
                  break;
                }

                eachCompareResult = eachComparableDatum.compareTo(lastComparableDatumToReturn);
                numberResult = 0;

                if (!(eachCompareResult instanceof _module.KoconutPrimitive)) {
                  _context13.next = 22;
                  break;
                }

                _context13.next = 19;
                return eachCompareResult["yield"]();

              case 19:
                numberResult = _context13.sent;
                _context13.next = 23;
                break;

              case 22:
                numberResult = eachCompareResult;

              case 23:
                if (numberResult < 0) shouldBeChanged = true;
                _context13.next = 27;
                break;

              case 26:
                shouldBeChanged = lastComparableDatumToReturn > eachComparableDatum;

              case 27:
                if (shouldBeChanged) lastComparableDatumToReturn = eachComparableDatum;

              case 28:
                _context13.next = 6;
                break;

              case 30:
                _context13.next = 35;
                break;

              case 32:
                _context13.prev = 32;
                _context13.t0 = _context13["catch"](4);

                _iterator13.e(_context13.t0);

              case 35:
                _context13.prev = 35;

                _iterator13.f();

                return _context13.finish(35);

              case 38:
                return _context13.abrupt("return", lastComparableDatumToReturn);

              case 39:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, null, [[4, 32, 35, 38]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the smallest value according to the provided ```comparator``` among all values
     * produced by ```selector``` function applied to each element in the collection all throws {@link KoconutNoSuchElementException}
     * if elements are empty.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param comparator A callback function that accepts two arguements. The method calls the ```comparator``` to compare two selected values.
     * In case the result is larger than 0, front is bigger than rear, and if it's less than 0 judge vice versa.
     * @param selectorThisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * @param comparatorThisArg An object to which the ```this``` keyword can refer in the ```comparator```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @throws {@link KoconutNoSuchElementException}
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of("1", "2", "3", "4", "5")
     *
     * const smallestNumberedStringOfArray = await koconutArray
     *                               .minOfWith(
     *                                   parseInt,
     *                                   (front, rear) => front - rear
     *                               )
     *                               .yield()
     * console.log(smallestNumberedStringOfArray)
     * // ↑ 1
     *
     * try {
     *   await koconutArray
     *           .filter(eachString => eachString.length > 2)
     *           .minOfWith(
     *               parseInt,
     *               (front, rear) => front - rear
     *           )
     *           .yield()
     * } catch(error) {
     *   console.log(error.name)
     *   // ↑ Koconut No Such Element Exception
     *   // i.e. -- Array is filtered.
     *   // No string in "1" to "5" is logner than 2.
     * }
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc")
     *
     * const shortestStringLengthOfSet = await koconutSet
     *                           .minOfWith(
     *                               eachString => eachString.length,
     *                               (front, rear) => front - rear
     *                           )
     *                           .yield()
     * console.log(shortestStringLengthOfSet)
     * // ↑ 1
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of("a", "ab", "abc")
     *               .associate(eachString => [eachString.length, eachString])
     *
     * const shortestStringLengthOfMap = await koconutMap
     *                               .minOfWith(
     *                                   eachEntry => eachEntry.key,
     *                                   (front, rear) => front - rear
     *                               )
     *                               .yield()
     * console.log(shortestStringLengthOfMap)
     * // ↑ 1
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(12,51,32,45,50)
     *
     * const smallestNumberOfArray2 = await koconutArray2
     *                           .minOfWith(
     *                               async eachNumber => eachNumber,
     *                               async (front, rear) => front - rear
     *                           )
     *                           .yield()
     * console.log(smallestNumberOfArray2)
     * // ↑ 12
     *
     * const smallest1sDigitOfArray2 = await koconutArray2
     *                           .minOfWith(
     *                               (eachNumber) => new Promise<number>(resolve => {
     *                                   resolve(eachNumber % 10)
     *                               }),
     *                               (front, rear) => new Promise(resolve => {
     *                                   resolve(front - rear)
     *                               })
     *                           )
     *                           .yield()
     * console.log(smallest1sDigitOfArray2)
     * // ↑ 0
     * ```
     */

  }, {
    key: "minOfWith",
    value: function minOfWith(selector, comparator) {
      var _this15 = this;

      var selectorThisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var comparatorThisArg = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      selector = selector.bind(selectorThisArg);
      comparator = comparator.bind(comparatorThisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14() {
        var lastComparableDatumToReturn, _iterator14, _step14, eachCombinedDatum, eachComparableDatum;

        return _regenerator["default"].wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                if (!(_this15.combinedDataWrapper == null)) {
                  _context14.next = 2;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is null");

              case 2:
                lastComparableDatumToReturn = null;
                _iterator14 = _createForOfIteratorHelper(_this15.combinedDataWrapper);
                _context14.prev = 4;

                _iterator14.s();

              case 6:
                if ((_step14 = _iterator14.n()).done) {
                  _context14.next = 21;
                  break;
                }

                eachCombinedDatum = _step14.value;
                _context14.next = 10;
                return selector(eachCombinedDatum);

              case 10:
                eachComparableDatum = _context14.sent;
                _context14.t0 = lastComparableDatumToReturn == null;

                if (_context14.t0) {
                  _context14.next = 17;
                  break;
                }

                _context14.next = 15;
                return comparator(lastComparableDatumToReturn, eachComparableDatum);

              case 15:
                _context14.t1 = _context14.sent;
                _context14.t0 = _context14.t1 > 0;

              case 17:
                if (!_context14.t0) {
                  _context14.next = 19;
                  break;
                }

                lastComparableDatumToReturn = eachComparableDatum;

              case 19:
                _context14.next = 6;
                break;

              case 21:
                _context14.next = 26;
                break;

              case 23:
                _context14.prev = 23;
                _context14.t2 = _context14["catch"](4);

                _iterator14.e(_context14.t2);

              case 26:
                _context14.prev = 26;

                _iterator14.f();

                return _context14.finish(26);

              case 29:
                if (!(lastComparableDatumToReturn == null)) {
                  _context14.next = 31;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is empty");

              case 31:
                return _context14.abrupt("return", lastComparableDatumToReturn);

              case 32:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14, null, [[4, 23, 26, 29]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the smallest value according to the provided ```comparator``` among all values
     * produced by ```selector``` function applied to each element in the collection all ```null```
     * if elements are empty.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param comparator A callback function that accepts two arguements. The method calls the ```comparator``` to compare two selected values.
     * In case the result is larger than 0, front is bigger than rear, and if it's less than 0 judge vice versa.
     * @param selectorThisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * @param comparatorThisArg An object to which the ```this``` keyword can refer in the ```comparator```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @throws {@link KoconutNoSuchElementException}
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of("1", "2", "3", "4", "5")
     *
     * const smallestNumberedStringOfArray = await koconutArray
     *                               .minOfWithOrNull(
     *                                   parseInt,
     *                                   (front, rear) => front - rear
     *                               )
     *                               .yield()
     * console.log(smallestNumberedStringOfArray)
     * // ↑ 1
     *
     * const smallestNumberedStringOfEmptyArray = await koconutArray
     *                           .filter(eachString => eachString.length > 2)
     *                           .minOfWithOrNull(
     *                               parseInt,
     *                               (front, rear) => front - rear
     *                           )
     *                           .yield()
     * console.log(smallestNumberedStringOfEmptyArray)
     * // ↑ null
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc")
     *
     * const shortestStringLengthOfSet = await koconutSet
     *                           .minOfWithOrNull(
     *                               eachString => eachString.length,
     *                               (front, rear) => front - rear
     *                           )
     *                           .yield()
     * console.log(shortestStringLengthOfSet)
     * // ↑ 1
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of("a", "ab", "abc")
     *               .associate(eachString => [eachString.length, eachString])
     *
     * const shortestStringLengthOfMap = await koconutMap
     *                               .minOfWithOrNull(
     *                                   eachEntry => eachEntry.key,
     *                                   (front, rear) => front - rear
     *                               )
     *                               .yield()
     * console.log(shortestStringLengthOfMap)
     * // ↑ 1
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(12,51,32,45,50)
     *
     * const smallestNumberOfArray2 = await koconutArray2
     *                           .minOfWithOrNull(
     *                               async eachNumber => eachNumber,
     *                               async (front, rear) => front - rear
     *                           )
     *                           .yield()
     * console.log(smallestNumberOfArray2)
     * // ↑ 12
     *
     * const smallest1sDigitOfArray2 = await koconutArray2
     *                           .minOfWithOrNull(
     *                               (eachNumber) => new Promise<number>(resolve => {
     *                                   resolve(eachNumber % 10)
     *                               }),
     *                               (front, rear) => new Promise(resolve => {
     *                                   resolve(front - rear)
     *                               })
     *                           )
     *                           .yield()
     * console.log(smallest1sDigitOfArray2)
     * // ↑ 0
     * ```
     */

  }, {
    key: "minOfWithOrNull",
    value: function minOfWithOrNull(selector, comparator) {
      var _this16 = this;

      var selectorThisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var comparatorThisArg = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      selector = selector.bind(selectorThisArg);
      comparator = comparator.bind(comparatorThisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee15() {
        var lastComparableDatumToReturn, _iterator15, _step15, eachCombinedDatum, eachComparableDatum;

        return _regenerator["default"].wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                if (!(_this16.combinedDataWrapper == null)) {
                  _context15.next = 2;
                  break;
                }

                return _context15.abrupt("return", null);

              case 2:
                lastComparableDatumToReturn = null;
                _iterator15 = _createForOfIteratorHelper(_this16.combinedDataWrapper);
                _context15.prev = 4;

                _iterator15.s();

              case 6:
                if ((_step15 = _iterator15.n()).done) {
                  _context15.next = 21;
                  break;
                }

                eachCombinedDatum = _step15.value;
                _context15.next = 10;
                return selector(eachCombinedDatum);

              case 10:
                eachComparableDatum = _context15.sent;
                _context15.t0 = lastComparableDatumToReturn == null;

                if (_context15.t0) {
                  _context15.next = 17;
                  break;
                }

                _context15.next = 15;
                return comparator(lastComparableDatumToReturn, eachComparableDatum);

              case 15:
                _context15.t1 = _context15.sent;
                _context15.t0 = _context15.t1 > 0;

              case 17:
                if (!_context15.t0) {
                  _context15.next = 19;
                  break;
                }

                lastComparableDatumToReturn = eachComparableDatum;

              case 19:
                _context15.next = 6;
                break;

              case 21:
                _context15.next = 26;
                break;

              case 23:
                _context15.prev = 23;
                _context15.t2 = _context15["catch"](4);

                _iterator15.e(_context15.t2);

              case 26:
                _context15.prev = 26;

                _iterator15.f();

                return _context15.finish(26);

              case 29:
                return _context15.abrupt("return", lastComparableDatumToReturn);

              case 30:
              case "end":
                return _context15.stop();
            }
          }
        }, _callee15, null, [[4, 23, 26, 29]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the first element having the smallest value according to the provided ```comparator``` or throws {@link KoconutNoSuchElementException}
     * if elements are empty.
     * @param comparator A callback function that accepts two arguements. The method calls the ```comparator``` to compare two selected values.
     * In case the result is larger than 0, front is bigger than rear, and if it's less than 0 judge vice versa.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```comparator```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @throws {@link KoconutNoSuchElementException}
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const smallestNumberOfArray = await koconutArray
     *                               .minWith((front, rear) => front - rear)
     *                               .yield()
     * console.log(smallestNumberOfArray)
     * // ↑ 1
     *
     * try {
     *   await koconutArray
     *           .filter(eachNumber => eachNumber > 10)
     *           .minWith((front, rear) => front - rear)
     *           .yield()
     * } catch(error) {
     *   console.log(error.name)
     *   // ↑ Koconut No Such Element Exception
     *   // i.e. -- Array is filtered.
     *   // No element in 1 to 5 is greater than 10.
     * }
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc", "abcd")
     *
     * const shortestStringLengthOfSet = await koconutSet
     *                                   .minWith((front, rear) => front.length - rear.length)
     *                                   .yield()
     * console.log(shortestStringLengthOfSet)
     * // ↑ a
     *
     * // Case 3
     * const koconutMap = KoconutArray.of("a", "ab", "abc")
     *               .associate(eachString => [eachString.length, eachString])
     *
     * const shortestStringLengthEntryOfMap = await koconutMap
     *                               .minWith((front, rear) => front.key - rear.key)
     *                               .yield()
     * console.log(shortestStringLengthEntryOfMap)
     * // ↑ Entry { keyElement: 1, valueElement: 'a' }
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(12,51,32,45,50)
     *
     * const smallestNumberOfArray2 = await koconutArray2
     *                   .minWith(async (front, rear) => front - rear)
     *                   .yield()
     * console.log(smallestNumberOfArray2)
     * // ↑ 12
     *
     * const smallest1sDigitNumberOfArray2 = await koconutArray2
     *                   .minWith((front, rear) => new Promise(resolve => {
     *                       resolve(front % 10 - rear % 10)
     *                   }))
     *                   .yield()
     * console.log(smallest1sDigitNumberOfArray2)
     * // ↑ 50
     * ```
     */

  }, {
    key: "minWith",
    value: function minWith(comparator) {
      var _this17 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      comparator = comparator.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee16() {
        var dataToReturn, _iterator16, _step16, eachCombinedDatum;

        return _regenerator["default"].wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                if (!(_this17.combinedDataWrapper == null)) {
                  _context16.next = 2;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is null");

              case 2:
                dataToReturn = null;
                _iterator16 = _createForOfIteratorHelper(_this17.combinedDataWrapper);
                _context16.prev = 4;

                _iterator16.s();

              case 6:
                if ((_step16 = _iterator16.n()).done) {
                  _context16.next = 18;
                  break;
                }

                eachCombinedDatum = _step16.value;
                _context16.t0 = dataToReturn == null;

                if (_context16.t0) {
                  _context16.next = 14;
                  break;
                }

                _context16.next = 12;
                return comparator(dataToReturn, eachCombinedDatum);

              case 12:
                _context16.t1 = _context16.sent;
                _context16.t0 = _context16.t1 > 0;

              case 14:
                if (!_context16.t0) {
                  _context16.next = 16;
                  break;
                }

                dataToReturn = eachCombinedDatum;

              case 16:
                _context16.next = 6;
                break;

              case 18:
                _context16.next = 23;
                break;

              case 20:
                _context16.prev = 20;
                _context16.t2 = _context16["catch"](4);

                _iterator16.e(_context16.t2);

              case 23:
                _context16.prev = 23;

                _iterator16.f();

                return _context16.finish(23);

              case 26:
                if (!(dataToReturn == null)) {
                  _context16.next = 28;
                  break;
                }

                throw new _module.KoconutNoSuchElementException("Source data is empty");

              case 28:
                return _context16.abrupt("return", dataToReturn);

              case 29:
              case "end":
                return _context16.stop();
            }
          }
        }, _callee16, null, [[4, 20, 23, 26]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns the first element having the smallest value according to the provided ```comparator``` or ```null```
     * if elements are empty.
     * @param comparator A callback function that accepts two arguements. The method calls the ```comparator``` to compare two selected values.
     * In case the result is larger than 0, front is bigger than rear, and if it's less than 0 judge vice versa.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```comparator```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @category Calculator
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const smallestNumberOfArray = await koconutArray
     *                               .minWithOrNull((front, rear) => front - rear)
     *                               .yield()
     * console.log(smallestNumberOfArray)
     * // ↑ 1
     *
     * const smallestNumberOfEmptyArray = await koconutArray
     *                           .filter(eachNumber => eachNumber > 10)
     *                           .minWithOrNull((front, rear) => front - rear)
     *                           .yield()
     * console.log(smallestNumberOfEmptyArray)
     * // ↑ null
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("a", "ab", "abc", "abcd")
     *
     * const shortestStringLengthOfSet = await koconutSet
     *                                   .minWithOrNull((front, rear) => front.length - rear.length)
     *                                   .yield()
     * console.log(shortestStringLengthOfSet)
     * // ↑ a
     *
     * // Case 3
     * const koconutMap = KoconutArray.of("a", "ab", "abc")
     *                .associate(eachString => [eachString.length, eachString])
     *
     * const shortestStringLengthEntryOfMap = await koconutMap
     *                               .minWithOrNull((front, rear) => front.key - rear.key)
     *                               .yield()
     * console.log(shortestStringLengthEntryOfMap)
     * // ↑ Entry { keyElement: 1, valueElement: 'a' }
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(12,51,32,45,50)
     *
     * const smallestNumberOfArray2 = await koconutArray2
     *                   .minWithOrNull(async (front, rear) => front - rear)
     *                   .yield()
     * console.log(smallestNumberOfArray2)
     * // ↑ 12
     *
     * const smallest1sDigitNumberOfArray2 = await koconutArray2
     *                   .minWithOrNull((front, rear) => new Promise(resolve => {
     *                       resolve(front % 10 - rear % 10)
     *                   }))
     *                   .yield()
     * console.log(smallest1sDigitNumberOfArray2)
     * // ↑ 50
     * ```
     */

  }, {
    key: "minWithOrNull",
    value: function minWithOrNull(comparator) {
      var _this18 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      comparator = comparator.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee17() {
        var dataToReturn, _iterator17, _step17, eachCombinedDatum;

        return _regenerator["default"].wrap(function _callee17$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                if (!(_this18.combinedDataWrapper == null)) {
                  _context17.next = 2;
                  break;
                }

                return _context17.abrupt("return", null);

              case 2:
                dataToReturn = null;
                _iterator17 = _createForOfIteratorHelper(_this18.combinedDataWrapper);
                _context17.prev = 4;

                _iterator17.s();

              case 6:
                if ((_step17 = _iterator17.n()).done) {
                  _context17.next = 18;
                  break;
                }

                eachCombinedDatum = _step17.value;
                _context17.t0 = dataToReturn == null;

                if (_context17.t0) {
                  _context17.next = 14;
                  break;
                }

                _context17.next = 12;
                return comparator(dataToReturn, eachCombinedDatum);

              case 12:
                _context17.t1 = _context17.sent;
                _context17.t0 = _context17.t1 > 0;

              case 14:
                if (!_context17.t0) {
                  _context17.next = 16;
                  break;
                }

                dataToReturn = eachCombinedDatum;

              case 16:
                _context17.next = 6;
                break;

              case 18:
                _context17.next = 23;
                break;

              case 20:
                _context17.prev = 20;
                _context17.t2 = _context17["catch"](4);

                _iterator17.e(_context17.t2);

              case 23:
                _context17.prev = 23;

                _iterator17.f();

                return _context17.finish(23);

              case 26:
                return _context17.abrupt("return", dataToReturn);

              case 27:
              case "end":
                return _context17.stop();
            }
          }
        }, _callee17, null, [[4, 20, 23, 26]]);
      })));
      return koconutToReturn;
    } // Caster

    /**
     * Creates an {@link KoconutArray} instance that wraps original data.
     * 
     * @since 1.0.13
     * 
     * @category Caster
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const arrToArr = await koconutArray
     *                           .asArray()
     *                           .yield()
     * console.log(arrToArr)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of(1,1,2,2,3,3,4,4,5,5)
     *
     * const setToArr = await koconutSet
     *                           .asArray()
     *                           .yield()
     * console.log(setToArr)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     *
     * // Case 3 -- KoconutFlow
     * const koconutFlow = KoconutFlow.ofSimple(1,2,3,4,5)
     *
     * const flowToArr = await koconutFlow
     *                           .asArray()
     *                           .yield()
     * console.log(flowToArr)
     * // ↑ 
     * // [
     * //    Entry { keyElement: 0, valueElement: 1 },
     * //    Entry { keyElement: 1, valueElement: 2 },
     * //    Entry { keyElement: 2, valueElement: 3 },
     * //    Entry { keyElement: 3, valueElement: 4 },
     * //    Entry { keyElement: 4, valueElement: 5 }
     * //  ]
     *
     * // Case 4 -- KoconutMap
     * const koconutMap = KoconutArray.of(1,2,3,4,5)
     *                           .associate(eachNumber => [eachNumber, eachNumber])
     *
     * const mapToArr = await koconutMap
     *                           .asArray()
     *                           .yield()
     * console.log(mapToArr)
     * // ↑ 
     * // [
     * //    Entry { keyElement: 1, valueElement: 1 },
     * //    Entry { keyElement: 2, valueElement: 2 },
     * //    Entry { keyElement: 3, valueElement: 3 },
     * //    Entry { keyElement: 4, valueElement: 4 },
     * //    Entry { keyElement: 5, valueElement: 5 }
     * //  ]
     * ```
     */

  }, {
    key: "asArray",
    value: function asArray() {
      var _this19 = this;

      var koconutToReturn = new _module.KoconutArray();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee18() {
        return _regenerator["default"].wrap(function _callee18$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                return _context18.abrupt("return", Array.from(_this19.combinedDataWrapper));

              case 1:
              case "end":
                return _context18.stop();
            }
          }
        }, _callee18);
      })));
      return koconutToReturn;
    }
    /**
     * Creates an {@link KoconutSet} instance that wraps original data.
     * 
     * @since 1.0.13
     * 
     * @category Caster
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const arrToSet = await koconutArray
     *                           .asSet()
     *                           .yield()
     * console.log(arrToSet)
     * // ↑ Set { 1, 2, 3, 4, 5 }
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of(1,1,2,2,3,3,4,4,5,5)
     *
     * const setToSet = await koconutSet
     *                           .asSet()
     *                           .yield()
     * console.log(setToSet)
     * // ↑ Set { 1, 2, 3, 4, 5 }
     *
     * // Case 3 -- KoconutFlow
     * const koconutFlow = KoconutFlow.ofSimple(1,2,3,4,5)
     *
     * const flowToSet = await koconutFlow
     *                           .asSet()
     *                           .yield()
     * console.log(flowToSet)
     * // ↑ 
     * // Set {
     * //    Entry { keyElement: 0, valueElement: 1 },
     * //    Entry { keyElement: 1, valueElement: 2 },
     * //    Entry { keyElement: 2, valueElement: 3 },
     * //    Entry { keyElement: 3, valueElement: 4 },
     * //    Entry { keyElement: 4, valueElement: 5 }
     * //  }
     *
     * // Case 4 -- KoconutMap
     * const koconutMap = KoconutArray.of(1,2,3,4,5)
     *                           .associate(eachNumber => [eachNumber, eachNumber])
     *
     * const mapToSet = await koconutMap
     *                           .asSet()
     *                           .yield()
     * console.log(mapToSet)
     * // ↑ 
     * // Set {
     * //    Entry { keyElement: 1, valueElement: 1 },
     * //    Entry { keyElement: 2, valueElement: 2 },
     * //    Entry { keyElement: 3, valueElement: 3 },
     * //    Entry { keyElement: 4, valueElement: 4 },
     * //    Entry { keyElement: 5, valueElement: 5 }
     * //  }
     * ```
     */

  }, {
    key: "asSet",
    value: function asSet() {
      var _this20 = this;

      var koconutToReturn = new _module.KoconutSet();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee19() {
        return _regenerator["default"].wrap(function _callee19$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                return _context19.abrupt("return", new Set(_this20.combinedDataWrapper));

              case 1:
              case "end":
                return _context19.stop();
            }
          }
        }, _callee19);
      })));
      return koconutToReturn;
    }
    /**
     * Creats an {@link KoconutFlow} instance that wraps original data.
     * 
     * @since 1.0.13
     * 
     * @category Caster
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const arrToFlow = await koconutArray
     *                           .asFlow()
     *                           .yield()
     * console.log(arrToFlow.dataArray)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of(1,1,2,2,3,3,4,4,5,5)
     *
     * const setToFlow = await koconutSet
     *                           .asFlow()
     *                           .yield()
     * console.log(setToFlow.dataArray)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     *
     * // Case 3 -- KoconutFlow
     * const koconutFlow = KoconutFlow.ofSimple(1,2,3,4,5)
     *
     * const flowToFlow = await koconutFlow
     *                           .asFlow()
     *                           .yield()
     * console.log(flowToFlow.dataArray)
     * // ↑ 
     * // [
     * //    Entry { keyElement: 0, valueElement: 1 },
     * //    Entry { keyElement: 1, valueElement: 2 },
     * //    Entry { keyElement: 2, valueElement: 3 },
     * //    Entry { keyElement: 3, valueElement: 4 },
     * //    Entry { keyElement: 4, valueElement: 5 }
     * // ]
     *
     * // Case 4 -- KoconutMap
     * const koconutMap = KoconutArray.of(1,2,3,4,5)
     *                           .associate(eachNumber => [eachNumber, eachNumber])
     *
     * const mapToFlow = await koconutMap
     *                           .asFlow()
     *                           .yield()
     * console.log(mapToFlow.dataArray)
     * // ↑ 
     * // [
     * //    Entry { keyElement: 1, valueElement: 1 },
     * //    Entry { keyElement: 2, valueElement: 2 },
     * //    Entry { keyElement: 3, valueElement: 3 },
     * //    Entry { keyElement: 4, valueElement: 4 },
     * //    Entry { keyElement: 5, valueElement: 5 }
     * // ]
     * ```
     */

    /*
     asFlow() : KoconutFlow<CombinedDataType> {
         const koconutToReturn = new KoconutFlow<CombinedDataType>();
        (koconutToReturn as any as KoconutOpener<Flow<CombinedDataType>>)
            .setPrevYieldable(this)
            .setProcessor(async () => {
                return Flow.fromSimple(this.combinedDataWrapper)
            })
        return koconutToReturn
     }
    */
    // Inspector

    /**
     * Return ```true``` if all elements match te given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Inspector
     * 
     * @example
     * ``` typescript
     *   // Case 1 -- KoconutArray
     *   const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     *   const areAllArrayElementsGreaterThan0 = await koconutArray
     *                                           .all(eachNumber => eachNumber > 0)
     *                                           .yield()
     *   console.log(areAllArrayElementsGreaterThan0)
     *   // ↑ true
     *
     *   const areAllArrayElementsEven = await koconutArray
     *                                   .all(eachNumber => eachNumber % 2 == 0)
     *                                   .yield()
     *   console.log(areAllArrayElementsEven)
     *   // ↑ false -- i.e. '1' is not an even number.
     *
     *
     *   // Case 2 -- KoconutSet
     *   const koconutSet = KoconutSet.of(1,2,3,4,5)
     *   
     *   const areAllSetElementsGreaterThan0 = await koconutSet
     *                                           .all(eachNumber => eachNumber > 0)
     *                                           .yield()
     *   console.log(areAllSetElementsGreaterThan0)
     *   // ↑ true
     *
     *   const areAllSetElementsOdd = await koconutSet
     *                                   .all(eachNumber => eachNumber % 2 == 1)
     *                                   .yield()
     *   console.log(areAllSetElementsOdd)
     *   // ↑ false -- i.e. '2' is not an odd number.
     *
     *
     *   // Case 3 -- KoconutMap
     *   const koconutMap = KoconutMap.of(
     *       [0, 0],
     *       [1, 1],
     *       [2, 2]
     *   )
     *
     *   const areAllMapEntriesKeyEqualsToValue = await koconutMap
     *                                          .all(eachEntry => eachEntry.key == eachEntry.value)
     *                                          .yield()
     *   console.log(areAllMapEntriesKeyEqualsToValue)
     *   // ↑ true
     *
     *   const areAllMapEntriesSumGreaterThan3 = await koconutMap
     *                                         .all(eachEntry => eachEntry.key + eachEntry.value > 3)
     *                                         .yield()
     *   console.log(areAllMapEntriesSumGreaterThan3)
     *   // ↑ false -- i.e. Sum of key and value of first Entry { 0, 0 } is 0. 
     *   // It's definetly less than 3
     * 
     *   // Case 4 -- You can also do it asynchronously
     *   const koconutArray2 = KoconutArray.of(1,2,3,4,5)
     *
     *   const areAllArrayElementsLessThan10 = await koconutArray2
     *                                       .all(async eachNumber => eachNumber < 10)
     *                                       .yield()
     *   console.log(areAllArrayElementsLessThan10)
     *   // ↑ true
     *
     *   const areAllArrayElementsOdd = await koconutArray2
     *                                   .all(eachNumber => new Promise(resolve => {
     *                                       resolve(eachNumber % 2 == 1)
     *                                   }))
     *                                   .yield()
     *   console.log(areAllArrayElementsOdd)
     *   // ↑ false -- i.e. '2' is not an odd number.
     * ```
     */

  }, {
    key: "all",
    value: function all(predicate) {
      var _this21 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      predicate = predicate.bind(thisArg);
      var koconutToReturn = new _module.KoconutBoolean();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee20() {
        var _iterator18, _step18, eachCombinedDatum;

        return _regenerator["default"].wrap(function _callee20$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                if (!(_this21.combinedDataWrapper == null)) {
                  _context20.next = 2;
                  break;
                }

                return _context20.abrupt("return", false);

              case 2:
                _iterator18 = _createForOfIteratorHelper(_this21.combinedDataWrapper);
                _context20.prev = 3;

                _iterator18.s();

              case 5:
                if ((_step18 = _iterator18.n()).done) {
                  _context20.next = 13;
                  break;
                }

                eachCombinedDatum = _step18.value;
                _context20.next = 9;
                return predicate(eachCombinedDatum);

              case 9:
                if (_context20.sent) {
                  _context20.next = 11;
                  break;
                }

                return _context20.abrupt("return", false);

              case 11:
                _context20.next = 5;
                break;

              case 13:
                _context20.next = 18;
                break;

              case 15:
                _context20.prev = 15;
                _context20.t0 = _context20["catch"](3);

                _iterator18.e(_context20.t0);

              case 18:
                _context20.prev = 18;

                _iterator18.f();

                return _context20.finish(18);

              case 21:
                return _context20.abrupt("return", true);

              case 22:
              case "end":
                return _context20.stop();
            }
          }
        }, _callee20, null, [[3, 15, 18, 21]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns ```true``` if the collection has at least one element matches the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Inspector
     * 
     * @example
     * ``` typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const isAnyArrayElementGreaterThan4 = await koconutArray
     *                                           .any(eachNumber => eachNumber > 4)
     *                                           .yield()
     * console.log(isAnyArrayElementGreaterThan4)
     * // ↑ true -- i.e. '5' is greater than 4.
     *
     * const isAnyArrayElementMultipleOf6 = await koconutArray
     *                                           .any(eachNumber => eachNumber % 6 == 0)
     *                                           .yield()
     * console.log(isAnyArrayElementMultipleOf6)
     * // ↑ false
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const isAnySetElementGreaterThan3 = await koconutSet
     *                                           .any(eachNumber => eachNumber > 3)
     *                                           .yield()
     * console.log(isAnySetElementGreaterThan3)
     * // ↑ true -- i.e. '4' is greater than 3.
     *
     * const isAnySetElementLessThan0 = await koconutSet
     *                                       .any(eachNumber => eachNumber < 0)
     *                                       .yield()
     * console.log(isAnySetElementLessThan0)
     * // ↑ false
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutMap.of(
     *   [0, 0],
     *   [1, 1],
     *   [2, 2]
     * )
     *
     * const isAnyMapEntrySumGreaterThan3 = await koconutMap
     *                                        .any(eachEntry => eachEntry.key + eachEntry.value > 3)
     *                                        .yield()
     * console.log(isAnyMapEntrySumGreaterThan3)
     * // ↑ true -- i.e. Sum of key and value of third Entry { 2, 2 } is 4.
     * // It's grater than 4.
     * 
     * const isAnyMapEntryKeyMultipleOf4 = await koconutMap
     *                                  .any(eachEntry => eachEntry.key > 0 && eachEntry.key % 4 == 0)
     *                                  .yield()
     * console.log(isAnyMapEntryKeyMultipleOf4)
     * // ↑ false
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(1,2,3,4,5)
     * 
     * const isAnyArrayElementLessThan2 = await koconutArray2
     *                                   .any(async eachNumber => eachNumber < 2)
     *                                   .yield()
     * console.log(isAnyArrayElementLessThan2)
     * // ↑ true -- i.e. '1' is less than 2.
     *
     * const isAnyArrayElementGreaterThan7 = await koconutArray2
     *                                       .any(eachNumber => new Promise(resolve => {
     *                                           resolve(eachNumber > 7)
     *                                       }))
     *                                       .yield()
     * console.log(isAnyArrayElementGreaterThan7)
     * // ↑ false
     * ```
     */

  }, {
    key: "any",
    value: function any(predicate) {
      var _this22 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      predicate = predicate.bind(thisArg);
      var koconutToReturn = new _module.KoconutBoolean();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee21() {
        var _iterator19, _step19, eachCombinedDatum;

        return _regenerator["default"].wrap(function _callee21$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                if (!(_this22.combinedDataWrapper == null)) {
                  _context21.next = 2;
                  break;
                }

                return _context21.abrupt("return", false);

              case 2:
                _iterator19 = _createForOfIteratorHelper(_this22.combinedDataWrapper);
                _context21.prev = 3;

                _iterator19.s();

              case 5:
                if ((_step19 = _iterator19.n()).done) {
                  _context21.next = 13;
                  break;
                }

                eachCombinedDatum = _step19.value;
                _context21.next = 9;
                return predicate(eachCombinedDatum);

              case 9:
                if (!_context21.sent) {
                  _context21.next = 11;
                  break;
                }

                return _context21.abrupt("return", true);

              case 11:
                _context21.next = 5;
                break;

              case 13:
                _context21.next = 18;
                break;

              case 15:
                _context21.prev = 15;
                _context21.t0 = _context21["catch"](3);

                _iterator19.e(_context21.t0);

              case 18:
                _context21.prev = 18;

                _iterator19.f();

                return _context21.finish(18);

              case 21:
                return _context21.abrupt("return", false);

              case 22:
              case "end":
                return _context21.stop();
            }
          }
        }, _callee21, null, [[3, 15, 18, 21]]);
      })));
      return koconutToReturn;
    }
    /**
     * Returns ```true``` if the collection is empty (contains no elements), ```false``` otherwise.
     * 
     * @since 1.0.10
     * 
     * @category Inspector
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const isNumberArrayEmpty = await koconutArray
     *                           .isEmpty()
     *                           .yield()
     * console.log(isNumberArrayEmpty)
     * // ↑ false
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const isFilteredNumberSetEmpty = await koconutSet
     *                           .filter(eachNumber => eachNumber > 10)
     *                           .isEmpty()
     *                           .yield()
     * console.log(isFilteredNumberSetEmpty)
     * // ↑ true
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = new KoconutMap<number, number>()
     *
     * const isNumberPairedMapEmpty = await koconutMap
     *                                   .isEmpty()
     *                                   .yield()
     * console.log(isNumberPairedMapEmpty)
     * // ↑ true
     * ```
     */

  }, {
    key: "isEmpty",
    value: function isEmpty() {
      var _this23 = this;

      var koconutToReturn = new _module.KoconutBoolean();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee22() {
        return _regenerator["default"].wrap(function _callee22$(_context22) {
          while (1) {
            switch (_context22.prev = _context22.next) {
              case 0:
                return _context22.abrupt("return", _this23.combinedDataWrapper != null && _this23.mSize == 0);

              case 1:
              case "end":
                return _context22.stop();
            }
          }
        }, _callee22);
      })));
      return koconutToReturn;
    }
    /**
     * Returns ```true``` if the collection is not empty.
     * 
     * @since 1.0.10
     * 
     * @category Inspector
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const isNumberArrayEmpty = await koconutArray
     *                           .isNotEmpty()
     *                           .yield()
     * console.log(isNumberArrayEmpty)
     * // ↑ true
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const isFilteredNumberSetEmpty = await koconutSet
     *                           .filter(eachNumber => eachNumber > 10)
     *                           .isNotEmpty()
     *                           .yield()
     * console.log(isFilteredNumberSetEmpty)
     * // ↑ false
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = new KoconutMap<number, number>()
     *
     * const isNumberPairedMapEmpty = await koconutMap
     *                                   .isNotEmpty()
     *                                   .yield()
     * console.log(isNumberPairedMapEmpty)
     * // ↑ false
     * ```
     */

  }, {
    key: "isNotEmpty",
    value: function isNotEmpty() {
      var _this24 = this;

      var koconutToReturn = new _module.KoconutBoolean();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee23() {
        return _regenerator["default"].wrap(function _callee23$(_context23) {
          while (1) {
            switch (_context23.prev = _context23.next) {
              case 0:
                return _context23.abrupt("return", _this24.mSize != 0);

              case 1:
              case "end":
                return _context23.stop();
            }
          }
        }, _callee23);
      })));
      return koconutToReturn;
    }
    /**
     * Returns ```true``` if this nullable collection is either null or empty.
     * 
     * @since 1.0.10
     * @deprecated Use {@link isEmpty} instead. 
     * @until 1.3.0
     * 
     * @category Inspector
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const isNumberArrayEmpty = await koconutArray
     *                           .isNullOrEmpty()
     *                           .yield()
     * console.log(isNumberArrayEmpty)
     * // ↑ false
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const isFilteredNumberSetEmpty = await koconutSet
     *                           .filter(eachNumber => eachNumber > 10)
     *                           .isNullOrEmpty()
     *                           .yield()
     * console.log(isFilteredNumberSetEmpty)
     * // ↑ true
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = new KoconutMap<number, number>()
     *
     * const isNumberPairedMapEmpty = await koconutMap
     *                                   .isNullOrEmpty()
     *                                   .yield()
     * console.log(isNumberPairedMapEmpty)
     * // ↑ true
     * ``` 
     */

  }, {
    key: "isNullOrEmpty",
    value: function isNullOrEmpty() {
      var _this25 = this;

      _module.KoconutDeprecation.showDeprecationWarning("1.3.0", this.isEmpty);

      var koconutToReturn = new _module.KoconutBoolean();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee24() {
        return _regenerator["default"].wrap(function _callee24$(_context24) {
          while (1) {
            switch (_context24.prev = _context24.next) {
              case 0:
                return _context24.abrupt("return", _this25.combinedDataWrapper == null || _this25.mSize == 0);

              case 1:
              case "end":
                return _context24.stop();
            }
          }
        }, _callee24);
      })));
      return koconutToReturn;
    }
    /**
     * ```predicate``` callback function is optional. If it's omitted the method returns ```true``` if the collection has no elements.
     * Otherwise, returns ```true``` if no elements match the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Inspector
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = new KoconutArray<number>()
     *
     * const isNoneOfAnEmptyArray = await koconutArray
     *                                   .none()
     *                                   .yield()
     * console.log(isNoneOfAnEmptyArray)
     * // ↑ true
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const isNoneOfSetElementGreaterThan10 = await koconutSet
     *                                       .none(eachNumber => eachNumber >= 10)
     *                                       .yield()
     * console.log(isNoneOfSetElementGreaterThan10)
     * // ↑ true
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of(1,2,3,4,5)
     *                   .associateWith(eachNumber => eachNumber * 2)
     *
     * const isNoneOfEntryOfMapHasLessThan3DifferenceBetweenKeyAndValue
     *                       = await koconutMap
     *                           .none(eachEntry => eachEntry.value - eachEntry.key <= 3)
     *                           .yield()
     * console.log(isNoneOfEntryOfMapHasLessThan3DifferenceBetweenKeyAndValue)
     * // ↑ false
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(1,2,3,4,5)
     *
     * const isNoneOfArrayElementGreaterThan3 = await koconutArray2
     *                                   .none(async eachNumber => eachNumber >= 3)
     *                                   .yield()
     * console.log(isNoneOfArrayElementGreaterThan3)
     * // ↑ false
     *
     * const isNoneOfArrayelementLessThan0 = await koconutArray2
     *                   .none(eachNumber => new Promise(resolve => {
     *                       resolve(eachNumber <= 0)
     *                   }))
     *                   .yield()
     * console.log(isNoneOfArrayelementLessThan0)
     * // ↑ true
     * ```
     */

  }, {
    key: "none",
    value: function none() {
      var _this26 = this;

      var predicate = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      if (predicate) predicate = predicate.bind(thisArg);
      var koconutToReturn = new _module.KoconutBoolean();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee25() {
        var _iterator20, _step20, eachCombinedDatum;

        return _regenerator["default"].wrap(function _callee25$(_context25) {
          while (1) {
            switch (_context25.prev = _context25.next) {
              case 0:
                if (!(_this26.combinedDataWrapper == null || _this26.mSize == 0)) {
                  _context25.next = 2;
                  break;
                }

                return _context25.abrupt("return", true);

              case 2:
                if (!predicate) {
                  _context25.next = 23;
                  break;
                }

                _iterator20 = _createForOfIteratorHelper(_this26.combinedDataWrapper);
                _context25.prev = 4;

                _iterator20.s();

              case 6:
                if ((_step20 = _iterator20.n()).done) {
                  _context25.next = 14;
                  break;
                }

                eachCombinedDatum = _step20.value;
                _context25.next = 10;
                return predicate(eachCombinedDatum);

              case 10:
                if (!_context25.sent) {
                  _context25.next = 12;
                  break;
                }

                return _context25.abrupt("return", false);

              case 12:
                _context25.next = 6;
                break;

              case 14:
                _context25.next = 19;
                break;

              case 16:
                _context25.prev = 16;
                _context25.t0 = _context25["catch"](4);

                _iterator20.e(_context25.t0);

              case 19:
                _context25.prev = 19;

                _iterator20.f();

                return _context25.finish(19);

              case 22:
                return _context25.abrupt("return", true);

              case 23:
                return _context25.abrupt("return", false);

              case 24:
              case "end":
                return _context25.stop();
            }
          }
        }, _callee25, null, [[4, 16, 19, 22]]);
      })));
      return koconutToReturn;
    } // Iterator

    /**
     * Performs the given ```action``` on each element.
     * When you want to stop iteration in the meantime ```return``` ```false``` or {@link KoconutLoopSignal.BREAK}.
     * @param action A callback function that accepts an argument. The method calls the ```action``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```action```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Iterator
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5,6,7)
     * await koconutArray
     *   .forEach(console.log)
     *   // ↑ 1 2 3 4 5 6 7  -- i.e. This will print out each number
     *   .process()
     *
     * await koconutArray
     *   .forEach(eachNumber => {
     *       if(eachNumber > 4) return KoconutLoopSignal.BREAK
     *       console.log(eachNumber)
     *   })
     *   // ↑ 1 2 3 4  -- i.e. Since '5', it is greater than 4, so the loop is broken.
     *   .process()
     *
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of(1,2,3,1,2,3)
     *
     * await koconutSet
     *   .forEach(console.log)
     *   // ↑ 1 2 3 -- i.e. All conflicted numbers will be ignored.
     *   .process()
     *
     * await koconutSet
     *   .forEach(eachNumber => {
     *       if(eachNumber % 2 == 0) return false
     *       console.log(eachNumber)
     *   })
     *   // ↑ 1 -- i.e. Since '2', it is an even number, so the loop is broken.
     *   .process()
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of(1,2,3)
     *                   .associateWith(eachElement => eachElement)
     *
     * await koconutMap
     *   .forEach(console.log)
     *   // ↑ 
     *   // Entry { keyElement: 1, valueElement: 1 }
     *   // Entry { keyElement: 2, valueElement: 2 }
     *   // Entry { keyElement: 3, valueElement: 3 }
     *   .process()
     *   
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(1,2,3)
     *    
     * await koconutArray2
     *   .forEach(async eachNumber => console.log(eachNumber))
     *   // ↑ 1 2 3
     *   .process()
     *
     * await koconutArray2
     *   .forEach(eachNumber => new Promise(resolve => resolve(console.log(eachNumber))))
     *   // ↑ 1 2 3
     *   .process()
     * ```
     */

  }, {
    key: "forEach",
    value: function forEach(action) {
      var _this27 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      action = action.bind(thisArg);
      var koconutToReturn = new _module.KoconutPrimitive();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee26() {
        var _iterator21, _step21, eachCombinedDatum, signal;

        return _regenerator["default"].wrap(function _callee26$(_context26) {
          while (1) {
            switch (_context26.prev = _context26.next) {
              case 0:
                if (!(_this27.combinedDataWrapper != null)) {
                  _context26.next = 21;
                  break;
                }

                _iterator21 = _createForOfIteratorHelper(_this27.combinedDataWrapper);
                _context26.prev = 2;

                _iterator21.s();

              case 4:
                if ((_step21 = _iterator21.n()).done) {
                  _context26.next = 13;
                  break;
                }

                eachCombinedDatum = _step21.value;
                _context26.next = 8;
                return action(eachCombinedDatum);

              case 8:
                signal = _context26.sent;

                if (!(signal == false || signal == _module.KoconutLoopSignal.BREAK)) {
                  _context26.next = 11;
                  break;
                }

                return _context26.abrupt("break", 13);

              case 11:
                _context26.next = 4;
                break;

              case 13:
                _context26.next = 18;
                break;

              case 15:
                _context26.prev = 15;
                _context26.t0 = _context26["catch"](2);

                _iterator21.e(_context26.t0);

              case 18:
                _context26.prev = 18;

                _iterator21.f();

                return _context26.finish(18);

              case 21:
              case "end":
                return _context26.stop();
            }
          }
        }, _callee26, null, [[2, 15, 18, 21]]);
      })));
      return koconutToReturn;
    } // No Comment - KoconutArray/KoconutSet/KoconutMap

  }, {
    key: "onEach",
    value: function onEach(action) {
      var _this28 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      action = action.bind(thisArg);
      var koconutToReturn = new KoconutIterable();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee27() {
        var _iterator22, _step22, eachCombinedDatum, signal;

        return _regenerator["default"].wrap(function _callee27$(_context27) {
          while (1) {
            switch (_context27.prev = _context27.next) {
              case 0:
                if (!(_this28.combinedDataWrapper != null)) {
                  _context27.next = 21;
                  break;
                }

                _iterator22 = _createForOfIteratorHelper(_this28.combinedDataWrapper);
                _context27.prev = 2;

                _iterator22.s();

              case 4:
                if ((_step22 = _iterator22.n()).done) {
                  _context27.next = 13;
                  break;
                }

                eachCombinedDatum = _step22.value;
                _context27.next = 8;
                return action(eachCombinedDatum);

              case 8:
                signal = _context27.sent;

                if (!(signal == false || signal == _module.KoconutLoopSignal.BREAK)) {
                  _context27.next = 11;
                  break;
                }

                return _context27.abrupt("break", 13);

              case 11:
                _context27.next = 4;
                break;

              case 13:
                _context27.next = 18;
                break;

              case 15:
                _context27.prev = 15;
                _context27.t0 = _context27["catch"](2);

                _iterator22.e(_context27.t0);

              case 18:
                _context27.prev = 18;

                _iterator22.f();

                return _context27.finish(18);

              case 21:
                return _context27.abrupt("return", _this28.data);

              case 22:
              case "end":
                return _context27.stop();
            }
          }
        }, _callee27, null, [[2, 15, 18, 21]]);
      })));
      return koconutToReturn;
    } // Manipulator
    // No Comment - KoconutArray/KoconutSet/KoconutMap

  }, {
    key: "filter",
    value: function filter(predicate) {
      var _this29 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      predicate = predicate.bind(thisArg);
      var koconutToReturn = new KoconutIterable();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee28() {
        var processedArray, _iterator23, _step23, eachCombinedDatum, processedMap;

        return _regenerator["default"].wrap(function _callee28$(_context28) {
          while (1) {
            switch (_context28.prev = _context28.next) {
              case 0:
                processedArray = new Array();

                if (!(_this29.combinedDataWrapper != null)) {
                  _context28.next = 21;
                  break;
                }

                _iterator23 = _createForOfIteratorHelper(_this29.combinedDataWrapper);
                _context28.prev = 3;

                _iterator23.s();

              case 5:
                if ((_step23 = _iterator23.n()).done) {
                  _context28.next = 13;
                  break;
                }

                eachCombinedDatum = _step23.value;
                _context28.next = 9;
                return predicate(eachCombinedDatum);

              case 9:
                if (!_context28.sent) {
                  _context28.next = 11;
                  break;
                }

                processedArray.push(eachCombinedDatum);

              case 11:
                _context28.next = 5;
                break;

              case 13:
                _context28.next = 18;
                break;

              case 15:
                _context28.prev = 15;
                _context28.t0 = _context28["catch"](3);

                _iterator23.e(_context28.t0);

              case 18:
                _context28.prev = 18;

                _iterator23.f();

                return _context28.finish(18);

              case 21:
                if (!(_this29.data instanceof Array)) {
                  _context28.next = 25;
                  break;
                }

                return _context28.abrupt("return", processedArray);

              case 25:
                if (!(_this29.data instanceof Set)) {
                  _context28.next = 29;
                  break;
                }

                return _context28.abrupt("return", new Set(processedArray));

              case 29:
                processedMap = new Map();
                processedArray.forEach(function (eachProcessedDatum) {
                  var eachEntry = eachProcessedDatum;
                  processedMap.set(eachEntry.key, eachEntry.value);
                });
                return _context28.abrupt("return", processedMap);

              case 32:
              case "end":
                return _context28.stop();
            }
          }
        }, _callee28, null, [[3, 15, 18, 21]]);
      })));
      return koconutToReturn;
    } // No Comment - KoconutArray/KoconutSet/KoconutMap

  }, {
    key: "filterNot",
    value: function filterNot(predicate) {
      var _this30 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      predicate = predicate.bind(thisArg);
      var koconutToReturn = new KoconutIterable();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee29() {
        var processedArray, _iterator24, _step24, eachCombinedDatum, processedMap;

        return _regenerator["default"].wrap(function _callee29$(_context29) {
          while (1) {
            switch (_context29.prev = _context29.next) {
              case 0:
                processedArray = new Array();

                if (!(_this30.combinedDataWrapper != null)) {
                  _context29.next = 21;
                  break;
                }

                _iterator24 = _createForOfIteratorHelper(_this30.combinedDataWrapper);
                _context29.prev = 3;

                _iterator24.s();

              case 5:
                if ((_step24 = _iterator24.n()).done) {
                  _context29.next = 13;
                  break;
                }

                eachCombinedDatum = _step24.value;
                _context29.next = 9;
                return predicate(eachCombinedDatum);

              case 9:
                if (_context29.sent) {
                  _context29.next = 11;
                  break;
                }

                processedArray.push(eachCombinedDatum);

              case 11:
                _context29.next = 5;
                break;

              case 13:
                _context29.next = 18;
                break;

              case 15:
                _context29.prev = 15;
                _context29.t0 = _context29["catch"](3);

                _iterator24.e(_context29.t0);

              case 18:
                _context29.prev = 18;

                _iterator24.f();

                return _context29.finish(18);

              case 21:
                if (!(_this30.data instanceof Array)) {
                  _context29.next = 25;
                  break;
                }

                return _context29.abrupt("return", processedArray);

              case 25:
                if (!(_this30.data instanceof Set)) {
                  _context29.next = 29;
                  break;
                }

                return _context29.abrupt("return", new Set(processedArray));

              case 29:
                processedMap = new Map();
                processedArray.forEach(function (eachProcessedDatum) {
                  var eachEntry = eachProcessedDatum;
                  processedMap.set(eachEntry.key, eachEntry.value);
                });
                return _context29.abrupt("return", processedMap);

              case 32:
              case "end":
                return _context29.stop();
            }
          }
        }, _callee29, null, [[3, 15, 18, 21]]);
      })));
      return koconutToReturn;
    } // Transformer

    /**
     * Returns a single list of all elements yielded from results of ```transform``` function being invoked on each element of original collection.
     * @param transform A callback function that accepts an argument. The method calls the ```transform``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of("123", "45")
     *
     * const allNumberInArray = await koconutArray
     *                           .flatMap(eachString => eachString)
     *                           // ↑ The string itself can be used as Iterable<string>.
     *                           // If you want to make it clear, also possible to type
     *                           // as eachString => eachString.split('')
     *                           .map(parseInt)
     *                           .yield()
     * console.log(allNumberInArray)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     *
     * // Case 2 - KoconutSet
     * const koconutSet = KoconutSet.of("abc", "de")
     *
     * const allCharactersInSet = await koconutSet
     *                           .flatMap(eachString => eachString)
     *                           .yield()
     * console.log(allCharactersInSet)
     * // ↑ [ 'a', 'b', 'c', 'd', 'e' ]
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of(1,2,3,4,5)
     *                   .associateWith(eachNumber => eachNumber * 2)
     *
     * const allKeysAndValuesInMap = await koconutMap
     *                               .flatMap(eachEntry => [eachEntry.key, eachEntry.value])
     *                               .yield()
     * console.log(allKeysAndValuesInMap)
     * // ↑ [1, 2, 2, 4, 3, 6, 4, 8, 5, 10]
     *
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(123, 987)
     *
     * const allDigitsInArray = await koconutArray2
     *                               .flatMap(async eachNumber => {
     *                                   const digits = new Array<number>()
     *                                   while(eachNumber != 0) {
     *                                       digits.unshift(eachNumber % 10)
     *                                       eachNumber = Math.floor(eachNumber / 10)
     *                                   }
     *                                   return digits
     *                               })
     *                               .yield()
     * console.log(allDigitsInArray)
     * // ↑ [ 1, 2, 3, 9, 8, 7 ]
     *
     * const allNumberCharactersInArray = await koconutArray2
     *                                       .flatMap(eachNumber => new Promise<string>(resolve => {
     *                                           resolve(eachNumber.toString())
     *                                       }))
     *                                       .yield()
     * console.log(allNumberCharactersInArray)
     * // ↑ [ '1', '2', '3', '9', '8', '7' ]
     * ```
     */

  }, {
    key: "flatMap",
    value: function flatMap(transform) {
      var _this31 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      transform = transform.bind(thisArg);
      var koconutToReturn = new _module.KoconutArray();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee30() {
        var processedArray, _iterator25, _step25, eachCombinedDatum, _iterator26, _step26, eachSubElement;

        return _regenerator["default"].wrap(function _callee30$(_context30) {
          while (1) {
            switch (_context30.prev = _context30.next) {
              case 0:
                processedArray = new Array();

                if (!(_this31.combinedDataWrapper != null)) {
                  _context30.next = 23;
                  break;
                }

                _iterator25 = _createForOfIteratorHelper(_this31.combinedDataWrapper);
                _context30.prev = 3;

                _iterator25.s();

              case 5:
                if ((_step25 = _iterator25.n()).done) {
                  _context30.next = 15;
                  break;
                }

                eachCombinedDatum = _step25.value;
                _context30.t0 = _createForOfIteratorHelper;
                _context30.next = 10;
                return transform(eachCombinedDatum);

              case 10:
                _context30.t1 = _context30.sent;
                _iterator26 = (0, _context30.t0)(_context30.t1);

                try {
                  for (_iterator26.s(); !(_step26 = _iterator26.n()).done;) {
                    eachSubElement = _step26.value;
                    processedArray.push(eachSubElement);
                  }
                } catch (err) {
                  _iterator26.e(err);
                } finally {
                  _iterator26.f();
                }

              case 13:
                _context30.next = 5;
                break;

              case 15:
                _context30.next = 20;
                break;

              case 17:
                _context30.prev = 17;
                _context30.t2 = _context30["catch"](3);

                _iterator25.e(_context30.t2);

              case 20:
                _context30.prev = 20;

                _iterator25.f();

                return _context30.finish(20);

              case 23:
                return _context30.abrupt("return", processedArray);

              case 24:
              case "end":
                return _context30.stop();
            }
          }
        }, _callee30, null, [[3, 17, 20, 23]]);
      })));
      return koconutToReturn;
    } // No Comment - KoconutArray/KoconutSet/KoconutMap

  }, {
    key: "flatMapTo",
    value: function flatMapTo(destination, transform) {
      var _this32 = this;

      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      transform = transform.bind(thisArg);
      var koconutToReturn = new KoconutIterable();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee31() {
        var flattenIterable;
        return _regenerator["default"].wrap(function _callee31$(_context31) {
          while (1) {
            switch (_context31.prev = _context31.next) {
              case 0:
                flattenIterable = _this32.flatMap(transform, thisArg);

                if (!(destination instanceof Array)) {
                  _context31.next = 6;
                  break;
                }

                _context31.next = 4;
                return flattenIterable.forEach(function (eachElement) {
                  destination.push(eachElement);
                }).process();

              case 4:
                _context31.next = 8;
                break;

              case 6:
                _context31.next = 8;
                return flattenIterable.asSet().forEach(function (eachElement) {
                  destination.add(eachElement);
                }).process();

              case 8:
                return _context31.abrupt("return", _this32.data);

              case 9:
              case "end":
                return _context31.stop();
            }
          }
        }, _callee31);
      })));
      return koconutToReturn;
    }
    /**
     * Returns a list containing the results of applying the given ```transform``` function
     * to each element in the original collection.
     * @param transform A callback function that accepts an argument. The method calls the ```transform``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const doubledNumbersInArray = await koconutArray
     *                           .map(eachNumber => eachNumber * 2)
     *                           .yield()
     * console.log(doubledNumbersInArray)
     * // ↑ [ 2, 4, 6, 8, 10 ]
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const doubledNumbersInSet = await koconutSet
     *                           .map(eachNumber => eachNumber * 2)
     *                           .yield()
     * console.log(doubledNumbersInSet)
     * // ↑ [ 2, 4, 6, 8, 10 ]
     *
     * // Case 3 -- KoconutMap
     * const koconutMap = KoconutArray.of(1,2,3,4,5)
     *                   .associate(eachNumber => [eachNumber, eachNumber * 2])
     *
     * const keyValueSumOfMap = await koconutMap
     *                       .map(eachEntry => eachEntry.key + eachEntry.value)
     *                       .yield()
     * console.log(keyValueSumOfMap)
     * // ↑ [ 3, 6, 9, 12, 15 ]
     *
     * // Case 4 -- You can also do it asynchronously
     * const koconutArray2 = KoconutArray.of(1,2,3,4,5)
     *
     * const squaredNumberInArray = await koconutArray2
     *                           .map(async eachNumber => eachNumber * eachNumber)
     *                           .yield()
     * console.log(squaredNumberInArray)
     * // ↑ [ 1, 4, 9, 16, 25 ]
     *
     * const trippledNumbersInArray = await koconutArray2
     *                               .map(eachNumber => new Promise(resolve => {
     *                                   resolve(eachNumber * 3)
     *                               }))
     *                               .yield()
     * console.log(trippledNumbersInArray)
     * // ↑ [ 3, 6, 9, 12, 15 ]
     * ```
     */

  }, {
    key: "map",
    value: function map(transform) {
      var _this33 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      transform = transform.bind(thisArg);
      var koconutToReturn = new _module.KoconutArray();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee32() {
        var processedArray, _iterator27, _step27, eachCombinedDatum;

        return _regenerator["default"].wrap(function _callee32$(_context32) {
          while (1) {
            switch (_context32.prev = _context32.next) {
              case 0:
                processedArray = new Array();

                if (!(_this33.combinedDataWrapper != null)) {
                  _context32.next = 22;
                  break;
                }

                _iterator27 = _createForOfIteratorHelper(_this33.combinedDataWrapper);
                _context32.prev = 3;

                _iterator27.s();

              case 5:
                if ((_step27 = _iterator27.n()).done) {
                  _context32.next = 14;
                  break;
                }

                eachCombinedDatum = _step27.value;
                _context32.t0 = processedArray;
                _context32.next = 10;
                return transform(eachCombinedDatum);

              case 10:
                _context32.t1 = _context32.sent;

                _context32.t0.push.call(_context32.t0, _context32.t1);

              case 12:
                _context32.next = 5;
                break;

              case 14:
                _context32.next = 19;
                break;

              case 16:
                _context32.prev = 16;
                _context32.t2 = _context32["catch"](3);

                _iterator27.e(_context32.t2);

              case 19:
                _context32.prev = 19;

                _iterator27.f();

                return _context32.finish(19);

              case 22:
                return _context32.abrupt("return", processedArray);

              case 23:
              case "end":
                return _context32.stop();
            }
          }
        }, _callee32, null, [[3, 16, 19, 22]]);
      })));
      return koconutToReturn;
    } // No Comment -- KoconutArray/KoconutSet/KoconutMap

  }, {
    key: "mapTo",
    value: function mapTo(destination, transform) {
      var _this34 = this;

      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      transform = transform.bind(thisArg);
      var koconutToReturn = new KoconutIterable();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee33() {
        var mappedIterable;
        return _regenerator["default"].wrap(function _callee33$(_context33) {
          while (1) {
            switch (_context33.prev = _context33.next) {
              case 0:
                mappedIterable = _this34.map(transform, thisArg);

                if (!(destination instanceof Array)) {
                  _context33.next = 6;
                  break;
                }

                _context33.next = 4;
                return mappedIterable.forEach(function (eachElement) {
                  destination.push(eachElement);
                }).process();

              case 4:
                _context33.next = 8;
                break;

              case 6:
                _context33.next = 8;
                return mappedIterable.asSet().forEach(function (eachElement) {
                  destination.add(eachElement);
                }).process();

              case 8:
                return _context33.abrupt("return", _this34.data);

              case 9:
              case "end":
                return _context33.stop();
            }
          }
        }, _callee33);
      })));
      return koconutToReturn;
    }
    /**
     * Returns a list containing results that are not ```null``` nor ```undefined``` of applying
     * the given ```transfrom``` function to each element in the original collection. You can use this method as ```filter``` then ```map```.
     * @param transform A callback function that accepts an argument. The method calls the ```transform``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * // Case 1 -- KoconutArray
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const squaredOddNumbersInArray = await koconutArray
     *                       .mapNotNull(eachNumber => {
     *                           if(eachNumber % 2 == 1)
     *                               return eachNumber * eachNumber
     *                           // return
     *                           // return null
     *                           // return undefined
     *                           // ↑ You can use any one of
     *                           //   them or just omit it.
     *                       })
     *                       .yield()
     * console.log(squaredOddNumbersInArray)
     * // ↑ [ 1, 9, 25 ]
     *
     * // Case 2 -- KoconutSet
     * const koconutSet = KoconutSet.of("1", "54", "26", "5")
     *
     * const twoDigitsNumbersInSet = await koconutSet
     *                       .mapNotNull(eachString => {
     *                           if(eachString.length == 2)
     *                               return parseInt(eachString)
     *                       })
     *                       .yield()
     * console.log(twoDigitsNumbersInSet)
     * // ↑ [ 54, 26 ]
     *
     * // Case 3 -- KoconutMap
     * const KoconutMap = KoconutArray.of(1,2,3,4,5)
     *               .associate(eachNumber => [eachNumber, eachNumber * 2])
     *
     * const oddKeyKeyValueSumInMap = await KoconutMap
     *                       .mapNotNull(eachEntry => {
     *                           if(eachEntry.key % 2 == 1)
     *                               return eachEntry.key + eachEntry.value
     *                       })
     *                       .yield()
     * console.log(oddKeyKeyValueSumInMap)
     * // ↑ [ 3, 9, 15 ]
     *
     * // Case 4 -- You can also do it asynchronously
     * const koocnutArray2 = KoconutArray.of(1,2,3,4,5)
     *
     * const squaredEvenNumbersInArray = await koocnutArray2
     *                           .mapNotNull(async eachNumber => {
     *                               if(eachNumber % 2 == 0)
     *                                   return eachNumber * eachNumber
     *                           })
     *                           .yield()
     * console.log(squaredEvenNumbersInArray)
     * // ↑ [ 4, 16 ]
     *
     * const doubledOddNumbersInArray = await koocnutArray2
     *                       .mapNotNull(eachNumber => new Promise<number | null>(resolve => {
     *                           if(eachNumber % 2 == 1)
     *                               resolve(eachNumber * 2)
     *                           else resolve(null)
     *                       }))
     *                       .yield()
     * console.log(doubledOddNumbersInArray)
     * // ↑ [ 2, 6, 10 ]
     * ```
     */

  }, {
    key: "mapNotNull",
    value: function mapNotNull(transform) {
      var _this35 = this;

      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      transform = transform.bind(thisArg);
      var koconutToReturn = new _module.KoconutArray();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee34() {
        var processedArray, _iterator28, _step28, eachCombinedDatum, dataToAdd;

        return _regenerator["default"].wrap(function _callee34$(_context34) {
          while (1) {
            switch (_context34.prev = _context34.next) {
              case 0:
                processedArray = new Array();

                if (!(_this35.combinedDataWrapper != null)) {
                  _context34.next = 21;
                  break;
                }

                _iterator28 = _createForOfIteratorHelper(_this35.combinedDataWrapper);
                _context34.prev = 3;

                _iterator28.s();

              case 5:
                if ((_step28 = _iterator28.n()).done) {
                  _context34.next = 13;
                  break;
                }

                eachCombinedDatum = _step28.value;
                _context34.next = 9;
                return transform(eachCombinedDatum);

              case 9:
                dataToAdd = _context34.sent;
                if (dataToAdd != null && dataToAdd != undefined) processedArray.push(dataToAdd);

              case 11:
                _context34.next = 5;
                break;

              case 13:
                _context34.next = 18;
                break;

              case 15:
                _context34.prev = 15;
                _context34.t0 = _context34["catch"](3);

                _iterator28.e(_context34.t0);

              case 18:
                _context34.prev = 18;

                _iterator28.f();

                return _context34.finish(18);

              case 21:
                return _context34.abrupt("return", processedArray);

              case 22:
              case "end":
                return _context34.stop();
            }
          }
        }, _callee34, null, [[3, 15, 18, 21]]);
      })));
      return koconutToReturn;
    } // No Comment -- KoconutArray/KoconutSet/KoconutMap

  }, {
    key: "mapNotNullTo",
    value: function mapNotNullTo(destination, transform) {
      var _this36 = this;

      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      transform = transform.bind(thisArg);
      var koconutToReturn = new KoconutIterable();
      koconutToReturn.setPrevYieldable(this).setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee35() {
        var mappedIterable;
        return _regenerator["default"].wrap(function _callee35$(_context35) {
          while (1) {
            switch (_context35.prev = _context35.next) {
              case 0:
                mappedIterable = _this36.mapNotNull(transform, thisArg);

                if (!(destination instanceof Array)) {
                  _context35.next = 6;
                  break;
                }

                _context35.next = 4;
                return mappedIterable.forEach(function (eachElement) {
                  destination.push(eachElement);
                }).process();

              case 4:
                _context35.next = 8;
                break;

              case 6:
                _context35.next = 8;
                return mappedIterable.asSet().forEach(function (eachElement) {
                  destination.add(eachElement);
                }).process();

              case 8:
                return _context35.abrupt("return", _this36.data);

              case 9:
              case "end":
                return _context35.stop();
            }
          }
        }, _callee35);
      })));
      return koconutToReturn;
    }
  }]);
  return KoconutIterable;
}(_module.KoconutPrimitive);

exports.KoconutIterable = KoconutIterable;