import { Pair, KoconutBoolean, KoconutPrimitive, KoconutEquatable } from "../../../module.internal";
export declare class Entry<KeyType, ValueType> implements KoconutEquatable {
    private keyElement;
    private valueElement;
    static from<KeyType, ValueType>(entry: [KeyType, ValueType]): Entry<KeyType, ValueType>;
    constructor(keyElement: KeyType, valueElement: ValueType);
    get key(): KeyType;
    get value(): ValueType;
    toString(): string;
    toArray(): Array<KeyType | ValueType>;
    toPair(): Pair<KeyType, ValueType>;
    equalsTo(other: Entry<KeyType, ValueType>): boolean | KoconutBoolean;
}
export declare class KoconutEntry<KeyType, ValueType> extends KoconutPrimitive<Entry<KeyType, ValueType>> implements KoconutEquatable {
    constructor(key?: KeyType | null, value?: ValueType | null);
    retrieve(): Promise<KoconutEntry<KeyType, ValueType>>;
    equalsTo(other: KoconutEntry<KeyType, ValueType>): boolean | KoconutBoolean;
}
