"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.KoconutArray = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _module = require("../../../../module.internal");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

"use strict";

var KoconutArray = /*#__PURE__*/function (_KoconutCollection) {
  (0, _inherits2["default"])(KoconutArray, _KoconutCollection);

  var _super = _createSuper(KoconutArray);

  (0, _createClass2["default"])(KoconutArray, null, [{
    key: "fromCollection",
    // Private
    value: function fromCollection(collection) {
      var koconutToReturn = new KoconutArray(collection['data']);
      koconutToReturn.processor = collection['processor'];
      koconutToReturn.prevYieldable = collection['prevYieldable'];
      return koconutToReturn;
    } // Koconut Primitive

    /**
     * Creates a new instance from ```iterable``` object.
     * @param array An array-like ```iterable``` object to convert to a {@link KoconutArray}.
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * const numbers = Array.of(1,2,3,4,5)
     * const koconutNumbers = new KoconutArray(numbers)
     * // ↑ This is a Koconut number array consists of 1 to 5.
     * 
     * const emptyNumberArray = new KoconutArray<number>()
     * // ↑ This is an empty Koconut number array.
     * ```
     */

  }]);

  function KoconutArray() {
    var _this;

    var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
    (0, _classCallCheck2["default"])(this, KoconutArray);
    _this = _super.call(this);
    _this.data = array == null ? new Array() : Array.from(array);
    return _this;
  }
  /**
   * Processes all the chained object and returns original {@link KoconutArray} instance.
   * 
   * @category Processor
   * 
   * @since 1.0.15
   * 
   * @example
   * ```typescript
   * const koconutArray = await KoconutArray
   *                     .of(1,2,3,4,5)
   *                     .retrieve()
   * console.log(koconutArray)
   * // ↑ KoconutArray {
   * //   isValidated: true,
   * //   data: [ 1, 2, 3, 4, 5 ],
   * //   combinedDataWrapper: [ 1, 2, 3, 4, 5 ],
   * //   mSize: 5,
   * //   mIndices: [ 0, 1, 2, 3, 4 ]
   * // }
   * ```
   */


  (0, _createClass2["default"])(KoconutArray, [{
    key: "retrieve",
    value: function () {
      var _retrieve = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "retrieve", this).call(this);

              case 2:
                return _context.abrupt("return", this);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function retrieve() {
        return _retrieve.apply(this, arguments);
      }

      return retrieve;
    }() // Creator

    /**
     * Creates a new instance from ```iterable``` object.
     * @param source An array-like ```iterable``` object to convert to a {@link KoconutArray}.
     * 
     * @category Creator
     * 
     * @since 1.0.11
     * 
     * @example
     * ```typescript
     * const numbers = Array.of(1,2,3,4,5)
     * const koconutNumbers = KoconutArray.from(numbers)
     * // ↑ This is a Koconut number array consists of 1 to 5.
     * 
     * const emptyNumberArray = KoconutArray.from<number>()
     * // ↑ This is an empty Koconut number array.
     * ```
     */

  }, {
    key: "onEach",
    // Iterator

    /**
     * Perfroms the given ```action``` on each element and returns the original collection itself afterwards.
     * When you want to stop iteration in the meantime ```return``` ```false``` or {@link KoconutLoopSignal.BREAK}.
     * @param action A callback function that accepts an argument. The method calls the ```action``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```action```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Iterator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const array = await koconutArray
     *                   .onEach(console.log)
     *                   // ↑ 1
     *                   //   2
     *                   //   3
     *                   //   4
     *                   //   5
     *                   .onEach(async eachNumber => {
     *                       if(eachNumber >= 3) return KoconutLoopSignal.BREAK
     *                       console.log(eachNumber)
     *                   })
     *                   // ↑ 1
     *                   //   2
     *                   .onEach(eachNumber => new Promise(resolve => {
     *                       if(eachNumber == 2) resolve(false)
     *                       else {
     *                           console.log(eachNumber)
     *                           resolve()
     *                       }
     *                   }))
     *                   // ↑ 1
     *                   .yield()
     * console.log(array)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     * ```
     */
    value: function onEach(action) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "onEach", this).call(this, action, thisArg));
    }
    /**
     * Performs the given ```action``` on each element, providing sequential index with the element, and returns the collection itself afterwards.
     * When you want to stop iteration in the meantime ```return``` ```false``` or {@link KoconutLoopSignal.BREAK}.
     * @param action A callback function that accepts two arguments. The method calls the ```action``` one time for each index and element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```action```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Iterator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const array = await koconutArray
     *                 .onEachIndexed(console.log)
     *                 // ↑ 0 1
     *                 //   1 2
     *                 //   2 3
     *                 //   3 4
     *                 //   4 5
     *                 .onEachIndexed(async (eachIndex, eachNumber) => {
     *                     if(eachIndex >= 2) return KoconutLoopSignal.BREAK
     *                     console.log(eachNumber)
     *                 })
     *                 // ↑ 1
     *                 //   2
     *                 .onEachIndexed((eachIndex, eachNumber) => new Promise(resolve => {
     *                     if(eachIndex == 2) resolve(false)
     *                     else {
     *                         console.log(eachNumber)
     *                         resolve()
     *                     }
     *                 }))
     *                 // ↑ 1
     *                 //   2
     *                 .yield()
     * console.log(array)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     * ```
     */

  }, {
    key: "onEachIndexed",
    value: function onEachIndexed(action) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "onEachIndexed", this).call(this, action, thisArg));
    } // Transformer

    /**
     * Populates the given ```destination``` map with entries, where ```key``` is provided by
     * ```keySelector``` function applied to each element.
     * ```valueTransform``` callback function is optional. If it's omitted, each value of entry
     * is same as the original data. Otherwise, the value is provided by the ```valueTransform``` function
     * applied to elements of the given collcetion.
     * @param destination Iterable destinaion. ```Map``` to be exact.
     * @param keySelector A callback function that accepts an argument. The method calls the ```keySelector``` one time for each element in object.
     * @param valueTransform A callback function that accepts an argument. The method calls the ```valueTransform``` one time for each element in object it it's not omitted.
     * @param keySelectorThisArg An object to which the ```this``` keyword can refer in the ```keySelector```. If ```keySelectorThisArg``` is omitted, ```null``` is used as the ```this``` value.
     * @param valueTransformThisArg An object to which the ```this``` keyword can refer in the ```valueTransform```. If ```valueTransformThisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @note This method has different functionality with Kotlin. It'll return the original collection instance.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const doubledKeyMap = new Map<number, number>()
     * const stringKeyDoubledValueMap = new Map<string ,number>()
     * const doubledKeySquaredValueMap = new Map<number, number>()
     * const originalData = await koconutArray
     *           .associateByTo(
     *               doubledKeyMap,
     *               eachNumber => eachNumber * 2
     *           )
     *           .associateByTo(
     *               stringKeyDoubledValueMap,
     *               async eachNumber => eachNumber.toString(),
     *               async eachNumber => eachNumber * 2
     *           )
     *           .associateByTo(
     *               doubledKeySquaredValueMap,
     *               eachNumber => new Promise(resolve => {
     *                   resolve(eachNumber * 2)
     *               }),
     *               eachNumber => new Promise(resolve => {
     *                   resolve(eachNumber * eachNumber)
     *               })
     *           )
     *           .yield()
     * console.log(doubledKeyMap)
     * // ↑ Map { 2 => 1, 4 => 2, 6 => 3, 8 => 4, 10 => 5 }
     * console.log(stringKeyDoubledValueMap)
     * // ↑ Map { '1' => 2, '2' => 4, '3' => 6, '4' => 8, '5' => 10 }
     * console.log(doubledKeySquaredValueMap)
     * // ↑ Map { 2 => 1, 4 => 4, 6 => 9, 8 => 16, 10 => 25 }
     * console.log(originalData)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     * ```
     */

  }, {
    key: "associateByTo",
    value: function associateByTo(destination, keySelector) {
      var valueTransform = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var keySelectorThisArg = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      var valueTransformThisArg = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "associateByTo", this).call(this, destination, keySelector, valueTransform, keySelectorThisArg, valueTransformThisArg));
    }
    /**
     * Populates the given ```destination``` map with entries, provided by ```transform``` function
     * applied to elements of the given collection
     * @param destination Iterable destinaion. ```Map``` to be exact.
     * @param transform A callback function that accepts an argument. The method calls the ```transform``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @note This method has different functionality with Kotlin. It'll return the original collection instance.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const doubledValueMap = new Map<number, number>()
     * const doubledKeyMap = new Map<number, number>()
     * const squaredValueMap = new Map<number, number>()
     * const originalData = await koconutArray
     *               .associateTo(
     *                   doubledValueMap,
     *                   eachNumber => [eachNumber, eachNumber * 2]
     *                   // ↑ Also can be
     *                   //   new Pair(eachNumber, eachNumber * 2)
     *                   //   Pair.from([eachNumber, eachNumber * 2])
     *                   //   new KoconutPair(eachNumber, eachNumber * 2)
     *                   //   new Entry(eachNumber, eachNumber * 2)
     *                   //   Entry.from([eachNumber, eachNumber * 2])
     *                   //   new KoconutEntry(eachNumber, eachNumber * 2)
     *               )
     *               .associateTo(
     *                   doubledKeyMap,
     *                   async eachNumber => [eachNumber * 2, eachNumber]
     *               )
     *               .associateTo(
     *                   squaredValueMap,
     *                   eachNumber => new Promise(resolve => {
     *                       resolve([eachNumber, eachNumber * eachNumber])
     *                   })
     *               )
     *               .yield()
     * console.log(doubledValueMap)
     * // ↑ Map { 1 => 2, 2 => 4, 3 => 6, 4 => 8, 5 => 10 }
     * console.log(doubledKeyMap)
     * // ↑ Map { 2 => 1, 4 => 2, 6 => 3, 8 => 4, 10 => 5 }
     * console.log(squaredValueMap)
     * // ↑ Map { 1 => 1, 2 => 4, 3 => 9, 4 => 16, 5 => 25 }
     * console.log(originalData)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     * ```
     */

  }, {
    key: "associateTo",
    value: function associateTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "associateTo", this).call(this, destination, transform, thisArg));
    }
    /**
     * Populates the given ```destination``` map with entries for each element of the
     * given collection, where key is the element itslef and value is provided by ```valueSelector``` function
     * applied to that key.
     * @param destination Iterable destinaion. ```Map``` to be exact.
     * @param valueSelector A callback function that accepts an argument. The method calls the ```valueSelector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```valueSelector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @note This method has different functionality with Kotlin. It'll return the original collection instance.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const doubledValueMap = new Map<number, number>()
     * const stringifiedValueMap = new Map<number, string>()
     * const squaredValueMap = new Map<number, number>()
     * const originalData = await koconutArray
     *                   .associateWithTo(
     *                       doubledValueMap,
     *                       eachNumber => eachNumber * 2
     *                   )
     *                   .associateWithTo(
     *                       stringifiedValueMap,
     *                       async eachNumber => eachNumber.toString()
     *                   )
     *                   .associateWithTo(
     *                       squaredValueMap,
     *                       eachNumber => new Promise(resolve => {
     *                           resolve(eachNumber * eachNumber)
     *                       })
     *                   )
     *                   .yield()
     * console.log(doubledValueMap)
     * // ↑ Map { 1 => 2, 2 => 4, 3 => 6, 4 => 8, 5 => 10 }
     * console.log(stringifiedValueMap)
     * // ↑ Map { 1 => '1', 2 => '2', 3 => '3', 4 => '4', 5 => '5' }
     * console.log(squaredValueMap)
     * // ↑ Map { 1 => 1, 2 => 4, 3 => 9, 4 => 16, 5 => 25 }
     * console.log(originalData)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     * ```
     */

  }, {
    key: "associateWithTo",
    value: function associateWithTo(destination, valueSelector) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "associateWithTo", this).call(this, destination, valueSelector, thisArg));
    }
    /**
     * Appends all elements yielded from results of ```transform``` function being invoked
     * on each element of original collection, to the given ```destination```.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param transform A callback function that accepts an argument. The method calls the ```transform``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of("123", "456")
     *
     * const allNumbersInArray = new Array<number>()
     * await koconutArray
     *       .flatMapTo(
     *           allNumbersInArray,
     *           (eachString) => eachString
     *                   .split('')
     *                   .map(eachCharacter => parseInt(eachCharacter))
     *       )
     *       .process()
     * console.log(allNumbersInArray)
     * // ↑ [ 1, 2, 3, 4, 5, 6 ]
     * ```
     */

  }, {
    key: "flatMapTo",
    value: function flatMapTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "flatMapTo", this).call(this, destination, transform, thisArg));
    }
    /**
     * Appends all elements yielded from results of ```transform``` function being invoked
     * on each element and its index in the original collection, to the given ```destination```.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param transform A callback function that accepts two arguments. The method calls the ```transform``` one time for each index and element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of("123", "456")
     *
     * const allIndexAndNumbersInArray = new Array<number>()
     * await koconutArray
     *       .flatMapIndexedTo(
     *           allIndexAndNumbersInArray,
     *           (eachIndex, eachElement) => [
     *               eachIndex,
     *               ...eachElement
     *                   .split('')
     *                   .map(eachCharacter => parseInt(eachCharacter))
     *           ]
     *       )
     *       .process()
     * console.log(allIndexAndNumbersInArray)
     * // ↑ [ 0, 1, 2, 3, 1, 4, 5, 6 ]
     * ```
     */

  }, {
    key: "flatMapIndexedTo",
    value: function flatMapIndexedTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "flatMapIndexedTo", this).call(this, destination, transform, thisArg));
    }
    /**
     * Applies the given ```transform``` function to each element of the original collection
     * and appends the results to the given ```destination```.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param transform A callback function that accepts an argument. The method calls the ```transform``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const doubledNumbers = new Array<number>()
     * const originalData = await koconutArray
     *                   .mapTo(
     *                       doubledNumbers,
     *                       eachNumber => eachNumber * 2
     *                   )
     *                   .yield()
     * console.log(doubledNumbers)
     * // ↑ [ 2, 4, 6, 8, 10 ]
     * console.log(originalData)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     * ```
     */

  }, {
    key: "mapTo",
    value: function mapTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "mapTo", this).call(this, destination, transform, thisArg));
    }
    /**
     * Applies the given ```transform``` function to each element of the original collection
     * and appends only the results that are not ```null``` nor ```undefined```.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param transform A callback function that accepts an argument. The method calls the ```transform``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const squaredOddNumbers = new Array<number>()
     * const origianlData = await koconutArray
     *                   .mapNotNullTo(
     *                       squaredOddNumbers,
     *                       eachNumber => {
     *                           if(eachNumber % 2 == 1)
     *                               return eachNumber * eachNumber
     *                           // return
     *                           // return null
     *                           // return undefined
     *                           // ↑ You can use any one of
     *                           //   them or just omit it.
     *                       }
     *                   )
     *                   .yield()
     * console.log(squaredOddNumbers)
     * // ↑ [ 1, 9, 25 ]
     * console.log(origianlData)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     * ```
     */

  }, {
    key: "mapNotNullTo",
    value: function mapNotNullTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "mapNotNullTo", this).call(this, destination, transform, thisArg));
    }
    /**
     * Applies the given ```transform``` function to each element and its index in the original
     * collection and appends the results to the given ```destination```.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param transform A callback function that accepts two arguments. The method calls the ```transform``` one time for each index and element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const sumsOfIndexesAndNumbers = new Array<number>()
     * const originalData = await koconutArray
     *                   .mapIndexedTo(
     *                       sumsOfIndexesAndNumbers,
     *                       (eachIndex, eachNumber) => eachIndex + eachNumber
     *                   )
     *                   .yield()
     * console.log(sumsOfIndexesAndNumbers)
     * // ↑ [ 1, 3, 5, 7, 9 ]
     * console.log(originalData)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     * ```
     */

  }, {
    key: "mapIndexedTo",
    value: function mapIndexedTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "mapIndexedTo", this).call(this, destination, transform, thisArg));
    }
    /**
     * Applies the given ```transform``` function to each element and its index in the original
     * collection and appends the results that are not ```null``` nor ```undefined``` to the given ```destination```.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param transform A callback function that accepts two arguments. The method calls the ```transform``` one time for each index and element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const sumsOfIndexesAndNumbersWhereNumberIsEvent = new Array<number>()
     * const prodcutsOfIndexesAndNumbersWhereIndexIsOdd = new Set<number>()
     * const squaredNumbersWhereIndexLessThan3 = new Array<number>()
     * const origianlData = await koconutArray
     *       .mapIndexedNotNullTo(
     *           sumsOfIndexesAndNumbersWhereNumberIsEvent,
     *           (eachIndex, eachNumber) => {
     *               if(eachNumber % 2 == 0)
     *                   return eachIndex + eachNumber
     *               // return
     *               // return null
     *               // return undefined
     *               // ↑ You can use any one of
     *               //   them or just omit it.
     *           }
     *       )
     *       .mapIndexedNotNullTo(
     *           prodcutsOfIndexesAndNumbersWhereIndexIsOdd,
     *           async (eachIndex, eachNumber) => {
     *               if(eachIndex % 2 == 1)
     *                   return eachIndex * eachNumber
     *           }
     *       )
     *       .mapIndexedNotNullTo(
     *           squaredNumbersWhereIndexLessThan3,
     *           (eachIndex, eachNumber) => new Promise<number | null>(resolve => {
     *               if(eachIndex <= 3)
     *                   resolve(eachNumber * eachNumber)
     *               else resolve(null)
     *           })
     *       )
     *           .yield()
     * console.log(sumsOfIndexesAndNumbersWhereNumberIsEvent)
     * // ↑ [ 3, 7 ]
     * console.log(prodcutsOfIndexesAndNumbersWhereIndexIsOdd)
     * // ↑ Set { 2, 12 }
     * console.log(squaredNumbersWhereIndexLessThan3)
     * // ↑ [ 1, 4, 9, 16 ]
     * console.log(origianlData)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     * ```
     */

  }, {
    key: "mapIndexedNotNullTo",
    value: function mapIndexedNotNullTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "mapIndexedNotNullTo", this).call(this, destination, transform, thisArg));
    } // Manipulator

    /**
     * Returns a {@link KoconutArray} containing only distinct elements from this collection.
     * If the type of data is a simple number or string, the method will check equality by using '==' operator, but if it's not,
     * you'd better make your custom class inherits {@link KoconutEquatable}.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const numberKoconutArray = KoconutArray.of(1,1,2,2,3,3)
     *
     * const distinctNumbers = await numberKoconutArray
     *                               .distinct()
     *                               .yield()
     * console.log(distinctNumbers)
     * // ↑ [ 1, 2, 3 ]
     *
     * class SomeInfo {
     *   info : string
     *   constructor(info : string) {
     *       this.info = info
     *   }
     * }
     * const someInfoKoconutArray = KoconutArray.of(
     *   new SomeInfo("A"),
     *   new SomeInfo("A"),
     *   new SomeInfo("B"),
     *   new SomeInfo("B"),
     *   new SomeInfo("C"),
     *   new SomeInfo("C"),
     * )
     * const distinctSomeInfos = await someInfoKoconutArray
     *                           .distinct()
     *                           .yield()
     * console.log(distinctSomeInfos)
     * // ↑ [
     * //        SomeInfo { info: 'A' },
     * //        SomeInfo { info: 'A' },
     * //        SomeInfo { info: 'B' },
     * //        SomeInfo { info: 'B' },
     * //        SomeInfo { info: 'C' },
     * //        SomeInfo { info: 'C' }
     * //   ]
     *
     * class SomeEquatableInfo implements KoconutEquatable {
     *   info : string
     *   constructor(info : string) {
     *       this.info = info
     *   }
     *   equalsTo(other : SomeEquatableInfo) : boolean {
     *       return this.info == other.info
     *   }
     * }
     * const someEquatableInfoKoconutArray = KoconutArray.of(
     *   new SomeEquatableInfo("A"),
     *   new SomeEquatableInfo("A"),
     *   new SomeEquatableInfo("B"),
     *   new SomeEquatableInfo("B"),
     *   new SomeEquatableInfo("C"),
     *   new SomeEquatableInfo("C")
     * )
     * const distinctSomeEquatableInfos = await someEquatableInfoKoconutArray
     *                                   .distinct()
     *                                   .yield()
     * console.log(distinctSomeEquatableInfos)
     * // ↑ [
     * //        SomeEquatableInfo { info: 'A' },
     * //        SomeEquatableInfo { info: 'B' },
     * //        SomeEquatableInfo { info: 'C' }
     * //   ]
     * ```
     */

  }, {
    key: "distinct",
    value: function distinct() {
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "distinct", this).call(this));
    }
    /**
     * Returns a {@link KoconutArray} containing only elements from the given collection having
     * distinct keys returned by the given ```selector``` function.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value 
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const numberKoconutArray = KoconutArray.of(1,1,2,2,3,3)
     *
     * const distinctNumbers = await numberKoconutArray
     *                         .distinctBy(eachNumber => eachNumber)
     *                         .yield()
     * console.log(distinctNumbers)
     * // ↑ [ 1, 2, 3 ]
      * class SomeInfo {
     *     info : string
     *     constructor(info : string) {
     *         this.info = info
     *     }
     * }
     * const someInfoKoconutArray = KoconutArray.of(
     *     new SomeInfo("A"),
     *     new SomeInfo("A"),
     *     new SomeInfo("B"),
     *     new SomeInfo("B"),
     *     new SomeInfo("C"),
     *     new SomeInfo("C")
     * )
     * const distinctSomeInfos = await someInfoKoconutArray
     *                     .distinctBy(eachSomeInfo => eachSomeInfo.info)
     *                     .yield()
     * console.log(distinctSomeInfos)
     * // ↑ [
     * //   SomeInfo { info: 'A' },
     * //   SomeInfo { info: 'B' },
     * //   SomeInfo { info: 'C' }
     * //  ]
     *
     * class SomeEquatableInfo implements KoconutEquatable {
     *     info : string
     *     constructor(info : string) {
     *         this.info = info
     *     }
     *     equalsTo(other : SomeEquatableInfo) : boolean {
     *         return this.info == other.info
     *     }
     * }
     * class SomeEquatableInfoContainer {
     *     someEquatableInfo : SomeEquatableInfo
     *     additionalInfo : string
     *     constructor(someEquatableInfo : SomeEquatableInfo, additionalInfo : string) {
     *         this.someEquatableInfo = someEquatableInfo
     *         this.additionalInfo = additionalInfo
     *     }
     * }
     * const someEquatableInfoContainerKoconutArray = KoconutArray.of(
     *     new SomeEquatableInfoContainer(
     *         new SomeEquatableInfo("A"),
     *         "First"
     *     ),
     *     new SomeEquatableInfoContainer(
     *         new SomeEquatableInfo("A"),
     *         "Second"
     *     ),
     *     new SomeEquatableInfoContainer(
     *         new SomeEquatableInfo("B"),
     *         "First"
     *     ),
     *     new SomeEquatableInfoContainer(
     *         new SomeEquatableInfo("B"),
     *         "Second"
     *     ),
     *     new SomeEquatableInfoContainer(
     *         new SomeEquatableInfo("C"),
     *         "First"
     *     ),
     *     new SomeEquatableInfoContainer(
     *         new SomeEquatableInfo("C"),
     *         "Second"
     *     )
     * )
     * const distinctSomeEquatableInfoContainersByEquatableInfo =
     *                 await someEquatableInfoContainerKoconutArray
     *                 .distinctBy(async eachContainer => eachContainer.someEquatableInfo)
     *                 .yield()
     * console.log(distinctSomeEquatableInfoContainersByEquatableInfo)
     * // ↑ [
     * //   SomeEquatableInfoContainer {
     * //     someEquatableInfo: SomeEquatableInfo { info: 'A' },
     * //     additionalInfo: 'First'
     * //   },
     * //   SomeEquatableInfoContainer {
     * //     someEquatableInfo: SomeEquatableInfo { info: 'B' },
     * //     additionalInfo: 'First'
     * //   },
     * //   SomeEquatableInfoContainer {
     * //     someEquatableInfo: SomeEquatableInfo { info: 'C' },
     * //     additionalInfo: 'First'
     * //   }
     * // ]
     *
     * const distinctSomeEquatableInfoContainersByAdditionalInfo =
     *                 await someEquatableInfoContainerKoconutArray
     *                 .distinctBy(eachContainer => new Promise(resolve => {
     *                     resolve(eachContainer.additionalInfo)
     *                 }))
     *                 .yield()
     * console.log(distinctSomeEquatableInfoContainersByAdditionalInfo)
     * // ↑ [
     * //   SomeEquatableInfoContainer {
     * //     someEquatableInfo: SomeEquatableInfo { info: 'A' },
     * //     additionalInfo: 'First'
     * //   },
     * //   SomeEquatableInfoContainer {
     * //     someEquatableInfo: SomeEquatableInfo { info: 'A' },
     * //     additionalInfo: 'Second'
     * //   }
     * // ]
     * ```
     */

  }, {
    key: "distinctBy",
    value: function distinctBy(selector) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "distinctBy", this).call(this, selector, thisArg));
    }
    /**
     * Returns a {@link KoconutArray} containing all elements except first ```n``` elements.
     * @param n Elements number to except.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const fisrt3ElementsDroppedArray = await koconutArray
     *                                         .drop(3)
     *                                         .yield()
     * console.log(fisrt3ElementsDroppedArray)
     * // ↑ [ 4, 5 ]
     * ```
     */

  }, {
    key: "drop",
    value: function drop(n) {
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "drop", this).call(this, n));
    }
    /**
     * Returns a {@link KoconutArray} containg all elements except last ```n``` elements.
     * @param n Elements number to except.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const last3ElementsDroppedArray = await koconutArray
     *                                         .dropLast(3)
     *                                         .yield()
     * console.log(last3ElementsDroppedArray)
     * // ↑ [ 1, 2 ]
     * ```
     */

  }, {
    key: "dropLast",
    value: function dropLast(n) {
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "dropLast", this).call(this, n));
    }
    /**
     * Returns a {@link KoconutArray} containing all elements except last elements that satisfy the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(
     *     1,2,3,4,5,6,7,8,9,10
     * )
     *
     * const greaterThan5DroppedArray = await koconutArray
     *                 .dropLastWhile(eachNumber => eachNumber > 5)
     *                 .yield()
     * console.log(greaterThan5DroppedArray)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     * ``` 
     */

  }, {
    key: "dropLastWhile",
    value: function dropLastWhile(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "dropLastWhile", this).call(this, predicate, thisArg));
    }
    /**
     * Returns a {@link KoconutArray} containing all elements except first elements that satisfy the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(
     *     1,2,3,4,5,6,7,8,9,10
     * )
     *
     * const lessThan5DroppedArray = await koconutArray
     *                 .dropWhile(eachNumber => eachNumber < 5)
     *                 .yield()
     * console.log(lessThan5DroppedArray)
     * // ↑ [ 5, 6, 7, 8, 9, 10 ]
     * ``` 
     */

  }, {
    key: "dropWhile",
    value: function dropWhile(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "dropWhile", this).call(this, predicate, thisArg));
    }
    /**
     * Returns a {@link KoconutArray} containing only elements matching the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const evenNumbers = await koconutArray
     *                       .filter(eachNumber => eachNumber % 2 == 0)
     *                       .yield()
     * console.log(evenNumbers)
     * // ↑ [ 2, 4 ]
     * ```
     */

  }, {
    key: "filter",
    value: function filter(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "filter", this).call(this, predicate, thisArg));
    }
    /**
     * Returns a {@link KoconutArray} containing only elements not matching the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const oddNumbers = await koconutArray
     *                       .filterNot(eachNumber => eachNumber % 2 == 0)
     *                       .yield()
     * console.log(oddNumbers)
     * // ↑ [ 1, 3, 5 ]
     * ```
     */

  }, {
    key: "filterNot",
    value: function filterNot(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "filterNot", this).call(this, predicate, thisArg));
    }
    /**
     * Appends all elements matching the given ```predicate``` to the given destination.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const evenNumbers = new Array<number>()
     * const originalData = await koconutArray
     *                       .filterTo(
     *                           evenNumbers,
     *                           eachNumber => eachNumber % 2 == 0
     *                       )
     *                       .yield()
     * console.log(evenNumbers)
     * // ↑ [ 2, 4 ]
     * console.log(originalData)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     * ```
     */

  }, {
    key: "filterTo",
    value: function filterTo(destination, predicate) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "filterTo", this).call(this, destination, predicate, thisArg));
    }
    /**
     * Appends all elements not matching the given ```predicate``` to the given destination.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,3,4,5)
     *
     * const oddNumbers = new Array<number>()
     * const originalData = await koconutArray
     *                       .filterNotTo(
     *                           oddNumbers,
     *                           eachNumber => eachNumber % 2 == 0
     *                       )
     *                       .yield()
     * console.log(oddNumbers)
     * // ↑ [ 1, 3, 5 ]
     * console.log(originalData)
     * // ↑ [ 1, 2, 3, 4, 5 ]
     * ```
     */

  }, {
    key: "filterNotTo",
    value: function filterNotTo(destination, predicate) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "filterNotTo", this).call(this, destination, predicate, thisArg));
    }
    /**
     * Returns a {@link KoconutArray} containing only elements matching the given ```predicate``` with indexes.
     * @param predicate A callback function that accepts two arguments. The method calls the ```predicate``` one time for each index and element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(0,1,2,5,6,7)
     *
     * const numbersEqualToIndex = await koconutArray
     *       .filterIndexed((eachIndex, eachNumber) => eachIndex == eachNumber)
     *       .yield()
     * console.log(numbersEqualToIndex)
     * // ↑ [ 0, 1, 2 ]
     * ```
     */

  }, {
    key: "filterIndexed",
    value: function filterIndexed(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "filterIndexed", this).call(this, predicate, thisArg));
    }
    /**
     * Appends all elements matching the given ```predicate``` with indexes to the given destination.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param predicate A callback function that accepts two arguments. The method calls the ```predicate``` one time for each index and element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(0,1,2,5,6,7)
     *
     * const numbersEqualToIndex = new Array<number>()
     * const origianlData =await koconutArray
     *       .filterIndexedTo(
     *           numbersEqualToIndex,
     *           (eachIndex, eachNumber) => eachIndex == eachNumber
     *       )
     *       .yield()
     * console.log(numbersEqualToIndex)
     * // ↑ [ 0, 1, 2 ]
     * console.log(origianlData)
     * // ↑ [ 0, 1, 2, 5, 6, 7 ]
     * ```
     */

  }, {
    key: "filterIndexedTo",
    value: function filterIndexedTo(destination, predicate) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "filterIndexedTo", this).call(this, destination, predicate, thisArg));
    }
    /**
     * Returns a {@link KoconutArray} containing all elements that are not ```null```.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,null,null)
     *
     * const numbers = await koconutArray
     *               .filterNotNull()
     *               .yield()
     * console.log(numbers)
     * // ↑ [ 1, 2 ]
     * ```
     */

  }, {
    key: "filterNotNull",
    value: function filterNotNull() {
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "filterNotNull", this).call(this));
    }
    /**
     * Appends all elements that are not ```null``` to the given destination.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(1,2,null,null)
     *
     * const numbers = Array<number>()
     * const originalData = await koconutArray
     *                   .filterNotNullTo(numbers)
     *                   .yield()
     * console.log(numbers)
     * // ↑ [ 1, 2 ]
     * console.log(originalData)
     * // ↑ [ 1, 2, null, null ]
     * ```
     */

  }, {
    key: "filterNotNullTo",
    value: function filterNotNullTo(destination) {
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "filterNotNullTo", this).call(this, destination));
    }
    /**
     * Returns a {@link KoconutArray} of all elements sorted according to natural sort order
     * of the value returned by specified ```selector``` function. It could be either a ```number```, ```string```, or custom class
     * that inherits {@link KoconutComparable}.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value 
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const stringKoconutArray = KoconutArray.of("abcd", "ab", "a", "abc")
     *
     * const sortedStringByItsLength = await stringKoconutArray
     *                                   .sortedBy(eachString => eachString.length)
     *                                   .yield()
     * console.log(sortedStringByItsLength)
     * // ↑ [ 'a', 'ab', 'abc', 'abcd' ]
     *
     * class Person implements KoconutComparable {
     *   name : string
     *   age : number
     *   constructor(name : string, age : number) {
     *       this.name = name
     *       this.age = age
     *   }
     *   compareTo(other : Person) : number {
     *       return this.name.length - other.name.length
     *   }
     * }
     * const personKoconutArray = KoconutArray.of(
     *   new Person("Keanu Reeves", 56),
     *   new Person("Robert Downey Jr.", 55),
     *   new Person("Christian Bale", 46)
     * )
     *
     * // You can do it by async function.
     * const sortedPeopleByWhoseAge = await personKoconutArray
     *                                   .sortedBy(async eachPerson => eachPerson.age)
     *                                   .yield()
     * console.log(sortedPeopleByWhoseAge)
     * // ↑ [
     * //        Person { name: 'Christian Bale', age: 46 },
     * //        Person { name: 'Robert Downey Jr.', age: 55 },
     * //        Person { name: 'Keanu Reeves', age: 56 }
     * //   ]
     *
     * // And of course, by returning Promise.
     * const sortedPeopleByWhoseName = await personKoconutArray
     *                                   .sortedBy(eachPerson => new Promise(resolve => {
     *                                       resolve(eachPerson.name)
     *                                   }))
     *                                   .yield()
     * console.log(sortedPeopleByWhoseName)
     * // ↑ [
     * //        Person { name: 'Christian Bale', age: 46 },
     * //        Person { name: 'Keanu Reeves', age: 56 },
     * //        Person { name: 'Robert Downey Jr.', age: 55 }
     * //   ]
     *
     * // The class Person itself implements KoconutComparable.
     * // So, it is a Comparable Type.
     * // If you're using JavaScript you can do something similar as following
     * // by extending KoconutComparable or simply adding method 'compareTo' to your custom class.
     * const sortedPeople = await personKoconutArray
     *                           .sortedBy(eachPerson => eachPerson)
     *                           .yield()
     * console.log(sortedPeople)
     * // ↑ [
     * //        Person { name: 'Keanu Reeves', age: 56 },
     * //        Person { name: 'Christian Bale', age: 46 },
     * //        Person { name: 'Robert Downey Jr.', age: 55 }
     * //   ]
     * ```
     */

  }, {
    key: "sortedBy",
    value: function sortedBy(selector) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "sortedBy", this).call(this, selector, thisArg));
    }
    /**
     * Returns a {@link KoconutArray} of all elements sorted descending according to natural sort order
     * of the value returned by specified ```selector``` function. It could be either a ```number```, ```string```, or custom class
     * that inherits {@link KoconutComparable}.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value 
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const stringKoconutArray = KoconutArray.of("abcd", "ab", "a", "abc")
     *
     * const descSortedStringByItsLength = await stringKoconutArray
     *                                   .sortedByDescending(eachString => eachString.length)
     *                                   .yield()
     * console.log(descSortedStringByItsLength)
     * // ↑ [ 'abcd', 'abc', 'ab', 'a' ]
     *
     * class Person implements KoconutComparable {
     *   name : string
     *   age : number
     *   constructor(name : string, age : number) {
     *       this.name = name
     *       this.age = age
     *   }
     *   compareTo(other : Person) : number {
     *       return this.name.length - other.name.length
     *   }
     * }
     * const personKoconutArray = KoconutArray.of(
     *   new Person("Keanu Reeves", 56),
     *   new Person("Robert Downey Jr.", 55),
     *   new Person("Christian Bale", 46)
     * )
     *
     * // You can do it by async function.
     * const descSortedPeopleByWhoseAge = await personKoconutArray
     *                                   .sortedByDescending(async eachPerson => eachPerson.age)
     *                                   .yield()
     * console.log(descSortedPeopleByWhoseAge)
     * // ↑ [
     * //        Person { name: 'Keanu Reeves', age: 56 },
     * //        Person { name: 'Robert Downey Jr.', age: 55 },
     * //        Person { name: 'Christian Bale', age: 46 }
     * //   ]
     *
     * // And of course, by returning Promise.
     * const descSortedPeopleByWhoseName = await personKoconutArray
     *                                   .sortedByDescending(eachPerson => new Promise(resolve => {
     *                                       resolve(eachPerson.name)
     *                                   }))
     *                                   .yield()
     * console.log(descSortedPeopleByWhoseName)
     * // ↑ [
     * //        Person { name: 'Robert Downey Jr.', age: 55 },
     * //        Person { name: 'Keanu Reeves', age: 56 },
     * //        Person { name: 'Christian Bale', age: 46 }
     * //   ]
     *
     * // The class Person itself implements KoconutComparable.
     * // So, it is a Comparable Type.
     * // If you're using JavaScript you can do something similar as following
     * // by extending KoconutComparable or simply adding method 'compareTo' to your custom class.
     * const descSortedPeople = await personKoconutArray
     *                           .sortedByDescending(eachPerson => eachPerson)
     *                           .yield()
     * console.log(descSortedPeople)
     * // ↑ [
     * //        Person { name: 'Robert Downey Jr.', age: 55 },
     * //        Person { name: 'Christian Bale', age: 46 },
     * //        Person { name: 'Keanu Reeves', age: 56 }
     * //   ]
     * ```
     */

  }, {
    key: "sortedByDescending",
    value: function sortedByDescending(selector) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "sortedByDescending", this).call(this, selector, thisArg));
    }
    /**
     * Returns a {@link KoconutArray} of all elements sorted according to the
     * specified ```comparator```.
     * @param comparator A callback function that accepts two arguements. The method calls the ```comparator``` to compare two selected values.
     * In case the result is larger than 0, front is bigger than rear, and if it's less than 0 judge vice versa.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```comparator```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value 
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(15, 4, 33)
     *
     * const sortedNumbers = await koconutArray
     *                       .sortedWith((front, rear) => front - rear)
     *                       .yield()
     * console.log(sortedNumbers)
     * // ↑ [ 4, 15, 33 ]
     *
     * const descSortedNumbers = await koconutArray
     *                           .sortedWith((front, rear) => rear - front)
     *                           .yield()
     * console.log(descSortedNumbers)
     * // ↑ [ 33, 15, 4 ]
     *
     * const sortedNumbersBy1sDigit = await koconutArray
     *                       .sortedWith((front, rear) => front % 10 - rear % 10)
     *                       .yield()
     * console.log(sortedNumbersBy1sDigit)
     * // ↑ [ 33, 4, 15 ]
     * ```
     */

  }, {
    key: "sortedWith",
    value: function sortedWith(comparator) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "sortedWith", this).call(this, comparator, thisArg));
    }
    /**
     * Returns a {@link KoconutArray} containing first ```n``` elements.
     * @param n Elements number to take.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(
     *     1,2,3,4,5,6,7,8,9,10
     * )
     *
     * const first3ElementsOfArray = await koconutArray
     *                                 .take(3)
     *                                 .yield()
     * console.log(first3ElementsOfArray)
     * // ↑ [ 1, 2, 3 ]
     * ```
     */

  }, {
    key: "take",
    value: function take(n) {
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "take", this).call(this, n));
    }
    /**
     * Returns a {@link KoconutArray} containg last ```n``` elements.
     * @param n Elements number to take.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(
     *     1,2,3,4,5,6,7,8,9,10
     * )
     *
     * const last3ElementsOfArray = await koconutArray
     *                                 .takeLast(3)
     *                                 .yield()
     * console.log(last3ElementsOfArray)
     * // ↑ [ 8, 9, 10 ]
     * ```
     */

  }, {
    key: "takeLast",
    value: function takeLast(n) {
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "takeLast", this).call(this, n));
    }
    /**
     * Returns a {@link KoconutArray} containing last elements satisfying the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(
     *     1,2,3,4,5,6,7,8,9,10
     * )
     *
     * const lastNumbersWhileGreaterThan7 = await koconutArray
     *                     .takeLastWhile(eachNumber => eachNumber >7)
     *                     .yield()
     * console.log(lastNumbersWhileGreaterThan7)
     * // ↑ [ 8, 9, 10 ]
     * ```
     */

  }, {
    key: "takeLastWhile",
    value: function takeLastWhile(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "takeLastWhile", this).call(this, predicate, thisArg));
    }
    /**
     * Returns a {@link KoconutArray} containing first elements satisfying the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutArray = KoconutArray.of(
     *     1,2,3,4,5,6,7,8,9,10
     * )
     *
     * const numbersWhileLessThan5 = await koconutArray
     *                     .takeWhile(eachNumber => eachNumber < 5)
     *                     .yield()
     * console.log(numbersWhileLessThan5)
     * // ↑ [ 1, 2, 3, 4 ] 
     * ```
     */

  }, {
    key: "takeWhile",
    value: function takeWhile(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "takeWhile", this).call(this, predicate, thisArg));
    }
  }, {
    key: "groupByTo",
    value: function groupByTo(destination, keySelector) {
      var valueTransform = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var keySelectorThisArg = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      var valueTransformThisArg = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "groupByTo", this).call(this, destination, keySelector, valueTransform, keySelectorThisArg, valueTransformThisArg));
    }
  }, {
    key: "minus",
    value: function minus(elements) {
      if (typeof elements[Symbol.iterator] === 'function') return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "minus", this).call(this, elements));else return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "minus", this).call(this, elements));
    }
  }, {
    key: "minusElement",
    value: function minusElement(element) {
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "minusElement", this).call(this, element));
    }
  }, {
    key: "plus",
    value: function plus(elements) {
      if (typeof elements[Symbol.iterator] === 'function') return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "plus", this).call(this, elements));else return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "plus", this).call(this, elements));
    }
  }, {
    key: "plusElement",
    value: function plusElement(element) {
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "plusElement", this).call(this, element));
    }
  }, {
    key: "reversed",
    value: function reversed() {
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "reversed", this).call(this));
    }
  }, {
    key: "shuffled",
    value: function shuffled() {
      return KoconutArray.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutArray.prototype), "shuffled", this).call(this));
    }
  }], [{
    key: "from",
    value: function from() {
      var source = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      return new KoconutArray(source == null ? null : Array.from(source));
    }
    /**
     * Creates a new instance from variable number of arguments.
     * @param data A set of elements to include in the new {@link KoconutArray} object.
     * 
     * @category Creator
     * 
     * @since 1.0.11
     * 
     * @example
     * ```typescript
     * const koconutNumbers = KoconutArray.of(1,2,3,4,5)
     * // ↑ This is a Koconut number array consists of 1 to 5.
     * 
     * const emptyNumberArray = KoconutArray.of<number>()
     * // ↑ This is an empty Koconut number array.
     * ```
     */

  }, {
    key: "of",
    value: function of() {
      for (var _len = arguments.length, data = new Array(_len), _key = 0; _key < _len; _key++) {
        data[_key] = arguments[_key];
      }

      return new KoconutArray(data);
    }
    /**
     * Creates a new instance with given ```count``` as number of values. ```count``` cannot be negative number.
     * Each value is provided from ```generator``` with given ordered index. 
     * @param count Number of values.
     * @param generator A callback function that accepts an argument. The method calls the ```action``` one time for each ordered index.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```generator```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @throws {@link KoconutInvalidArgumentException}
     * -- When ```count``` is less than 0.
     * 
     * @since 1.0.14
     * 
     * @category Creator
     * 
     * @example
     * ```typescript
     * const evenNumberArray = await KoconutArray.generate(5, i => i*2)
     *                                                        .yield()
     * console.log(evenNumberArray)
     * // ↑ [ 0, 2, 4, 6, 8 ]
     * ```
     */

  }, {
    key: "generate",
    value: function generate(count, generator) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      if (count < 0) throw new _module.KoconutInvalidArgumentException("Count must be larger than 0. Given value : ".concat(count));
      generator = generator.bind(thisArg);
      var koconutToReturn = new KoconutArray();
      koconutToReturn.setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        var processedArray, eachIndex;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                processedArray = new Array();
                eachIndex = 0;

              case 2:
                if (!(eachIndex < count)) {
                  _context2.next = 11;
                  break;
                }

                _context2.t0 = processedArray;
                _context2.next = 6;
                return generator(eachIndex);

              case 6:
                _context2.t1 = _context2.sent;

                _context2.t0.push.call(_context2.t0, _context2.t1);

              case 8:
                eachIndex++;
                _context2.next = 2;
                break;

              case 11:
                return _context2.abrupt("return", processedArray);

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      })));
      return koconutToReturn;
    }
  }]);
  return KoconutArray;
}(_module.KoconutCollection);

exports.KoconutArray = KoconutArray;