"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.KoconutSet = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _module = require("../../../../module.internal");

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

"use strict";

var KoconutSet = /*#__PURE__*/function (_KoconutCollection) {
  (0, _inherits2["default"])(KoconutSet, _KoconutCollection);

  var _super = _createSuper(KoconutSet);

  (0, _createClass2["default"])(KoconutSet, null, [{
    key: "fromCollection",
    // Private
    value: function fromCollection(collection) {
      var koconutToReturn = new KoconutSet(collection['data']);
      koconutToReturn.processor = collection['processor'];
      koconutToReturn.prevYieldable = collection['prevYieldable'];
      return koconutToReturn;
    } // Koconut Primitive

    /**
     * Creates a new instance from ```iterable``` object.
     * @param set An array-like ```iterable``` object to convert to a {@link KoconutSet}.
     * 
     * @since 1.0.10
     * 
     * @example
     * ```typescript
     * const numbers = Array.of(1,2,3,4,5)
     * const koconutNumbers = new KoconutSet(numbers)
     * // ↑ This is a Koconut number set consists of 1 to 5.
     * 
     * const emptyNumberSet = new KoconutSet<number>()
     * // ↑ This is an empty Koconut number set.
     * ```
     */

  }]);

  function KoconutSet() {
    var _this;

    var set = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
    (0, _classCallCheck2["default"])(this, KoconutSet);
    _this = _super.call(this);
    _this.data = set == null ? new Set() : new Set(set);
    return _this;
  }
  /**
   * Processes all the chained object and returns original {@link KoconutSet} instance.
   * 
   * @category Processor
   * 
   * @since 1.0.15
   * 
   * @example
   * ```typescript
   * const koconutSet = await KoconutSet
   *                     .of(1,2,3,4,5)
   *                     .retrieve()
   * console.log(koconutSet)
   * // ↑ KoconutSet {
   * //   isValidated: true,
   * //   data: Set { 1, 2, 3, 4, 5 },
   * //   combinedDataWrapper: Set { 1, 2, 3, 4, 5 },
   * //   mSize: 5,
   * //   mIndices: [ 0, 1, 2, 3, 4 ]
   * // }
   * ```
   */


  (0, _createClass2["default"])(KoconutSet, [{
    key: "retrieve",
    value: function () {
      var _retrieve = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "retrieve", this).call(this);

              case 2:
                return _context.abrupt("return", this);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function retrieve() {
        return _retrieve.apply(this, arguments);
      }

      return retrieve;
    }() // Koconut Iterable

  }, {
    key: "validate",
    value: function () {
      var _validate = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(data) {
        var _index, keys, _iterator, _step, eachDatum, _this$data, isConflict, _iterator2, _step2, eachPrevEquatablekDatum, equalityResult;

        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(data != null)) {
                  _context2.next = 53;
                  break;
                }

                _index = 0;
                keys = new Array();
                _iterator = _createForOfIteratorHelper(data);
                _context2.prev = 4;

                _iterator.s();

              case 6:
                if ((_step = _iterator.n()).done) {
                  _context2.next = 44;
                  break;
                }

                eachDatum = _step.value;

                if (!_module.KoconutTypeChecker.checkIsEquatable(eachDatum)) {
                  _context2.next = 40;
                  break;
                }

                isConflict = false;
                _iterator2 = _createForOfIteratorHelper(keys);
                _context2.prev = 11;

                _iterator2.s();

              case 13:
                if ((_step2 = _iterator2.n()).done) {
                  _context2.next = 29;
                  break;
                }

                eachPrevEquatablekDatum = _step2.value;
                equalityResult = eachDatum.equalsTo(eachPrevEquatablekDatum);
                _context2.t1 = equalityResult instanceof _module.KoconutPrimitive;

                if (!_context2.t1) {
                  _context2.next = 21;
                  break;
                }

                _context2.next = 20;
                return equalityResult["yield"]();

              case 20:
                _context2.t1 = _context2.sent;

              case 21:
                _context2.t0 = _context2.t1;

                if (_context2.t0) {
                  _context2.next = 24;
                  break;
                }

                _context2.t0 = !(equalityResult instanceof _module.KoconutPrimitive) && equalityResult;

              case 24:
                if (!_context2.t0) {
                  _context2.next = 27;
                  break;
                }

                isConflict = true;
                return _context2.abrupt("break", 29);

              case 27:
                _context2.next = 13;
                break;

              case 29:
                _context2.next = 34;
                break;

              case 31:
                _context2.prev = 31;
                _context2.t2 = _context2["catch"](11);

                _iterator2.e(_context2.t2);

              case 34:
                _context2.prev = 34;

                _iterator2.f();

                return _context2.finish(34);

              case 37:
                if (!isConflict) {
                  this.mSize++;
                  this.mIndices.push(_index++);
                  keys.push(eachDatum);
                } else (_this$data = this.data) === null || _this$data === void 0 ? void 0 : _this$data["delete"](eachDatum);

                _context2.next = 42;
                break;

              case 40:
                this.mSize++;
                this.mIndices.push(_index++);

              case 42:
                _context2.next = 6;
                break;

              case 44:
                _context2.next = 49;
                break;

              case 46:
                _context2.prev = 46;
                _context2.t3 = _context2["catch"](4);

                _iterator.e(_context2.t3);

              case 49:
                _context2.prev = 49;

                _iterator.f();

                return _context2.finish(49);

              case 52:
                this.combinedDataWrapper = data;

              case 53:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[4, 46, 49, 52], [11, 31, 34, 37]]);
      }));

      function validate(_x) {
        return _validate.apply(this, arguments);
      }

      return validate;
    }() // Creator

    /**
     * Creates a new instance from ```iterable``` object.
     * @param source An array-like ```iterable``` object to convert to a {@link KoconutSet}.
     * 
     * @category Creator
     * 
     * @since 1.0.11
     * 
     * @example
     * ```typescript
     * const numbers = Array.of(1,2,3,4,5)
     * const koconutNumbers = KoconutSet.from(numbers)
     * // ↑ This is a Koconut number set consists of 1 to 5.
     * 
     * const emptyNumberSet = KoconutSet.from<number>()
     * // ↑ This is an empty Koconut number set.
     * ```
     */

  }, {
    key: "onEach",
    // Iterator

    /**
     * Perfroms the given ```action``` on each element and returns the original collection itself afterwards.
     * When you want to stop iteration in the meantime ```return``` ```false``` or {@link KoconutLoopSignal.BREAK}.
     * @param action A callback function that accepts an argument. The method calls the ```action``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```action```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Iterator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const set = await koconutSet
     *                   .onEach(console.log)
     *                   // ↑ 1
     *                   //   2
     *                   //   3
     *                   //   4
     *                   //   5
     *                   .onEach(async eachNumber => {
     *                       if(eachNumber >= 3) return KoconutLoopSignal.BREAK
     *                       console.log(eachNumber)
     *                   })
     *                   // ↑ 1
     *                   //   2
     *                   .onEach(eachNumber => new Promise(resolve => {
     *                       if(eachNumber == 2) resolve(false)
     *                       else {
     *                           console.log(eachNumber)
     *                           resolve()
     *                       }
     *                   }))
     *                   // ↑ 1
     *                   .yield()
     * console.log(set)
     * // ↑ Set { 1, 2, 3, 4, 5 }
     * ```
     */
    value: function onEach(action) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "onEach", this).call(this, action, thisArg));
    }
    /**
     * Performs the given ```action``` on each element, providing sequential index with the element, and returns the collection itself afterwards.
     * When you want to stop iteration in the meantime ```return``` ```false``` or {@link KoconutLoopSignal.BREAK}.
     * @param action A callback function that accepts two arguments. The method calls the ```action``` one time for each index and element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```action```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Iterator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const set = await koconutSet
     *                 .onEachIndexed(console.log)
     *                 // ↑ 0 1
     *                 //   1 2
     *                 //   2 3
     *                 //   3 4
     *                 //   4 5
     *                 .onEachIndexed(async (eachIndex, eachNumber) => {
     *                     if(eachIndex >= 2) return KoconutLoopSignal.BREAK
     *                     console.log(eachNumber)
     *                 })
     *                 // ↑ 1
     *                 //   2
     *                 .onEachIndexed((eachIndex, eachNumber) => new Promise(resolve => {
     *                     if(eachIndex == 2) resolve(false)
     *                     else {
     *                         console.log(eachNumber)
     *                         resolve()
     *                     }
     *                 }))
     *                 // ↑ 1
     *                 //   2
     *                 .yield()
     * console.log(set)
     * // ↑ Set { 1, 2, 3, 4, 5 }
     * ```
     */

  }, {
    key: "onEachIndexed",
    value: function onEachIndexed(action) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "onEachIndexed", this).call(this, action, thisArg));
    } // Transformer

    /**
     * Populates the given ```destination``` map with entries, where ```key``` is provided by
     * ```keySelector``` function applied to each element.
     * ```valueTransform``` callback function is optional. If it's omitted, each value of entry
     * is same as the original data. Otherwise, the value is provided by the ```valueTransform``` function
     * applied to elements of the given collcetion.
     * @param destination Iterable destinaion. ```Map``` to be exact.
     * @param keySelector A callback function that accepts an argument. The method calls the ```keySelector``` one time for each element in object.
     * @param valueTransform A callback function that accepts an argument. The method calls the ```valueTransform``` one time for each element in object it it's not omitted.
     * @param keySelectorThisArg An object to which the ```this``` keyword can refer in the ```keySelector```. If ```keySelectorThisArg``` is omitted, ```null``` is used as the ```this``` value.
     * @param valueTransformThisArg An object to which the ```this``` keyword can refer in the ```valueTransform```. If ```valueTransformThisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @note This method has different functionality with Kotlin. It'll return the original collection instance.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const doubledKeyMap = new Map<number, number>()
     * const stringKeyDoubledValueMap = new Map<string ,number>()
     * const doubledKeySquaredValueMap = new Map<number, number>()
     * const originalData = await koconutSet
     *           .associateByTo(
     *               doubledKeyMap,
     *               eachNumber => eachNumber * 2
     *           )
     *           .associateByTo(
     *               stringKeyDoubledValueMap,
     *               async eachNumber => eachNumber.toString(),
     *               async eachNumber => eachNumber * 2
     *           )
     *           .associateByTo(
     *               doubledKeySquaredValueMap,
     *               eachNumber => new Promise(resolve => {
     *                   resolve(eachNumber * 2)
     *               }),
     *               eachNumber => new Promise(resolve => {
     *                   resolve(eachNumber * eachNumber)
     *               })
     *           )
     *           .yield()
     * console.log(doubledKeyMap)
     * // ↑ Map { 2 => 1, 4 => 2, 6 => 3, 8 => 4, 10 => 5 }
     * console.log(stringKeyDoubledValueMap)
     * // ↑ Map { '1' => 2, '2' => 4, '3' => 6, '4' => 8, '5' => 10 }
     * console.log(doubledKeySquaredValueMap)
     * // ↑ Map { 2 => 1, 4 => 4, 6 => 9, 8 => 16, 10 => 25 }
     * console.log(originalData)
     * // ↑ Set { 1, 2, 3, 4, 5 }
     * ```
     */

  }, {
    key: "associateByTo",
    value: function associateByTo(destination, keySelector) {
      var valueTransform = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var keySelectorThisArg = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      var valueTransformThisArg = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "associateByTo", this).call(this, destination, keySelector, valueTransform, keySelectorThisArg, valueTransformThisArg));
    }
    /**
     * Populates the given ```destination``` map with entries, provided by ```transform``` function
     * applied to elements of the given collection
     * @param destination Iterable destinaion. ```Map``` to be exact.
     * @param transform A callback function that accepts an argument. The method calls the ```transform``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @note This method has different functionality with Kotlin. It'll return the original collection instance.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutArray.of(1,2,3,4,5)
     *
     * const doubledValueMap = new Map<number, number>()
     * const doubledKeyMap = new Map<number, number>()
     * const squaredValueMap = new Map<number, number>()
     * const originalData = await koconutSet
     *               .associateTo(
     *                   doubledValueMap,
     *                   eachNumber => [eachNumber, eachNumber * 2]
     *                   // ↑ Also can be
     *                   //   new Pair(eachNumber, eachNumber * 2)
     *                   //   Pair.from([eachNumber, eachNumber * 2])
     *                   //   new KoconutPair(eachNumber, eachNumber * 2)
     *                   //   new Entry(eachNumber, eachNumber * 2)
     *                   //   Entry.from([eachNumber, eachNumber * 2])
     *                   //   new KoconutEntry(eachNumber, eachNumber * 2)
     *               )
     *               .associateTo(
     *                   doubledKeyMap,
     *                   async eachNumber => [eachNumber * 2, eachNumber]
     *               )
     *               .associateTo(
     *                   squaredValueMap,
     *                   eachNumber => new Promise(resolve => {
     *                       resolve([eachNumber, eachNumber * eachNumber])
     *                   })
     *               )
     *               .yield()
     * console.log(doubledValueMap)
     * // ↑ Map { 1 => 2, 2 => 4, 3 => 6, 4 => 8, 5 => 10 }
     * console.log(doubledKeyMap)
     * // ↑ Map { 2 => 1, 4 => 2, 6 => 3, 8 => 4, 10 => 5 }
     * console.log(squaredValueMap)
     * // ↑ Map { 1 => 1, 2 => 4, 3 => 9, 4 => 16, 5 => 25 }
     * console.log(originalData)
     * // ↑ Set { 1, 2, 3, 4, 5 }
     * ```
     */

  }, {
    key: "associateTo",
    value: function associateTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "associateTo", this).call(this, destination, transform, thisArg));
    }
    /**
     * Populates the given ```destination``` map with entries for each element of the
     * given collection, where key is the element itslef and value is provided by ```valueSelector``` function
     * applied to that key.
     * @param destination Iterable destinaion. ```Map``` to be exact.
     * @param valueSelector A callback function that accepts an argument. The method calls the ```valueSelector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```valueSelector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @note This method has different functionality with Kotlin. It'll return the original collection instance.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const doubledValueMap = new Map<number, number>()
     * const stringifiedValueMap = new Map<number, string>()
     * const squaredValueMap = new Map<number, number>()
     * const originalData = await koconutSet
     *                   .associateWithTo(
     *                       doubledValueMap,
     *                       eachNumber => eachNumber * 2
     *                   )
     *                   .associateWithTo(
     *                       stringifiedValueMap,
     *                       async eachNumber => eachNumber.toString()
     *                   )
     *                   .associateWithTo(
     *                       squaredValueMap,
     *                       eachNumber => new Promise(resolve => {
     *                           resolve(eachNumber * eachNumber)
     *                       })
     *                   )
     *                   .yield()
     * console.log(doubledValueMap)
     * // ↑ Map { 1 => 2, 2 => 4, 3 => 6, 4 => 8, 5 => 10 }
     * console.log(stringifiedValueMap)
     * // ↑ Map { 1 => '1', 2 => '2', 3 => '3', 4 => '4', 5 => '5' }
     * console.log(squaredValueMap)
     * // ↑ Map { 1 => 1, 2 => 4, 3 => 9, 4 => 16, 5 => 25 }
     * console.log(originalData)
     * // ↑ Set { 1, 2, 3, 4, 5 }
     * ```
     */

  }, {
    key: "associateWithTo",
    value: function associateWithTo(destination, valueSelector) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "associateWithTo", this).call(this, destination, valueSelector, thisArg));
    }
    /**
     * Appends all elements yielded from results of ```transform``` function being invoked
     * on each element of original collection, to the given ```destination```.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param transform A callback function that accepts an argument. The method calls the ```transform``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of("123", "456")
     *
     * const allNumbersInSet = new Array<number>()
     * await koconutSet
     *       .flatMapTo(
     *           allNumbersInSet,
     *           (eachString) => eachString
     *                   .split('')
     *                   .map(eachCharacter => parseInt(eachCharacter))
     *       )
     *       .process()
     * console.log(allNumbersInSet)
     * // ↑ [ 1, 2, 3, 4, 5, 6 ]
     * ```
     */

  }, {
    key: "flatMapTo",
    value: function flatMapTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "flatMapTo", this).call(this, destination, transform, thisArg));
    }
    /**
     * Appends all elements yielded from results of ```transform``` function being invoked
     * on each element and its index in the original collection, to the given ```destination```.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param transform A callback function that accepts two arguments. The method calls the ```transform``` one time for each index and element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of("123", "456")
     *
     * const allIndexAndNumbersInSet= new Array<number>()
     * await koconutSet
     *       .flatMapIndexedTo(
     *           allIndexAndNumbersInSet,
     *           (eachIndex, eachElement) => [
     *               eachIndex,
     *               ...eachElement
     *                   .split('')
     *                   .map(eachCharacter => parseInt(eachCharacter))
     *           ]
     *       )
     *       .process()
     * console.log(allIndexAndNumbersInSet)
     * // ↑ [ 0, 1, 2, 3, 1, 4, 5, 6 ]
     * ```
     */

  }, {
    key: "flatMapIndexedTo",
    value: function flatMapIndexedTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "flatMapIndexedTo", this).call(this, destination, transform, thisArg));
    }
    /**
     * Applies the given ```transform``` function to each element of the original collection
     * and appends the results to the given ```destination```.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param transform A callback function that accepts an argument. The method calls the ```transform``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const doubledNumbers = new Array<number>()
     * const originalData = await koconutSet
     *                   .mapTo(
     *                       doubledNumbers,
     *                       eachNumber => eachNumber * 2
     *                   )
     *                   .yield()
     * console.log(doubledNumbers)
     * // ↑ [ 2, 4, 6, 8, 10 ]
     * console.log(originalData)
     * // ↑ Set { 1, 2, 3, 4, 5 }
     * ```
     */

  }, {
    key: "mapTo",
    value: function mapTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "mapTo", this).call(this, destination, transform, thisArg));
    }
    /**
     * Applies the given ```transform``` function to each element of the original collection
     * and appends only the results that are not ```null``` nor ```undefined```.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param transform A callback function that accepts an argument. The method calls the ```transform``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of("1", "12", "34", "5")
     *
     * const twoDigitsNumbers = Array<number>()
     * const originalData = await koconutSet
     *                       .mapNotNullTo(
     *                           twoDigitsNumbers,
     *                           eachString => {
     *                               if(eachString.length == 2)
     *                                   return parseInt(eachString)
     *                               // return
     *                               // return null
     *                               // return undefined
     *                               // ↑ You can use any one of
     *                               //   them or just omit it.
     *                           }
     *                       )
     *                       .yield()
     * console.log(twoDigitsNumbers)
    // ↑ [ 12, 34 ]
    console.log(originalData)
    // ↑ Set { '1', '12', '34', '5' }
     * ```
     */

  }, {
    key: "mapNotNullTo",
    value: function mapNotNullTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "mapNotNullTo", this).call(this, destination, transform, thisArg));
    }
    /**
     * Applies the given ```transform``` function to each element and its index in the original
     * collection and appends the results to the given ```destination```.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param transform A callback function that accepts two arguments. The method calls the ```transform``` one time for each index and element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const sumsOfIndexesAndNumbers = new Array<number>()
     * const originalData = await koconutSet
     *                   .mapIndexedTo(
     *                       sumsOfIndexesAndNumbers,
     *                       (eachIndex, eachNumber) => eachIndex + eachNumber
     *                   )
     *                   .yield()
     * console.log(sumsOfIndexesAndNumbers)
     * // ↑ [ 1, 3, 5, 7, 9 ]
     * console.log(originalData)
     * // ↑ Set { 1, 2, 3, 4, 5 }
     * ```
     */

  }, {
    key: "mapIndexedTo",
    value: function mapIndexedTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "mapIndexedTo", this).call(this, destination, transform, thisArg));
    }
    /**
     * Applies the given ```transform``` function to each element and its index in the original
     * collection and appends the results that are not ```null``` nor ```undefined``` to the given ```destination```.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param transform A callback function that accepts two arguments. The method calls the ```transform``` one time for each index and element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```transform```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Transformer
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const sumsOfIndexesAndNumbersWhereNumberIsEvent = new Array<number>()
     * const prodcutsOfIndexesAndNumbersWhereIndexIsOdd = new Set<number>()
     * const squaredNumbersWhereIndexLessThan3 = new Array<number>()
     * const origianlData = await koconutSet
     *       .mapIndexedNotNullTo(
     *           sumsOfIndexesAndNumbersWhereNumberIsEvent,
     *           (eachIndex, eachNumber) => {
     *               if(eachNumber % 2 == 0)
     *                   return eachIndex + eachNumber
     *               // return
     *               // return null
     *               // return undefined
     *               // ↑ You can use any one of
     *               //   them or just omit it.
     *           }
     *       )
     *       .mapIndexedNotNullTo(
     *           prodcutsOfIndexesAndNumbersWhereIndexIsOdd,
     *           async (eachIndex, eachNumber) => {
     *               if(eachIndex % 2 == 1)
     *                   return eachIndex * eachNumber
     *           }
     *       )
     *       .mapIndexedNotNullTo(
     *           squaredNumbersWhereIndexLessThan3,
     *           (eachIndex, eachNumber) => new Promise<number | null>(resolve => {
     *               if(eachIndex <= 3)
     *                   resolve(eachNumber * eachNumber)
     *               else resolve(null)
     *           })
     *       )
     *           .yield()
     * console.log(sumsOfIndexesAndNumbersWhereNumberIsEvent)
     * // ↑ [ 3, 7 ]
     * console.log(prodcutsOfIndexesAndNumbersWhereIndexIsOdd)
     * // ↑ Set { 2, 12 }
     * console.log(squaredNumbersWhereIndexLessThan3)
     * // ↑ [ 1, 4, 9, 16 ]
     * console.log(origianlData)
     * // ↑ Set { 1, 2, 3, 4, 5 }
     * ```
     */

  }, {
    key: "mapIndexedNotNullTo",
    value: function mapIndexedNotNullTo(destination, transform) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "mapIndexedNotNullTo", this).call(this, destination, transform, thisArg));
    } // Manipulator

    /**
     * Returns a {@link KoconutSet} containing only distinct elements from this collection.
     * If the type of data is a simple number or string, the method will check equality by using '==' operator, but if it's not,
     * you'd better make your custom class inherits {@link KoconutEquatable}.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const numberKoconutSet = KoconutSet.of(1,1,2,2,3,3)
     *
     * const distinctNumbers = await numberKoconutSet
     *                               .distinct()
     *                               .yield()
     * console.log(distinctNumbers)
     * // ↑ Set { 1, 2, 3 }
     *
     * class SomeInfo {
     *   info : string
     *   constructor(info : string) {
     *       this.info = info
     *   }
     * }
     * const someInfoKoconutSet = KoconutSet.of(
     *   new SomeInfo("A"),
     *   new SomeInfo("A"),
     *   new SomeInfo("B"),
     *   new SomeInfo("B"),
     *   new SomeInfo("C"),
     *   new SomeInfo("C"),
     * )
     * const distinctSomeInfos = await someInfoKoconutSet
     *                           .distinct()
     *                           .yield()
     * console.log(distinctSomeInfos)
     * // ↑ Set {
     * //        SomeInfo { info: 'A' },
     * //        SomeInfo { info: 'A' },
     * //        SomeInfo { info: 'B' },
     * //        SomeInfo { info: 'B' },
     * //        SomeInfo { info: 'C' },
     * //        SomeInfo { info: 'C' }
     * //       }
     *
     * class SomeEquatableInfo implements KoconutEquatable {
     *   info : string
     *   constructor(info : string) {
     *       this.info = info
     *   }
     *   equalsTo(other : SomeEquatableInfo) : boolean {
     *       return this.info == other.info
     *   }
     * }
     * const someEquatableInfoKoconutSet = KoconutSet.of(
     *   new SomeEquatableInfo("A"),
     *   new SomeEquatableInfo("A"),
     *   new SomeEquatableInfo("B"),
     *   new SomeEquatableInfo("B"),
     *   new SomeEquatableInfo("C"),
     *   new SomeEquatableInfo("C")
     * )
     * const distinctSomeEquatableInfos = await someEquatableInfoKoconutSet
     *                                   .distinct()
     *                                   .yield()
     * console.log(distinctSomeEquatableInfos)
     * // ↑ Set {
     * //        SomeEquatableInfo { info: 'A' },
     * //        SomeEquatableInfo { info: 'B' },
     * //        SomeEquatableInfo { info: 'C' }
     * //       }
     * ```
     */

  }, {
    key: "distinct",
    value: function distinct() {
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "distinct", this).call(this));
    }
    /**
     * Returns a {@link KoconutSet} containing only elements from the given collection having
     * distinct keys returned by the given ```selector``` function.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value 
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const numberKoconutSet = KoconutSet.of(1,1,2,2,3,3)
     * 
     * const distinctNumbers = await numberKoconutSet
     *                         .distinctBy(eachNumber => eachNumber)
     *                         .yield()
     * console.log(distinctNumbers)
     * // ↑ Set { 1, 2, 3 }
     *
     * class SomeInfo {
     *     info : string
     *     constructor(info : string) {
     *         this.info = info
     *     }
     * }
     * const someInfoKoconutSet = KoconutSet.of(
     *     new SomeInfo("A"),
     *     new SomeInfo("A"),
     *     new SomeInfo("B"),
     *     new SomeInfo("B"),
     *     new SomeInfo("C"),
     *     new SomeInfo("C")
     * )
     * const distinctSomeInfos = await someInfoKoconutSet
     *                     .distinctBy(eachSomeInfo => eachSomeInfo.info)
     *                     .yield()
     * console.log(distinctSomeInfos)
     * // ↑ Set {
     * //        SomeInfo { info: 'A' },
     * //        SomeInfo { info: 'B' },
     * //        SomeInfo { info: 'C' }
     * //       }
     *
     * class SomeEquatableInfo implements KoconutEquatable {
     *     info : string
     *     constructor(info : string) {
     *         this.info = info
     *     }
     *     equalsTo(other : SomeEquatableInfo) : boolean {
     *         return this.info == other.info
     *     }
     * }
     * class SomeEquatableInfoContainer {
     *     someEquatableInfo : SomeEquatableInfo
     *     additionalInfo : string
     *     constructor(someEquatableInfo : SomeEquatableInfo, additionalInfo : string) {
     *         this.someEquatableInfo = someEquatableInfo
     *         this.additionalInfo = additionalInfo
     *     }
     * }
     * const someEquatableInfoContainerKoconutSet = KoconutSet.of(
     *     new SomeEquatableInfoContainer(
     *         new SomeEquatableInfo("A"),
     *         "First"
     *     ),
     *     new SomeEquatableInfoContainer(
     *         new SomeEquatableInfo("A"),
     *         "Second"
     *     ),
     *     new SomeEquatableInfoContainer(
     *         new SomeEquatableInfo("B"),
     *         "First"
     *     ),
     *     new SomeEquatableInfoContainer(
     *         new SomeEquatableInfo("B"),
     *         "Second"
     *     ),
     *     new SomeEquatableInfoContainer(
     *         new SomeEquatableInfo("C"),
     *         "First"
     *     ),
     *     new SomeEquatableInfoContainer(
     *         new SomeEquatableInfo("C"),
     *         "Second"
     *     )
     * )
     * const distinctSomeEquatableInfoContainersByEquatableInfo =
     *                 await someEquatableInfoContainerKoconutSet
     *                 .distinctBy(async eachContainer => eachContainer.someEquatableInfo)
     *                 .yield()
     * console.log(distinctSomeEquatableInfoContainersByEquatableInfo)
     * // ↑ Set {
     * //            SomeEquatableInfoContainer {
     * //                someEquatableInfo: SomeEquatableInfo { info: 'A' },
     * //                additionalInfo: 'First'
     * //            },
     * //            SomeEquatableInfoContainer {
     * //                someEquatableInfo: SomeEquatableInfo { info: 'B' },
     * //                additionalInfo: 'First'
     * //            },
     * //            SomeEquatableInfoContainer {
     * //                someEquatableInfo: SomeEquatableInfo { info: 'C' },
     * //                additionalInfo: 'First'
     * //            }
     * //       }
     *
     * const distinctSomeEquatableInfoContainersByAdditionalInfo =
     *                 await someEquatableInfoContainerKoconutSet
     *                 .distinctBy(eachContainer => new Promise(resolve => {
     *                     resolve(eachContainer.additionalInfo)
     *                 }))
     *                 .yield()
     * console.log(distinctSomeEquatableInfoContainersByAdditionalInfo)
     * // ↑ Set {
     * //            SomeEquatableInfoContainer {
     * //                someEquatableInfo: SomeEquatableInfo { info: 'A' },
     * //                additionalInfo: 'First'
     * //            },
     * //            SomeEquatableInfoContainer {
     * //                someEquatableInfo: SomeEquatableInfo { info: 'A' },
     * //                additionalInfo: 'Second'
     * //            }
     * //       }
     * ```
     */

  }, {
    key: "distinctBy",
    value: function distinctBy(selector) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "distinctBy", this).call(this, selector, thisArg));
    }
    /**
     * Returns a {@link KoconutSet} containing all elements except first ```n``` elements.
     * @param n Elements number to except.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const fisrt3ElementsDroppedSet = await koconutSet
     *                                         .drop(3)
     *                                         .yield()
     * console.log(fisrt3ElementsDroppedSet)
     * // ↑ Set { 4, 5 }
     * ```
     */

  }, {
    key: "drop",
    value: function drop(n) {
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "drop", this).call(this, n));
    }
    /**
     * Returns a {@link KoconutSet} containg all elements except last ```n``` elements.
     * @param n Elements number to except.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const last3ElementsDroppedSet = await koconutSet
     *                                         .dropLast(3)
     *                                         .yield()
     * console.log(last3ElementsDroppedSet)
    // ↑ Set  { 1, 2 }
     * ```
     */

  }, {
    key: "dropLast",
    value: function dropLast(n) {
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "dropLast", this).call(this, n));
    }
    /**
     * Returns a {@link KoconutSet} containing all elements except last elements that satisfy the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(
     *     1,2,3,4,5,6,7,8,9,10
     * )
     *
     * const greaterThan5DroppedSet = await koconutSet
     *                 .dropLastWhile(eachNumber => eachNumber > 5)
     *                 .yield()
     * console.log(greaterThan5DroppedSet)
     * // ↑ Set { 1, 2, 3, 4, 5 }
     * ``` 
     */

  }, {
    key: "dropLastWhile",
    value: function dropLastWhile(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "dropLastWhile", this).call(this, predicate, thisArg));
    }
    /**
     * Returns a {@link KoconutSet} containing all elements except first elements that satisfy the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(
     *     1,2,3,4,5,6,7,8,9,10
     * )
     *
     * const lessThan5DroppedSet = await koconutSet
     *                 .dropWhile(eachNumber => eachNumber < 5)
     *                 .yield()
     * console.log(lessThan5DroppedSet)
     * // ↑ Set { 5, 6, 7, 8, 9, 10 }
     * ``` 
     */

  }, {
    key: "dropWhile",
    value: function dropWhile(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "dropWhile", this).call(this, predicate, thisArg));
    }
    /**
     * Returns a {@link KoconutSet} containing only elements matching the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const evenNumbers = await koconutSet
     *                       .filter(eachNumber => eachNumber % 2 == 0)
     *                       .yield()
     * console.log(evenNumbers)
     * // ↑ Set { 2, 4 }
     * ```
     */

  }, {
    key: "filter",
    value: function filter(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "filter", this).call(this, predicate, thisArg));
    }
    /**
     * Returns a {@link KoconutSet} containing only elements not matching the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const oddNumbers = await koconutSet
     *                       .filterNot(eachNumber => eachNumber % 2 == 0)
     *                       .yield()
     * console.log(oddNumbers)
     * // ↑ Set { 1, 3, 5 }
     * ```
     */

  }, {
    key: "filterNot",
    value: function filterNot(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "filterNot", this).call(this, predicate, thisArg));
    }
    /**
     * Appends all elements matching the given ```predicate``` to the given destination.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const evenNumbers = new Array<number>()
     * const originalData = await koconutSet
     *                       .filterTo(
     *                           evenNumbers,
     *                           eachNumber => eachNumber % 2 == 0
     *                       )
     *                       .yield()
     * console.log(evenNumbers)
     * // ↑ [ 2, 4 ]
     * console.log(originalData)
     * // ↑ Set { 1, 2, 3, 4, 5 }
     * ```
     */

  }, {
    key: "filterTo",
    value: function filterTo(destination, predicate) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "filterTo", this).call(this, destination, predicate, thisArg));
    }
    /**
     * Appends all elements not matching the given ```predicate``` to the given destination.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,3,4,5)
     *
     * const oddNumbers = new Array<number>()
     * const originalData = await koconutSet
     *                       .filterTo(
     *                           oddNumbers,
     *                           eachNumber => eachNumber % 2 == 0
     *                       )
     *                       .yield()
     * console.log(oddNumbers)
     * // ↑ [ 1, 3, 5 ]
     * console.log(originalData)
     * // ↑ Set { 1, 2, 3, 4, 5 }
     * ```
     */

  }, {
    key: "filterNotTo",
    value: function filterNotTo(destination, predicate) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "filterNotTo", this).call(this, destination, predicate, thisArg));
    }
    /**
     * Returns a {@link KoconutSet} containing only elements matching the given ```predicate``` with indexes.
     * @param predicate A callback function that accepts two arguments. The method calls the ```predicate``` one time for each index and element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(0,1,2,5,6,7)
     *
     * const numbersEqualToIndex = await koconutSet
     *       .filterIndexed((eachIndex, eachNumber) => eachIndex == eachNumber)
     *       .yield()
     * console.log(numbersEqualToIndex)
     * // ↑ Set { 0, 1, 2 }
     * ```
     */

  }, {
    key: "filterIndexed",
    value: function filterIndexed(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "filterIndexed", this).call(this, predicate, thisArg));
    }
    /**
     * Appends all elements matching the given ```predicate``` with indexes to the given destination.
     * @param destination Iterable destinaion. ```Array``` or ```Set``` to be exact.
     * @param predicate A callback function that accepts two arguments. The method calls the ```predicate``` one time for each index and element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(0,1,2,5,6,7)
     *
     * const numbersEqualToIndex = new Array<number>()
     * const origianlData =await koconutSet
     *       .filterIndexedTo(
     *           numbersEqualToIndex,
     *           (eachIndex, eachNumber) => eachIndex == eachNumber
     *       )
     *       .yield()
     * console.log(numbersEqualToIndex)
     * // ↑ [ 0, 1, 2 ]
     * console.log(origianlData)
     * // ↑ Set { 0, 1, 2, 5, 6, 7 }
     * ```
     */

  }, {
    key: "filterIndexedTo",
    value: function filterIndexedTo(destination, predicate) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "filterIndexedTo", this).call(this, destination, predicate, thisArg));
    }
    /**
     * Returns a {@link KoconutSet} containing all elements that are not ```null```.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,null,null)
     *
     * const numbers = await koconutSet
     *               .filterNotNull()
     *               .yield()
     * console.log(numbers)
     * // ↑ Set { 1, 2 }
     * ```
     */

  }, {
    key: "filterNotNull",
    value: function filterNotNull() {
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "filterNotNull", this).call(this));
    }
    /**
     * Appends all elements that are not ```null``` to the given destination.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(1,2,null,null)
     *
     * const numbers = Array<number>()
     * const originalData = await koconutSet
     *                   .filterNotNullTo(numbers)
     *                   .yield()
     * console.log(numbers)
     * // ↑ [ 1, 2 ]
     * console.log(originalData)
     * // ↑ Set { 1, 2, null }
     * ```
     */

  }, {
    key: "filterNotNullTo",
    value: function filterNotNullTo(destination) {
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "filterNotNullTo", this).call(this, destination));
    }
    /**
     * Returns a {@link KoconutSet} of all elements sorted according to natural sort order
     * of the value returned by specified ```selector``` function. It could be either a ```number```, ```string```, or custom class
     * that inherits {@link KoconutComparable}.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value 
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const stringKoconutSet = KoconutSet.of("abcd", "ab", "a", "abc")
     *
     * const sortedStringByItsLength = await stringKoconutSet
     *                                   .sortedBy(eachString => eachString.length)
     *                                   .yield()
     * console.log(sortedStringByItsLength)
     * // ↑ Set { 'a', 'ab', 'abc', 'abcd' }
     *
     * class Person implements KoconutComparable {
     *   name : string
     *   age : number
     *   constructor(name : string, age : number) {
     *       this.name = name
     *       this.age = age
     *   }
     *   compareTo(other : Person) : number {
     *       return this.name.length - other.name.length
     *   }
     * }
     * const personKoconutSet = KoconutSet.of(
     *   new Person("Keanu Reeves", 56),
     *   new Person("Robert Downey Jr.", 55),
     *   new Person("Christian Bale", 46)
     * )
     *
     * // You can do it by async function.
     * const sortedPeopleByWhoseAge = await personKoconutSet
     *                                   .sortedBy(async eachPerson => eachPerson.age)
     *                                   .yield()
     * console.log(sortedPeopleByWhoseAge)
     * // ↑ Set {
     * //        Person { name: 'Christian Bale', age: 46 },
     * //        Person { name: 'Robert Downey Jr.', age: 55 },
     * //        Person { name: 'Keanu Reeves', age: 56 }
     * //       }
     *
     * // And of course, by returning Promise.
     * const sortedPeopleByWhoseName = await personKoconutSet
     *                                   .sortedBy(eachPerson => new Promise(resolve => {
     *                                       resolve(eachPerson.name)
     *                                   }))
     *                                   .yield()
     * console.log(sortedPeopleByWhoseName)
     * // ↑ Set {
     * //        Person { name: 'Christian Bale', age: 46 },
     * //        Person { name: 'Keanu Reeves', age: 56 },
     * //        Person { name: 'Robert Downey Jr.', age: 55 }
     * //       }
     *
     * // The class Person itself implements KoconutComparable.
     * // So, it is a Comparable Type.
     * // If you're using JavaScript you can do something similar as following
     * // by extending KoconutComparable or simply adding method 'compareTo' to your custom class.
     * const sortedPeople = await personKoconutSet
     *                           .sortedBy(eachPerson => eachPerson)
     *                           .yield()
     * console.log(sortedPeople)
     * // ↑ Set {
     * //        Person { name: 'Keanu Reeves', age: 56 },
     * //        Person { name: 'Christian Bale', age: 46 },
     * //        Person { name: 'Robert Downey Jr.', age: 55 }
     * //       }
     * ```
     */

  }, {
    key: "sortedBy",
    value: function sortedBy(selector) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "sortedBy", this).call(this, selector, thisArg));
    }
    /**
     * Returns a {@link KoconutSet} of all elements sorted descending according to natural sort order
     * of the value returned by specified ```selector``` function. It could be either a ```number```, ```string```, or custom class
     * that inherits {@link KoconutComparable}.
     * @param selector A callback function that accepts an argument. The method calls the ```selector``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```selector```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value 
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const stringKoconutSet = KoconutSet.of("abcd", "ab", "a", "abc")
     *
     * const descSortedStringByItsLength = await stringKoconutSet
     *                                   .sortedByDescending(eachString => eachString.length)
     *                                   .yield()
     * console.log(descSortedStringByItsLength)
     * // ↑ Set { 'abcd', 'abc', 'ab', 'a' }
     *
     * class Person implements KoconutComparable {
     *   name : string
     *   age : number
     *   constructor(name : string, age : number) {
     *       this.name = name
     *       this.age = age
     *   }
     *   compareTo(other : Person) : number {
     *       return this.name.length - other.name.length
     *   }
     * }
     * const personKoconutSet = KoconutSet.of(
     *   new Person("Keanu Reeves", 56),
     *   new Person("Robert Downey Jr.", 55),
     *   new Person("Christian Bale", 46)
     * )
     *
     * // You can do it by async function.
     * const descSortedPeopleByWhoseAge = await personKoconutSet
     *                                   .sortedByDescending(async eachPerson => eachPerson.age)
     *                                   .yield()
     * console.log(descSortedPeopleByWhoseAge)
     * // ↑ Set {
     * //        Person { name: 'Keanu Reeves', age: 56 },
     * //        Person { name: 'Robert Downey Jr.', age: 55 },
     * //        Person { name: 'Christian Bale', age: 46 }
     * //       }
     *
     * // And of course, by returning Promise.
     * const descSortedPeopleByWhoseName = await personKoconutSet
     *                                   .sortedByDescending(eachPerson => new Promise(resolve => {
     *                                       resolve(eachPerson.name)
     *                                   }))
     *                                   .yield()
     * console.log(descSortedPeopleByWhoseName)
     * // ↑ Set {
     * //        Person { name: 'Robert Downey Jr.', age: 55 },
     * //        Person { name: 'Keanu Reeves', age: 56 },
     * //        Person { name: 'Christian Bale', age: 46 }
     * //       }
     * 
     * // The class Person itself implements KoconutComparable.
     * // So, it is a Comparable Type.
     * // If you're using JavaScript you can do something similar as following
     * // by extending KoconutComparable or simply adding method 'compareTo' to your custom class.
     * const descSortedPeople = await personKoconutSet
     *                           .sortedByDescending(eachPerson => eachPerson)
     *                           .yield()
     * console.log(descSortedPeople)
     * // ↑ Set {
     * //        Person { name: 'Robert Downey Jr.', age: 55 },
     * //        Person { name: 'Christian Bale', age: 46 },
     * //        Person { name: 'Keanu Reeves', age: 56 }
     * //       }
     * ```
     */

  }, {
    key: "sortedByDescending",
    value: function sortedByDescending(selector) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "sortedByDescending", this).call(this, selector, thisArg));
    }
    /**
     * Returns a {@link KoconutSet} of all elements sorted according to the
     * specified ```comparator```.
     * @param comparator A callback function that accepts two arguements. The method calls the ```comparator``` to compare two selected values.
     * In case the result is larger than 0, front is bigger than rear, and if it's less than 0 judge vice versa.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```comparator```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value 
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(15, 4, 33)
     *
     * const sortedNumbers = await koconutSet
     *                       .sortedWith((front, rear) => front - rear)
     *                       .yield()
     * console.log(sortedNumbers)
     * // ↑ Set { 4, 15, 33 }
     *
     * const descSortedNumbers = await koconutSet
     *                           .sortedWith((front, rear) => rear - front)
     *                           .yield()
     * console.log(descSortedNumbers)
     * // ↑ Set { 4, 15, 33 }
     *
     * const sortedNumbersBy1sDigit = await koconutSet
     *                       .sortedWith((front, rear) => front % 10 - rear % 10)
     *                       .yield()
     * console.log(sortedNumbersBy1sDigit)
     * // ↑ Set { 4, 15, 33 }
     * ```
     */

  }, {
    key: "sortedWith",
    value: function sortedWith(comparator) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "sortedWith", this).call(this, comparator, thisArg));
    }
    /**
     * Returns a {@link KoconutSet} containing first ```n``` elements.
     * @param n Elements number to take.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(
     *     1,2,3,4,5,6,7,8,9,10
     * )
     *
     * const first3ElementsOfSet = await koconutSet
     *                                 .take(3)
     *                                 .yield()
     * console.log(first3ElementsOfSet)
     * // ↑ Set { 1, 2, 3 }
     * ```
     */

  }, {
    key: "take",
    value: function take(n) {
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "take", this).call(this, n));
    }
    /**
     * Returns a {@link KoconutSet} containg last ```n``` elements.
     * @param n Elements number to take.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(
     *     1,2,3,4,5,6,7,8,9,10
     * )
     *
     * const last3ElementsOfSet = await koconutSet
     *                                 .takeLast(3)
     *                                 .yield()
     * console.log(last3ElementsOfSet)
     * // ↑ Set { 8, 9, 10 }
     * ```
     */

  }, {
    key: "takeLast",
    value: function takeLast(n) {
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "takeLast", this).call(this, n));
    }
    /**
     * Returns a {@link KoconutSet} containing last elements satisfying the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(
     *     1,2,3,4,5,6,7,8,9,10
     * )
     *
     * const lastNumbersWhileGreaterThan7 = await koconutSet
     *                     .takeLastWhile(eachNumber => eachNumber >7)
     *                     .yield()
     * console.log(lastNumbersWhileGreaterThan7)
     * // ↑ Set { 8, 9, 10 }
     * ```
     */

  }, {
    key: "takeLastWhile",
    value: function takeLastWhile(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "takeLastWhile", this).call(this, predicate, thisArg));
    }
    /**     
     * Returns a {@link KoconutSet} containing first elements satisfying the given ```predicate```.
     * @param predicate A callback function that accepts an argument. The method calls the ```predicate``` one time for each element in object.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```predicate```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @since 1.0.10
     * 
     * @category Manipulator
     * 
     * @example
     * ```typescript
     * const koconutSet = KoconutSet.of(
     *     1,2,3,4,5,6,7,8,9,10
     * )
     *
     * const numbersWhileLessThan5 = await koconutSet
     *                     .takeWhile(eachNumber => eachNumber < 5)
     *                     .yield()
     * console.log(numbersWhileLessThan5)
     * // ↑ Set { 1, 2, 3, 4 }
     * ```
     */

  }, {
    key: "takeWhile",
    value: function takeWhile(predicate) {
      var thisArg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "takeWhile", this).call(this, predicate, thisArg));
    }
  }, {
    key: "groupByTo",
    value: function groupByTo(destination, keySelector) {
      var valueTransform = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var keySelectorThisArg = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      var valueTransformThisArg = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "groupByTo", this).call(this, destination, keySelector, valueTransform, keySelectorThisArg, valueTransformThisArg));
    }
  }, {
    key: "minus",
    value: function minus(elements) {
      if (typeof elements[Symbol.iterator] === 'function') return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "minus", this).call(this, elements));else return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "minus", this).call(this, elements));
    }
  }, {
    key: "minusElement",
    value: function minusElement(element) {
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "minusElement", this).call(this, element));
    }
  }, {
    key: "plus",
    value: function plus(elements) {
      if (typeof elements[Symbol.iterator] === 'function') return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "plus", this).call(this, elements));else return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "plus", this).call(this, elements));
    }
  }, {
    key: "plusElement",
    value: function plusElement(element) {
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "plusElement", this).call(this, element));
    }
  }, {
    key: "reversed",
    value: function reversed() {
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "reversed", this).call(this));
    }
  }, {
    key: "shuffled",
    value: function shuffled() {
      return KoconutSet.fromCollection((0, _get2["default"])((0, _getPrototypeOf2["default"])(KoconutSet.prototype), "shuffled", this).call(this));
    }
  }], [{
    key: "from",
    value: function from() {
      var source = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      return new KoconutSet(new Set(source));
    }
    /**
     * Creates a new instance from variable number of arguments.
     * @param data A set of elements to include in the new {@link KoconutSet} object.
     * 
     * @category Creator
     * 
     * @since 1.0.11
     * 
     * @example
     * ```typescript
     * const koconutNumbers = KoconutSet.of(1,2,3,4,5)
     * // ↑ This is a Koconut number set consists of 1 to 5.
     * 
     * const emptyNumberSet = KoconutSet.of<number>()
     * // ↑ This is an empty Koconut number set.
     * ```
     */

  }, {
    key: "of",
    value: function of() {
      for (var _len = arguments.length, data = new Array(_len), _key = 0; _key < _len; _key++) {
        data[_key] = arguments[_key];
      }

      return new KoconutSet(new Set(data));
    }
    /**
     * Creates a new instance with given ```count``` as number of values. ```count``` cannot be negative number.
     * Each value is provided from ```generator``` with given ordered index. 
     * @param count Number of values.
     * @param generator A callback function that accepts an argument. The method calls the ```action``` one time for each ordered index.
     * @param thisArg An object to which the ```this``` keyword can refer in the ```generator```. If ```thisArg``` is omitted, ```null``` is used as the ```this``` value.
     * 
     * @throws {@link KoconutInvalidArgumentException}
     * -- When ```count``` is less than 0.
     * 
     * @since 1.0.14
     * 
     * @category Creator
     * 
     * @example
     * ```typescript
     * const evenNumberSet = await KoconutSet.generate(5, i => i*2)
     *                                                     .yield()
     * console.log(evenNumberSet)
     * // ↑ Set { 0, 2, 4, 6, 8 }
     * ```
     */

  }, {
    key: "generate",
    value: function generate(count, generator) {
      var thisArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      if (count < 0) throw new _module.KoconutInvalidArgumentException("Count must be larger than 0. Given value : ".concat(count, "."));
      generator = generator.bind(thisArg);
      var koconutToReturn = new KoconutSet();
      koconutToReturn.setProcessor( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
        var processedSet, eachIndex;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                processedSet = new Set();
                eachIndex = 0;

              case 2:
                if (!(eachIndex < count)) {
                  _context3.next = 11;
                  break;
                }

                _context3.t0 = processedSet;
                _context3.next = 6;
                return generator(eachIndex);

              case 6:
                _context3.t1 = _context3.sent;

                _context3.t0.add.call(_context3.t0, _context3.t1);

              case 8:
                eachIndex++;
                _context3.next = 2;
                break;

              case 11:
                return _context3.abrupt("return", processedSet);

              case 12:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      })));
      return koconutToReturn;
    }
  }]);
  return KoconutSet;
}(_module.KoconutCollection);

exports.KoconutSet = KoconutSet;