import { KoconutPrimitive, Entry, Pair, KoconutPair, KoconutEntry, KoconutIterable, KoconutArray, KoconutSet, KoconutBoolean, KoconutLoopSignal, KoconutComparable } from "../../../module.internal";
export declare class KoconutMap<KeyType, ValueType> extends KoconutIterable<[KeyType, ValueType], Entry<KeyType, ValueType>, Map<KeyType, ValueType>, Set<Entry<KeyType, ValueType>>> {
    protected validate(data: Map<KeyType, ValueType> | null): Promise<void>;
    private static fromIterable;
    constructor(map?: Iterable<[KeyType, ValueType] | Entry<KeyType, ValueType> | Pair<KeyType, ValueType>> | null);
    retrieve(): Promise<KoconutMap<KeyType, ValueType>>;
    private mKeys;
    private mValues;
    get entries(): KoconutSet<Entry<KeyType, ValueType>>;
    get keys(): KoconutSet<KeyType>;
    get size(): KoconutPrimitive<number>;
    get values(): KoconutArray<ValueType>;
    static from<KeyType, ValueType>(source?: Iterable<[KeyType, ValueType] | Entry<KeyType, ValueType> | Pair<KeyType, ValueType>> | null): KoconutMap<KeyType, ValueType>;
    static of<KeyType, ValueType>(...data: ([KeyType, ValueType] | Entry<KeyType, ValueType> | Pair<KeyType, ValueType>)[]): KoconutMap<KeyType, ValueType>;
    static generate<KeyType, ValueType>(count: number, generator: (index: number) => [
        KeyType,
        ValueType
    ] | Pair<KeyType, ValueType> | KoconutPair<KeyType, ValueType> | Entry<KeyType, ValueType> | KoconutEntry<KeyType, ValueType> | Promise<[
        KeyType,
        ValueType
    ] | Pair<KeyType, ValueType> | KoconutPair<KeyType, ValueType> | Entry<KeyType, ValueType> | KoconutEntry<KeyType, ValueType>>, thisArg?: any): KoconutMap<KeyType, ValueType>;
    maxBy(selector: (entry: Entry<KeyType, ValueType>) => number | string | KoconutComparable | Promise<number | string | KoconutComparable>, thisArg?: any): KoconutEntry<KeyType, ValueType>;
    maxByOrNull(selector: (entry: Entry<KeyType, ValueType>) => number | string | KoconutComparable | Promise<number | string | KoconutComparable>, thisArg?: any): KoconutEntry<KeyType, ValueType>;
    maxWith(selector: (front: Entry<KeyType, ValueType>, rear: Entry<KeyType, ValueType>) => number | Promise<number>, thisArg?: any): KoconutEntry<KeyType, ValueType>;
    maxWithOrNull(selector: (front: Entry<KeyType, ValueType>, rear: Entry<KeyType, ValueType>) => number | Promise<number>, thisArg?: any): KoconutEntry<KeyType, ValueType>;
    minBy(selector: (entry: Entry<KeyType, ValueType>) => number | string | KoconutComparable | Promise<number | string | KoconutComparable>, thisArg?: any): KoconutEntry<KeyType, ValueType>;
    minByOrNull(selector: (entry: Entry<KeyType, ValueType>) => number | string | KoconutComparable | Promise<number | string | KoconutComparable>, thisArg?: any): KoconutEntry<KeyType, ValueType>;
    minWith(selector: (front: Entry<KeyType, ValueType>, rear: Entry<KeyType, ValueType>) => number | Promise<number>, thisArg?: any): KoconutEntry<KeyType, ValueType>;
    minWithOrNull(selector: (front: Entry<KeyType, ValueType>, rear: Entry<KeyType, ValueType>) => number | Promise<number>, thisArg?: any): KoconutEntry<KeyType, ValueType>;
    contains(key: KeyType): KoconutBoolean;
    containsKey(key: KeyType): KoconutBoolean;
    containsValue(value: ValueType): KoconutBoolean;
    onEach(action: (entry: Entry<KeyType, ValueType>) => boolean | KoconutLoopSignal | void | Promise<boolean | KoconutLoopSignal | void>, thisArg?: any): KoconutMap<KeyType, ValueType>;
    filter(predicate: (entry: Entry<KeyType, ValueType>) => boolean | Promise<boolean>, thisArg?: any): KoconutMap<KeyType, ValueType>;
    filterNot(predicate: (entry: Entry<KeyType, ValueType>) => boolean | Promise<boolean>, thisArg?: any): KoconutMap<KeyType, ValueType>;
    filterTo(destination: Map<KeyType, ValueType>, predicate: (entry: Entry<KeyType, ValueType>) => boolean | Promise<boolean>, thisArg?: any): KoconutMap<KeyType, ValueType>;
    filterNotTo(destination: Map<KeyType, ValueType>, predicate: (entry: Entry<KeyType, ValueType>) => boolean | Promise<boolean>, thisArg?: any): KoconutMap<KeyType, ValueType>;
    filterKeys(predicate: (key: KeyType) => boolean | Promise<boolean>, thisArg?: any): KoconutMap<KeyType, ValueType>;
    filterValues(predicate: (value: ValueType) => boolean | Promise<boolean>, thisArg?: any): KoconutMap<KeyType, ValueType>;
    minus(...keys: KeyType[]): KoconutMap<KeyType, ValueType>;
    plus(...entries: ([
        KeyType,
        ValueType
    ] | Pair<KeyType, ValueType> | KoconutPair<KeyType, ValueType> | Entry<KeyType, ValueType> | KoconutEntry<KeyType, ValueType>)[]): KoconutMap<KeyType, ValueType>;
    get(key: KeyType): KoconutPrimitive<ValueType | null>;
    getOrDefault(key: KeyType, defaultValue: ValueType): KoconutPrimitive<ValueType>;
    getOrElse(key: KeyType, defaultValue: () => ValueType | Promise<ValueType>): KoconutPrimitive<ValueType>;
    getValue(key: KeyType): KoconutPrimitive<ValueType>;
    flatMapTo<ResultDataType>(destination: Array<ResultDataType> | Set<ResultDataType>, transform: (entry: Entry<KeyType, ValueType>) => Iterable<ResultDataType> | Promise<Iterable<ResultDataType>>, thisArg?: any): KoconutMap<KeyType, ValueType>;
    mapTo<ResultDataType>(destination: Array<ResultDataType> | Set<ResultDataType>, transform: (entry: Entry<KeyType, ValueType>) => ResultDataType | Promise<ResultDataType>, thisArg?: any): KoconutMap<KeyType, ValueType>;
    mapNotNullTo<ResultDataType>(destination: Array<ResultDataType> | Set<ResultDataType>, transform: (entry: Entry<KeyType, ValueType>) => ResultDataType | null | Promise<ResultDataType | null>, thisArg?: any): KoconutMap<KeyType, ValueType>;
    mapKeys<ResultDataType>(transform: (entry: Entry<KeyType, ValueType>) => ResultDataType | Promise<ResultDataType>, thisArg?: any): KoconutMap<ResultDataType, ValueType>;
    mapKeysTo<ResultDataType>(destination: Map<ResultDataType, ValueType>, transform: (entry: Entry<KeyType, ValueType>) => ResultDataType | Promise<ResultDataType>, thisArg?: any): KoconutMap<KeyType, ValueType>;
    mapVaues<ResultDataType>(transform: (entry: Entry<KeyType, ValueType>) => ResultDataType | Promise<ResultDataType>, thisArg?: any): KoconutMap<KeyType, ResultDataType>;
    mapValuesTo<ResultDataType>(destination: Map<KeyType, ResultDataType>, transform: (entry: Entry<KeyType, ValueType>) => ResultDataType | Promise<ResultDataType>, thisArg?: any): KoconutMap<KeyType, ValueType>;
}
